<?php
//=======================================
//###################################
// Kayako Infotech Ltd. - SWIFT Framework
//
// Source Copyright 2001-2008 Kayako Infotech Ltd.
// Unauthorized reproduction is not allowed
// License Number: $%LICENSE%$
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//                   www.kayako.com
//###################################
//=======================================

define("SWIFT_AREA", 30);

// KACT 5/pages/302
if (defined("SWIFTCUSTOMPATH"))
{
	chdir(SWIFTCUSTOMPATH);
} else {
	chdir('./../');
}
require_once ("./swift.php");

/**
* ###############################################
* BEGIN IP RESTRICTION CHECK
* ###############################################
*/
if (_is_array($_SWIFT['iprestrict']))
{
	// Seems like we have IPs specified.. by default deny all requests
	$_continue = false;
	foreach ($_SWIFT['iprestrict'] as $key=>$val)
	{
		if (netMatch($val, $_SERVER['REMOTE_ADDR']))
		{
			$_continue = true;
		}
	}

	if (!$_continue)
	{
		trigger_error(sprintf($_SWIFT['language']['iprestrictdenial'], 'admin', $_SERVER['REMOTE_ADDR']), E_USER_ERROR);
		exit;
	}
}
/**
* ###############################################
* END IP RESTRICTION CHECK
* ###############################################
*/


// KACT 5/pages/291
if ($_REQUEST["_ca"] == "login") {
	/*
	* #########################################################
	* Authenticate User, Insert session and redirect else just display login form
	* #########################################################
	*/
	// Remember Password available?

        // KACT 5/pages/294
        // KACT 5/pages/288
        // KACT 5/pages/297
	if (!empty($_POST["cookiepassword"]) && $_POST["password"] == "******")
	{
		// Try to use cookie password
		$staffid = $staffauth->authenticate($_POST["username"], $_POST["cookiepassword"], true, false);
	} else {
		$staffid = $staffauth->authenticate($_POST["username"], $_POST["password"], true);
	}
	// KACT 5/pages/291
	if (!empty($staffid))
	{
                // KACT 5/pages/297
		require_once ("./includes/functions_html.php");

		// Authentication successfull, Generate a sessionid for this user
		$session->insertSession(SESSION_ADMIN, $staffid);

		// We always empty the remember cookie if username differs
		$_cookieusername = $cookie->getSCookie("remusernameadm");
		// KACT 5/pages/294
		if ($_POST["username"] != $_cookieusername && !empty($_cookieusername))
		{
                        // KACT 5/pages/302
			$cookie->emptySCookie("remusernameadm");
			$cookie->emptySCookie("rempasswordadm");
		}

                // KACT 5/pages/294
		if ($_POST["remember"] == 1 && $_POST["password"] != "******")
		{
			$cookie->setSCookie("remusernameadm", $_POST["username"], true);
			$cookie->setSCookie("rempasswordadm", md5($_POST["password"]), true);
                // KACT 5/pages/294
		} else if ($_POST["remember"] == 1 && $_POST["password"] == "******") {
			// Do Nothing
		} else {
                        // KACT 5/pages/302
			$cookie->emptySCookie("remusernameadm");
			$cookie->emptySCookie("rempasswordadm");
		}

		printRedirect($_SWIFT["language"]["redirect_login"], "index.php?_m=core&_a=dashboard", true);
	} else {
                // KACT 5/pages/302
		$cookie->emptySCookie("remusernameadm");
		$cookie->emptySCookie("rempasswordadm");
		$staffauth->displayLoginForm($_SWIFT["errorstr"]);
	}
// KACT 5/pages/291
} else if ($_REQUEST["_ca"] == "logout") {
	$result = $session->logoutSession(SESSION_ADMIN);
        // KACT 5/pages/295
	$staffauth->displayLoginForm(iif($result, $_SWIFT["language"]["loggedout"]));
} else {
	if (!$session->start(SESSION_ADMIN)) {
		/*
		* #########################################################
		* No other action, we always try to start a session
		* #########################################################
		*/
		// Failed to load session
		$staffauth->displayLoginForm($_SWIFT["errorstr"]);
		exit;
	}

	// User logged in, trigger events
	if (!$events->triggerEvent(EVENT_ADMIN))
	{
		require_once ("./includes/functions_html.php");
		printRedirect($_SWIFT["language"]["redirect_dashboard"], "index.php?_m=core&_a=dashboard", true);
	}
}
?>