<?php
//=======================================
//###################################
// Kayako Infotech Ltd. - SWIFT Framework
//
// Source Copyright 2001-2008 Kayako Infotech Ltd.
// Unauthorized reproduction is not allowed
// License Number: $%LICENSE%$
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//                   www.kayako.com
//###################################
//=======================================

if (!defined("INSWIFT")) {
	trigger_error("Unable to process " . htmlentities($_SERVER['PHP_SELF']), E_USER_ERROR);
}

/**
* Initialization function. You can connect to your database etc over here.
*/
function loginShareInit()
{
	global $loginshare;
	$loginshare->moduleloaded = true;
}

/**
* Authorize a user based on email and password
*/
function loginShareAuthorize($username, $password)
{
	global $dbCore, $_SWIFT, $loginshare, $settings;
	$_loginshare = $settings->getSection("loginshare");
	$dbLoginShare = new dbCore($_loginshare["awbshostname"], $_loginshare["awbsdbuser"], $_loginshare["awbsdbpass"], $_loginshare["awbsdbname"], "mysql", false);
	
	$_user = $dbLoginShare->queryFetch("SELECT * FROM `users` WHERE `email` = '". $dbCore->escape($username) ."';");

	if (empty($_user["id"])){
		$_user = $dbLoginShare->queryFetch("SELECT * FROM `users_profiles` WHERE `email` = '". $dbCore->escape($username) ."' and type = '2';");
	}else{
		include(dirname(__FILE__)."/awbsfunctions.php");
		$userpassword = create_encoded_password(md5($password));
		$regpassword = $_user["password"];
	}
		
	if (empty($_user["id"])){
		return false;
	}else if(empty($userpassword)){
		$userpassword = $password;
		$regpassword = $_user["password"];		
	}

	if ($_user["password"] == $userpassword && !empty($_user["password"]))
	{
		$userid = getLoginShareUser(LOGINAPI_AWBS, $_user["id"]);
		if (!$userid)
		{
			// Not registered, Register him
			$userid = insertUser(true, $_user["email"], $regpassword, $_SWIFT["tgroup"]["regusergroupid"], LOGINAPI_AWBS, $_user["id"], $_user["fname"]." ".$_user["lname"], $_SWIFT["tgroup"]["languageid"], 0, false, 1, true, true);
		}

		if (!$userid)
		{
			return false;
		}

		$_swiftuser = $loginshare->loadSWIFTUser($userid);
		if (!$_swiftuser)
		{
			return false;
		}

		$_SWIFT["user"] = $_swiftuser;
		return $_swiftuser["userid"];
	}

	return false;
}

/**
* Return the Unique User ID of the current user
*/
function loginShareUserID()
{
	global $_SWIFT;

	if (empty($_SWIFT["user"]["userid"]))
	{
		return false;
	} else {
		return $_SWIFT["user"]["userid"];
	}
}

/**
* Logout the current user
*/
function loginShareLogout()
{
	global $session, $_SWIFT;

	$session->updateSession($_SWIFT["session"]["sessionid"], 0);

	return true;
}

/**
* Load the user credentials into current workspace. The following variables should be declared for proper working:
* userid - User id that is set in the "users" table
* fullname
* email - Array
* password (MD5 Hashed)
* usergroupid - If this is not set, then it will use the default registered user group for this template group
*/
function loginShareLoadUser()
{
	global $dbCore, $_SWIFT, $loginshare;

	if (empty($_SWIFT["session"]["typeid"]))
	{
		$_SWIFT["user"]["loggedin"] = false;
		return false;
	}

	$_user = $loginshare->loadSWIFTUser($_SWIFT["session"]["typeid"]);
	if (!$_user)
	{
		$_SWIFT["user"]["loggedin"] = false;

		return false;
	}

	$_SWIFT["user"] = $_user;

	return true;
}

/**
* Renders the Login Share Form
*/
function renderLoginShareForm()
{
	global $_SWIFT;

	$forms = array();

	$forms[0]["title"] = $_SWIFT["language"]["hostname"];
	$forms[0]["name"] = "awbshostname";
	$forms[1]["title"] = $_SWIFT["language"]["dbname"];
	$forms[1]["name"] = "awbsdbname";
	$forms[2]["title"] = $_SWIFT["language"]["dbuser"];
	$forms[2]["name"] = "awbsdbuser";
	$forms[3]["title"] = $_SWIFT["language"]["dbpass"];
	$forms[3]["name"] = "awbsdbpass";

	return $forms;

}
?>