<?php
//=======================================
//###################################
// Kayako Infotech Ltd. - SWIFT Framework
//
// Source Copyright 2001-2008 Kayako Infotech Ltd.
// Unauthorized reproduction is not allowed
// License Number: $%LICENSE%$
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//                   www.kayako.com
//###################################
//=======================================

if (!defined("INSWIFT")) {
	trigger_error("Unable to process " . htmlentities($_SERVER['PHP_SELF']), E_USER_ERROR);
}

/**
* Initialization function. You can connect to your database etc over here.
*/
function loginShareInit()
{
	global $loginshare;

	$loginshare->moduleloaded = true;
}

/**
* Authorize a user based on email and password
*/
function loginShareAuthorize($username, $password)
{
	global $dbCore, $_SWIFT, $loginshare, $settings, $locale_db_host, $locale_db_name, $locale_db_login, $locale_db_pass, $this_user;

	if (defined("ISMODERNBILL"))
	{
		$_user = $this_user;

//		$_loginshare = $settings->getSection("loginshare");
//		$dbLoginShare = new dbCore($locale_db_host, $locale_db_login, $locale_db_pass, $locale_db_name, "mysql", false);
	} else {
		$_loginshare = $settings->getSection("loginshare");
		$dbLoginShare = new dbCore($_loginshare["mbhostname"], $_loginshare["mbdbuser"], $_loginshare["mbdbpass"], $_loginshare["mbdbname"], "mysql", false);

		$_user = $dbLoginShare->queryFetch("SELECT * FROM `client_info` WHERE `client_email` = '". $dbCore->escape($username) ."';");
	}

	if (empty($_user["client_id"]))
	{
//		return false;
	}

	if (defined("ISMODERNBILL"))
	{
		$userpassword = $_user["client_password"];
	} else {
		$userpassword = md5($password);
	}

	$regpassword = $_user["client_password"];

	if ($_user["client_password"] == $userpassword && !empty($_user["client_password"]))
	{
		$userid = getLoginShareUser(LOGINAPI_MODERNBILL, $_user["client_id"]);
		if (!$userid)
		{
			// Not registered, Register him
			$userid = insertUser(true, $_user["client_email"], iif(!empty($_user["client_real_pass"]), $_user["client_real_pass"], substr(buildHash(),0,6)), $_SWIFT["tgroup"]["regusergroupid"], LOGINAPI_MODERNBILL, $_user["client_id"], $_user["client_fname"]." ".$_user["client_lname"], $_SWIFT["tgroup"]["languageid"], 0, false, 1, true, true);
		}

		if ($userid)
		{
			$_useremails = array();
			$dbCore->query("SELECT * FROM ". TABLE_PREFIX ."useremails WHERE userid = '". intval($userid) ."';");
			while ($dbCore->nextRecord())
			{
				$_useremails[] = $dbCore->Record["email"];
			}

			// Not in list for this user? Add the email..
			if (!in_array($_user['client_email'], $_useremails))
			{
				// See if the record already exists..and under a different user
				$_newemail = $dbCore->queryFetch("SELECT * FROM ". TABLE_PREFIX ."useremails WHERE email = '". $dbCore->escape($_user['client_email'])."';");
				if (!empty($_newemail['email'])) {
					unset($userid);
				} else {
					$dbCore->query("UPDATE ". TABLE_PREFIX ."useremails SET isprimary = '0' WHERE userid = '". intval($userid) ."'");
					$dbCore->query("INSERT INTO ". TABLE_PREFIX ."useremails (userid, email, isprimary) VALUES ('". intval($userid) ."', '". $dbCore->escape($_user['client_email']) ."', '1');");
				}
			}
		}

		if (!$userid)
		{
			// ======= GET THE USER WITH THE EMAIL AND TAG HIM UNDER MODERNBILL =======
			$_swiftuser = $dbCore->queryFetch("SELECT `userid` FROM `". TABLE_PREFIX ."useremails` WHERE `email` = '". $dbCore->escape($_user["client_email"]) ."' LIMIT 1;");
			if (!empty($_swiftuser["userid"]))
			{
				$dbCore->query("UPDATE `". TABLE_PREFIX ."users` SET `loginapi_moduleid` = '". LOGINAPI_MODERNBILL ."', `loginapi_userid` = '". intval($_user["client_id"]) ."' WHERE `userid` = '". intval($_swiftuser["userid"]) ."';");

				$userid = $_swiftuser["userid"];
			} else {
				return false;
			}
		}

		$_swiftuser = $loginshare->loadSWIFTUser($userid);
		if (!$_swiftuser)
		{
			return false;
		}

		$_SWIFT["user"] = $_swiftuser;

		return $_swiftuser["userid"];
	} else {
		// Failed Authentication, Fall back over to default SupportSuite Login Routine
		$_email = $dbCore->queryFetch("SELECT `userid` FROM `". TABLE_PREFIX ."useremails` WHERE `email` = '". $dbCore->escape($username) ."';");
		if (empty($_email["userid"]))
		{
			return false;
		}

		$_user = $dbCore->queryFetch("SELECT * FROM `". TABLE_PREFIX ."users` WHERE `userid` = '". intval($_email["userid"]) ."';");

		if ($_user["userpassword"] == md5($password) && $_user["enabled"] == 1)
		{
			// Authenticated
			$_SWIFT["user"] = $_user;

			return $_user["userid"];
		} else {
			unset($_SWIFT["user"]);
		}
	}

	return false;
}

/**
* Return the Unique User ID of the current user
*/
function loginShareUserID()
{
	global $_SWIFT;

	if (empty($_SWIFT["user"]["userid"]))
	{
		return false;
	} else {
		return $_SWIFT["user"]["userid"];
	}
}

/**
* Logout the current user
*/
function loginShareLogout()
{
	global $session, $_SWIFT;

	$session->updateSession($_SWIFT["session"]["sessionid"], 0);

	return true;
}

/**
* Load the user credentials into current workspace. The following variables should be declared for proper working:
* userid - User id that is set in the "users" table
* fullname
* email - Array
* password (MD5 Hashed)
* usergroupid - If this is not set, then it will use the default registered user group for this template group
*/
function loginShareLoadUser()
{
	global $dbCore, $_SWIFT, $loginshare;

	if (empty($_SWIFT["session"]["typeid"]))
	{
		$_SWIFT["user"]["loggedin"] = false;
		return false;
	}

	$_user = $loginshare->loadSWIFTUser($_SWIFT["session"]["typeid"]);
	if (!$_user)
	{
		$_SWIFT["user"]["loggedin"] = false;

		return false;
	}

	$_SWIFT["user"] = $_user;

	return true;
}

/**
* Renders the Login Share Form
*/
function renderLoginShareForm()
{
	global $_SWIFT;

	$forms = array();

	$forms[0]["title"] = $_SWIFT["language"]["hostname"];
	$forms[0]["name"] = "mbhostname";
	$forms[1]["title"] = $_SWIFT["language"]["dbname"];
	$forms[1]["name"] = "mbdbname";
	$forms[2]["title"] = $_SWIFT["language"]["dbuser"];
	$forms[2]["name"] = "mbdbuser";
	$forms[3]["title"] = $_SWIFT["language"]["dbpass"];
	$forms[3]["name"] = "mbdbpass";

	return $forms;

}
?>