<?php
//=======================================
//###################################
// Kayako Infotech Ltd. - SWIFT Framework
//
// Source Copyright 2001-2008 Kayako Infotech Ltd.
// Unauthorized reproduction is not allowed
// License Number: $%LICENSE%$
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//                   www.kayako.com
//###################################
//=======================================

if (!defined("INSWIFT")) {
	trigger_error("Unable to process " . htmlentities($_SERVER['PHP_SELF']), E_USER_ERROR);
}

/**
* Initialization function. You can connect to your database etc over here.
*/
function loginShareInit()
{
	global $loginshare;

	$loginshare->moduleloaded = true;
}

/**
* Authorize a user based on email and password
*/
function loginShareAuthorize($username, $password)
{
	global $dbCore, $_SWIFT, $loginshare, $settings, $CONF, $whmcsuser;

	if (!defined("ISWHMCS"))
	{
		return false;

	} else {
		if (empty($whmcsuser["userid"]))
		{
			return false;
		}
	}

	if (!empty($whmcsuser["userid"]) && !empty($whmcsuser["email"]) && defined("ISWHMCS"))
	{
		$userid = getLoginShareUser(LOGINAPI_WHMCSINTEGRATION, $whmcsuser["userid"]);
		if (!$userid)
		{
			// Not registered, Register him
			if (isset($whmcsuser['password']))
			{
				$_password = $whmcsuser['password'];
			} else {
				$_password = substr(buildHash(),0,6);
			}
			$userid = insertUser(true, $whmcsuser["email"], $_password, $_SWIFT["tgroup"]["regusergroupid"], LOGINAPI_WHMCSINTEGRATION, $whmcsuser["userid"], $whmcsuser["firstname"]." ".$whmcsuser["lastname"], $_SWIFT["tgroup"]["languageid"], 0, false, 1, true, false);
		}

		$_useremails = array();
		$dbCore->query("SELECT * FROM ". TABLE_PREFIX ."useremails WHERE userid = '". intval($userid) ."';");
		while ($dbCore->nextRecord())
		{
			$_useremails[] = $dbCore->Record["email"];
		}

		// Not in list for this user? Add the email..
		if (!in_array($whmcsuser["email"], $_useremails))
		{
			// See if the record already exists..and under a different user
			$_newemail = $dbCore->queryFetch("SELECT * FROM ". TABLE_PREFIX ."useremails WHERE email = '". $dbCore->escape($whmcsuser["email"])."';");
			if (!empty($_newemail['email'])) {
				unset($userid);
			} else {
				$dbCore->query("UPDATE ". TABLE_PREFIX ."useremails SET isprimary = '0' WHERE userid = '". intval($userid) ."'");
				$dbCore->query("INSERT INTO ". TABLE_PREFIX ."useremails (userid, email, isprimary) VALUES ('". intval($userid) ."', '". $dbCore->escape($whmcsuser["email"]) ."', '1');");
			}
		}

		if (!$userid)
		{
			// ======= GET THE USER WITH THE EMAIL AND TAG HIM UNDER MODERNBILL =======
			$_swiftuser = $dbCore->queryFetch("SELECT `userid` FROM `". TABLE_PREFIX ."useremails` WHERE `email` = '". $dbCore->escape($whmcsuser["email"]) ."' LIMIT 1;");
			if (!empty($_swiftuser["userid"]))
			{
				$dbCore->query("UPDATE `". TABLE_PREFIX ."users` SET `loginapi_moduleid` = '". LOGINAPI_WHMCSINTEGRATION ."', `loginapi_userid` = '". intval($whmcsuser["userid"]) ."' WHERE `userid` = '". intval($_swiftuser["userid"]) ."';");

				$userid = $_swiftuser["userid"];
			} else {
				return false;
			}
		}

		$_swiftuser = $loginshare->loadSWIFTUser($userid);
		if (!$_swiftuser)
		{
			return false;
		}

		$_SWIFT["user"] = $_swiftuser;

		return $_swiftuser["userid"];
	}

	return false;
}

/**
* Return the Unique User ID of the current user
*/
function loginShareUserID()
{
	global $_SWIFT;

	if (empty($_SWIFT["user"]["userid"]))
	{
		return false;
	} else {
		return $_SWIFT["user"]["userid"];
	}
}

/**
* Logout the current user
*/
function loginShareLogout()
{
	global $session, $_SWIFT;

	$session->updateSession($_SWIFT["session"]["sessionid"], 0);

	return true;
}

/**
* Load the user credentials into current workspace. The following variables should be declared for proper working:
* userid - User id that is set in the "users" table
* fullname
* email - Array
* password (MD5 Hashed)
* usergroupid - If this is not set, then it will use the default registered user group for this template group
*/
function loginShareLoadUser()
{
	global $dbCore, $_SWIFT, $loginshare;

	if (empty($_SWIFT["session"]["typeid"]))
	{
		$_SWIFT["user"]["loggedin"] = false;
		return false;
	}

	$_user = $loginshare->loadSWIFTUser($_SWIFT["session"]["typeid"]);
	if (!$_user)
	{
		$_SWIFT["user"]["loggedin"] = false;

		return false;
	}

	$_SWIFT["user"] = $_user;

	return true;
}

/**
* Renders the Login Share Form
*/
function renderLoginShareForm()
{
	global $_SWIFT;

	$forms = array();

	return $forms;

}
?>