<?php
//=======================================
//###################################
// Kayako Infotech Ltd. - SWIFT Framework
//
// Source Copyright 2001-2008 Kayako Infotech Ltd.
// Unauthorized reproduction is not allowed
// License Number: $%LICENSE%$
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//                   www.kayako.com
//###################################
//=======================================

if (!defined("INSWIFT")) {
        trigger_error("Unable to process " . htmlentities($_SERVER['PHP_SELF']), E_USER_ERROR);
}

global $staffauth;
if (!$staffauth->isAdmin()) {
        trigger_error("You do not have permission to access " . htmlentities($_SERVER['PHP_SELF']), E_USER_ERROR);
}

// Certain parts taken from phpMyAdmin and another script I found on net. I do not remember the author of other script so in case you are reading this, let me know and I will place in the required credits ;)





 /*********
  *
  *  Gets the table definitions
  *
  *  @author    Varun Shoor
  *  @since     1
  *  @version   1
  *  @access    public
  *
  *  @param     string	$table	Which table to work with
  *
  *  @return    string	Table definition string
  *
  */

  function getTableDef($table) {

    global $_SWIFT;

    $schema_create  = "DROP TABLE IF EXISTS `$table`;" . SWIFT_CRLF;
    $schema_create .= "CREATE TABLE `$table` ("        . SWIFT_CRLF;



    $fields = mysql_query("SHOW FIELDS FROM `$table`", $_SWIFT["backuplink"]);

    $firstpass = true;
    while ($row = mysql_fetch_array($fields)) {

        if ($firstpass) { $firstpass = false; } else { $schema_create .= "," . SWIFT_CRLF; }

        $schema_create .= " `{$row['Field']}` {$row['Type']}";

        if (isset($row["Default"]) && (!empty($row["Default"]) || $row["Default"] == "0")) {    // todo this should be made explicit
          $schema_create .= " DEFAULT '{$row['Default']}'";
        }

        if ($row["Null"]  != "YES") { $schema_create .= " NOT NULL"; }
        if ($row["Extra"] != "")    { $schema_create .= " {$row['Extra']}"; }  // why bother with this test?  appending empty strings is fine.

    }



    $keys = mysql_query("SHOW KEYS FROM `$table`", $_SWIFT["backuplink"]);

    while ($row = mysql_fetch_array($keys)) {

//    print_r($row); echo '<br><br>';

        $kname = $row['Key_name'];

        if (($kname != "PRIMARY") && ($row['Non_unique'] == 0)) {
            $kname="UNIQUE|$kname";
        }

        // key types are mutually exclusive, so just checking something else is safe
        if ($row['Index_type'] == 'FULLTEXT') { $kname = "FULLTEXT|$kname"; }

        if (!isset($index[$kname])) { $index[$kname] = array(); }

        $index[$kname][] = "`{$row['Column_name']}`";

    }



    reset($index);
    while (list($x, $columns) = @each($index)) {

//    print_r($index); echo '<br><br>';

         $schema_create .= ",".SWIFT_CRLF;
         $icols          = implode($columns, ", ");

         if      ($x == "PRIMARY")              { $schema_create .= " PRIMARY KEY ($icols)"; }
         else if (substr($x,0,6) == "UNIQUE")   { $schema_create .= " UNIQUE "   . substr($x,7)." ($icols)"; }
         else if (substr($x,0,8) == "FULLTEXT") { $schema_create .= " FULLTEXT " . substr($x,9)." ($icols)"; }
         else                                   { $schema_create .= " KEY `$x` ($icols)"; }

    }



    $schema_create .= SWIFT_CRLF.");";

    return $schema_create;

}





/**
* Generates the actual INSERT queries
*/
function getTableContent($table, $handler) {
    
    WriteToBackup(SWIFT_CRLF);
    
    global $_SWIFT, $showcolumns;  // todo comeback break this global
    $result = mysql_query("SELECT * FROM $table", $_SWIFT["backuplink"]);

    while ($row = mysql_fetch_row($result)) {


        if (isset($showcolumns)) {

            $table_list = "(";

            for ($j=0; $j<mysql_num_fields($result); ++$j) {
                if ($j>0) { $table_list .= ','; }
                $table_list .= mysql_field_name($result,$j);
            }
            
            $table_list .= ")";
        
        } else {
            $table_list = '';	
        }


        $schema_insert = "INSERT INTO `$table` $table_list VALUES (";

        $jCap = mysql_num_fields($result);
        for ($j=0; $j<$jCap; ++$j) {
            
            if ($j>0) { $schema_insert .= ','; }

            if (!isset($row[$j]))    { $schema_insert .= "NULL"; }
            else if ($row[$j] != "") { $schema_insert .= "'" . addslashes($row[$j]) . "'"; }
            else                     { $schema_insert .= "''"; }
            
        }
        
        $schema_insert .= ")";

        
        $handler(trim($schema_insert));
        
    }

    return true;
    
}





/**
* Outputs the DB String returned to the handler function
*/
function dbOutput($sql_insert) {
//  global $crlf, $asfile;  // todo comeback is this removable?  surely it is?  
    WriteToBackup($sql_insert .";".SWIFT_CRLF);
}





 /*********
  *
  *  Writes out the informational header at the beginning of the backup
  *
  *  @author    John Haugeland
  *  @since     2.0
  *  @version   1
  *  @access    public
  *
  *  @return    The backup (string value)
  *
  */

  function WriteBackupHeader() {

    WriteToBackup("#############################" . SWIFT_CRLF);
    WriteToBackup("# SWIFT Backup System"         . SWIFT_CRLF);
    WriteToBackup("# Date: ". date("d M Y h:i:s") . SWIFT_CRLF);
    WriteToBackup("#############################" . SWIFT_CRLF . SWIFT_CRLF . SWIFT_CRLF);
    WriteToBackup("start transaction;"            . SWIFT_CRLF . SWIFT_CRLF . SWIFT_CRLF);
        
  }





 /*********
  *
  *  Sends HTML noncaching headers
  *
  *  @author    John Haugeland
  *  @since     2.0
  *  @version   1
  *  @access    public
  *
  *  @param		string	$backupfilename		The name of the backup file as presented in HTML headers
  * 
  *  @return    The backup (string value)
  *
  */

  function WriteHtmlHeader($backupfilename) {
    
    header("Content-disposition: attachment; filename=\"$backupfilename\"");
    header("Content-Type: text/x-delimtext; name=\"$backupfilename\"");
	session_cache_limiter('nocache');    
  }





 /*********
  *
  *  Writes the name of a given table into the backup
  *
  *  @author    John Haugeland
  *  @since     2.0
  *  @version   1
  *  @access    public
  *
  *  @param		string	$table	The name of the table being annoted 
  * 
  */

  function WriteTableName($table) {
    
    WriteToBackup(                                         SWIFT_CRLF);
    WriteToBackup("# ==================================" . SWIFT_CRLF);
    WriteToBackup("# Table Name: ". $table               . SWIFT_CRLF);
    WriteToBackup("# ==================================" . SWIFT_CRLF);
    
  }





 /*********
  *
  *  Generate and transfer the backup; calls database and includes HTTP headers + etc.  Refactoring of Varun's code.
  * 
  *  Backup generation and transfer routine.  Has a bunch of control logic, but defers most of the load to implementation
  *  functionality.  Refactored from prior code to allow storage drivers (stream to disk instead of ram)
  *
  *  @author    John Haugeland
  *  @since     1.0
  *  @version   4
  *  @access    public
  *
  *  @param		boolean	$createtable	Whether or not to destroy and recreate given tables
  *  @param		boolean	$compress		Whether to write a compressed or uncompressed file
  *  @param		boolean	$structureonly	Whether or not to send the contents of tables
  * 
  *  @todo		add error handling behavior
  * 
  */

  function doBackup($createtable = true, $compress = true, $structureonly = false) {
    
    @set_time_limit(0);
    global $_SWIFT, $_DB;
    
    if (!(extension_loaded("zlib"))) { $compress = false; }
    require_once($compress? "functions_backup_gz_diskstream.php" : "functions_backup_ramstream.php");
    
    
    
    StartBackupOutput();

    // Connect to mySQL Server
    $_SWIFT["backuplink"] = mysql_connect ($_DB["hostname"], $_DB["username"], $_DB["password"]) or die ("Could not connect");
    mysql_select_db($_DB["name"], $_SWIFT["backuplink"]);

    $tables     = mysql_list_tables($_DB["name"], $_SWIFT["backuplink"]);
    $num_tables = @mysql_num_rows($tables);

    WriteBackupHeader();



    if ($num_tables == 0) {
        
      WriteToBackup("# No Tables in Database".SWIFT_CRLF);
        
    } else {

      while ($i < $num_tables) { 
            
        $table = mysql_tablename($tables, $i);
        WriteTableName($table);

        if ($createtable)    { WriteToBackup(getTableDef($table).SWIFT_CRLF); }
        if (!$structureonly) { getTableContent($table, "dbOutput"); }

        $i++;

      }

    }


    
    WriteToBackup("commit;");
    
    StopAndTransmitBackup();  

    mysql_close($_SWIFT["backuplink"]);

    return true;
    
  }





?>