<?php

if (!defined("INSWIFT")) {
	trigger_error("Unable to process " . htmlentities($_SERVER['PHP_SELF']), E_USER_ERROR);
}

global $staffauth;
if (!$staffauth->isAdmin()) {
	trigger_error("You do not have permission to access " . htmlentities($_SERVER['PHP_SELF']), E_USER_ERROR);
}





  $gz_diskstream_handle = false;
  $backup_loc           = false;





 /*********
  *
  *  Writes output to the backup stream.  Pretty simple in the RAM driver.
  *
  *  @author    John Haugeland
  *  @since     2.0
  *  @version   1
  *  @access    public
  *
  *  @param		boolean	$x	The value to write to 
  *
  *  @return    UUID as string
  *
  *  @todo      pull into a more appropriate location (after finding it)
  *
  */

  function WriteToBackup($x) {
	global $gz_diskstream_handle;
    gzwrite($gz_diskstream_handle, $x);  
  }





 /*********
  *
  *  But where oh where to write on disk, junior bear campers?
  *
  *  @author    John Haugeland
  *  @since     2.0
  *  @version   1
  *  @access    public
  *
  *  @return    UUID as string
  *
  *  @todo      pull into a more appropriate location (after finding it)
  *
  */

  function GetWriteLocationForBackup() {

    global $backup_name;
	global $backup_loc;
	
	if (!($backup_loc)) { 
	  $backup_name = GenBackupFilename($GLOBALS['_DB']['name']);
	  $backup_loc  = './files/' . $backup_name; 
	}

	return $backup_loc;

  }





 /*********
  *
  *  But where oh where to write on disk, junior bear campers?
  *
  *  @author    John Haugeland
  *  @since     2.0
  *  @version   1
  *  @access    public
  *
  *  @return    UUID as string
  *
  *  @todo      pull into a more appropriate location (after finding it)
  *
  */

  function GetWriteNameForBackup() {

    global $backup_name;
	
	if (!($backup_name)) { 
	  GetWriteLocationForBackup();
	}

	return $backup_name;

  }





 /*********
  *
  *  Driver entrypoint to start the backup process
  *
  *  @author    John Haugeland
  *  @since     2.0
  *  @version   1
  *  @access    public
  *
  */

  function StartBackupOutput() {

    global $gz_diskstream_handle;
    global $backup_loc;
    
    $backup_loc           = GetWriteLocationForBackup();  // cached for later read-back
    $gz_diskstream_handle = gzopen($backup_loc, 'wb9');
    
    if ($gz_diskstream_handle) { return true; } 
    else                       { return false; }

  }





 /*********
  *
  *  Driver entrypoint to finish the backup process; returns the backup as held.
  *
  *  @author    John Haugeland
  *  @since     2.0
  *  @version   1
  *  @access    public
  *
  */

  function StopBackupAndOutput() {
	
	global $gz_diskstream_handle;
	global $backup_loc;
	
	gzclose($gz_diskstream_handle);
    echo file_get_contents($backup_loc);  // todo replace with incremental output so that ram limit doesn't come back
    
    unlink($backup_loc);
    
    return $contents;
    
  }





 /*********
  *
  *  Generate the filename for a backup, given a database's base name and whether or not the output is to be compressed
  *
  *  @author    John Haugeland
  *  @since     2.0
  *  @version   1
  *  @access    public
  *
  *  @param		string	$basename	The name of the database
  *  @param		boolean	$compressed	Whether to write the name of a compressed or uncompressed file (to be removed in favor of a seperate driver)
  * 
  *  @return    The backup filename (string)
  * 
  *  @todo		split into two drivers, one for compressed and one for not
  *
  */

  function GenBackupFilename($basename) {
    return $basename . "." . date("d") . "_" . date("M") . "_" . date("Y") . '.sql.gz';
  }





 /*********
  *
  *  Stops the backup process and dispatches the results to the client.  Implies cleanup.
  *
  *  @author    John Haugeland
  *  @since     2.0
  *  @version   1
  *  @access    public
  *
  */

  function StopAndTransmitBackup() {
    
    global $_DB;
    
    WriteHtmlHeader(GetWriteNameForBackup());
    StopBackupAndOutput();
    
  }



	

?>