<?php
//=======================================
//###################################
// Kayako Infotech Ltd. - SWIFT Framework
//
// Source Copyright 2001-2008 Kayako Infotech Ltd.
// Unauthorized reproduction is not allowed
// License Number: $%LICENSE%$
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//                   www.kayako.com
//###################################
//=======================================

if (!defined("INSWIFT")) {
	trigger_error("Unable to process " . htmlentities($_SERVER['PHP_SELF']), E_USER_ERROR);
}

define("FIELD_TEXT", 1);
define("FIELD_TEXTAREA", 2);
define("FIELD_PASSWORD", 3);
define("FIELD_CHECKBOX", 4);
define("FIELD_RADIO", 5);
define("FIELD_SELECT", 6);
define("FIELD_SELECTMULTIPLE", 7);
define("FIELD_CUSTOM", 8);

/**
* Add a new link
*/
function addCustomFieldLink($linktype, $typeid, $customfieldgroupid)
{
	global $dbCore;

	$dbCore->shutdownQuery("REPLACE INTO `". TABLE_PREFIX ."customfieldlinks` (`linktype`, `typeid`, `customfieldgroupid`) VALUES ('". intval($linktype) ."', '". intval($typeid) ."', '". intval($customfieldgroupid) ."');");

	return true;
}

/**
* Inserts a new custom field into the database
*/
function insertCustomField($customfieldgroupid, $fieldtype, $title, $fieldname, $defaultvalue, $displayorder, $isrequired, $usereditable, $staffeditable, $regexpvalidate, $fieldoptions, $selectedfield, $description = '')
{
	global $dbCore, $_SWIFT;

	$dbCore->query("INSERT INTO `". TABLE_PREFIX ."customfields` (`customfieldgroupid`, `title`, `fieldtype`, `fieldname`, `defaultvalue`, `isrequired`, `usereditable`, `staffeditable`, `regexpvalidate`, `displayorder`, `description`) VALUES ('". intval($customfieldgroupid) ."', '". $dbCore->escape($title) ."', '". intval($fieldtype) ."', '". $dbCore->escape($fieldname) ."', '". $dbCore->escape($defaultvalue) ."', '". intval($isrequired) ."', '". intval($usereditable) ."', '". intval($staffeditable) ."', '". $dbCore->escape($regexpvalidate) ."', '". intval($displayorder) ."', '". $dbCore->escape($description) ."');");
	$customfieldid = $dbCore->lastInsertId();
	if (!$customfieldid)
	{
		return false;
	}

	if (_is_array($fieldoptions))
	{
		// Iterate through field options
		$fieldsql = array();
		foreach ($fieldoptions as $key=>$val)
		{
			if (trim($val[0]) != "")
			{
				// Ok add the option because its a valid entry
				if ($selectedfield == $key && $selectedfield != "")
				{
					$isselected = "1";
				} else if ($val[2] == "1") {
					$isselected = "1";
				} else {
					$isselected = "0";
				}
				
				$fieldsql[] = "('". intval($customfieldid) ."', '". $dbCore->escape($val[0]) ."', '". intval($val[1]) ."', '". $isselected ."')";
			}
		}

		// Add all the field options
		if (count($fieldsql))
		{
			$dbCore->query("INSERT INTO `". TABLE_PREFIX ."customfieldoptions` (`customfieldid`, `optionvalue`, `displayorder`, `isselected`) VALUES ". implode(",", $fieldsql) .";");
		}
	}
}

/**
* Update existing custom field
*/
function updateCustomField($customfieldid, $customfieldgroupid, $title, $fieldname, $defaultvalue, $displayorder, $isrequired, $usereditable, $staffeditable, $regexpvalidate, $fieldoptions, $selectedfield, $description)
{
	global $dbCore, $_SWIFT;

	$dbCore->query("UPDATE `". TABLE_PREFIX ."customfields` SET `title` = '". $dbCore->escape($title) ."', `customfieldgroupid` = '". intval($customfieldgroupid) ."', `fieldname` = '". $dbCore->escape($fieldname) ."', `defaultvalue` = '". $dbCore->escape($defaultvalue) ."', `description` = '". $dbCore->escape($description) ."', `isrequired` = '". intval($isrequired) ."', `usereditable` = '". intval($usereditable) ."', `staffeditable` = '". intval($staffeditable) ."', `regexpvalidate` = '". $dbCore->escape($regexpvalidate) ."', `displayorder` = '". intval($displayorder) ."' WHERE `customfieldid` = '". intval($customfieldid) ."';");

	// Delete existing field options
	$dbCore->query("DELETE FROM `". TABLE_PREFIX ."customfieldoptions` WHERE `customfieldid` = '". intval($customfieldid) ."';");
	if (_is_array($fieldoptions))
	{
		// Iterate through field options
		$fieldsql = array();
		foreach ($fieldoptions as $key=>$val)
		{
			if (trim($val[0]) != "")
			{
				// Ok add the option because its a valid entry
				if ($selectedfield == $key && $selectedfield != "")
				{
					$isselected = "1";
				} else if ($val[2] == "1") {
					$isselected = "1";
				} else {
					$isselected = "0";
				}
				
				$fieldsql[] = "('". intval($customfieldid) ."', '". $dbCore->escape($val[0]) ."', '". intval($val[1]) ."', '". $isselected ."')";
			}
		}

		// Add all the field options
		if (count($fieldsql))
		{
			$dbCore->query("INSERT INTO `". TABLE_PREFIX ."customfieldoptions` (`customfieldid`, `optionvalue`, `displayorder`, `isselected`) VALUES ". implode(",", $fieldsql) .";");
		}
	}

	return true;
}

/**
* Deletes the given custom fields
*/
function deleteCustomFields($customfieldidlist)
{
	global $dbCore, $_SWIFT, $module;

	if (!_is_array($customfieldidlist))
	{
		return false;
	}

	$dbCore->query("DELETE FROM `". TABLE_PREFIX ."customfields` WHERE `customfieldid` IN (". buildIN($customfieldidlist) .");");
	$dbCore->query("DELETE FROM `". TABLE_PREFIX ."customfieldvalues` WHERE `customfieldid` IN (". buildIN($customfieldidlist) .");");
	$dbCore->query("DELETE FROM `". TABLE_PREFIX ."customfieldoptions` WHERE `customfieldid` IN (". buildIN($customfieldidlist) .");");

	if ($module->isRegistered(MODULE_TICKETS))
	{
		require_once ("./modules/tickets/functions_views.php");
		$dbCore->query("DELETE FROM `". TABLE_PREFIX ."ticketviewfields` WHERE `customfieldid` IN (". buildIN($customfieldidlist) .");");
		rebuildTicketViewsCache();
	}

	return true;
}

/**
* Delete given custom field groups
*/
function deleteCustomFieldGroups($customfieldgroupidlist)
{
	global $dbCore, $_SWIFT;

	if (!_is_array($customfieldgroupidlist))
	{
		return false;
	}

	$dbCore->query("DELETE FROM `". TABLE_PREFIX ."customfieldgroups` WHERE `customfieldgroupid` IN (". buildIN($customfieldgroupidlist) .");");

	// Now get the list of all custom fields under the specified groups
	$customfieldidlist = array();
	$dbCore->query("SELECT `customfieldid` FROM `". TABLE_PREFIX ."customfields` WHERE `customfieldgroupid` IN (". buildIN($customfieldgroupidlist) .");");
	while ($dbCore->nextRecord())
	{
		$customfieldidlist[] = $dbCore->Record["customfieldid"];
	}

	// Ok now nuke everything
	$customfieldidresult = buildIN($customfieldidlist);

	if (count($customfieldidlist))
	{
		$dbCore->query("DELETE FROM `". TABLE_PREFIX ."customfields` WHERE `customfieldid` IN (". $customfieldidresult .");");
		$dbCore->query("DELETE FROM `". TABLE_PREFIX ."customfieldvalues` WHERE `customfieldid` IN (". $customfieldidresult .");");
		$dbCore->query("DELETE FROM `". TABLE_PREFIX ."customfieldoptions` WHERE `customfieldid` IN (". $customfieldidresult .");");
	}

	// Delete all the assignments
	$dbCore->query("DELETE FROM `". TABLE_PREFIX ."customfielddeplinks` WHERE `customfieldgroupid` IN (". buildIN($customfieldgroupid) .");");
	$dbCore->query("DELETE FROM `". TABLE_PREFIX ."customfieldlinks` WHERE `customfieldgroupid` IN (". buildIN($customfieldgroupid) .");");

	return true;
}

/**
* Insert a new custom field group
*/
function insertCustomFieldGroup($title, $grouptype, $displayorder, $departmentidlist)
{
	global $dbCore, $_SWIFT;

	$dbCore->query("INSERT INTO `". TABLE_PREFIX ."customfieldgroups` (`title`, `grouptype`, `displayorder`) VALUES ('". $dbCore->escape($title) ."', '". intval($grouptype) ."', '". intval($displayorder) ."');");
	$customfieldgroupid = $dbCore->lastInsertId();

	unset($assignsql);
	//Mahesh Slaria: Staff & user ticket creation
	if (($grouptype == CUSTOMFIELD_USERTICKET || $grouptype == CUSTOMFIELD_STAFFTICKET || $grouptype == CUSTOMFIELD_STAFFUSERTICKET) && _is_array($departmentidlist))
	{
		// Add the department links for this user ticket creation
		foreach ($departmentidlist as $key=>$val)
		{
			$assignsql[] = "('". intval($customfieldgroupid) ."', '". intval($val) ."')";
		}

		if (count($assignsql))
		{
			$dbCore->query("REPLACE INTO `". TABLE_PREFIX ."customfielddeplinks` (`customfieldgroupid`, `departmentid`) VALUES ". implode(",", $assignsql).";");				
		}
	}else if ($grouptype == CUSTOMFIELD_USER) {

		$dbCore->query("SELECT `userid` FROM `". TABLE_PREFIX ."users` WHERE 1;");

		while ($dbCore->nextRecord())
		{
			$useridlink = $dbCore->Record["userid"];
			if (!empty($useridlink))
			{
				addCustomFieldLink(CUSTOMFIELD_USER, $useridlink, $customfieldgroupid);
			}
		}
	}
	
return $customfieldgroupid;
}

/**
* Update an existing custom field group
*/
function updateCustomFieldGroup($customfieldgroupid, $title, $grouptype, $displayorder, $departmentidlist)
{
	global $dbCore, $_SWIFT;

	$dbCore->query("UPDATE `". TABLE_PREFIX ."customfieldgroups` SET `title` = '". $dbCore->escape($title) ."', `grouptype` = '". intval($grouptype) ."', `displayorder` = '". intval($displayorder) ."' WHERE `customfieldgroupid` = '". intval($customfieldgroupid) ."';");

	// First nuke all assignments
	$dbCore->query("DELETE FROM `". TABLE_PREFIX ."customfielddeplinks` WHERE `customfieldgroupid` = '". intval($customfieldgroupid) ."';");

	unset($assignsql);
	//Mahesh Slaria: Staff & user ticket creation
	if (($grouptype == CUSTOMFIELD_USERTICKET || $grouptype == CUSTOMFIELD_STAFFTICKET || $grouptype == CUSTOMFIELD_STAFFUSERTICKET) && _is_array($departmentidlist))
	{
		// Add the department links for this user ticket creation
		foreach ($departmentidlist as $key=>$val)
		{
			$assignsql[] = "('". intval($customfieldgroupid) ."', '". intval($val) ."')";
		}

		if (count($assignsql))
		{
			$dbCore->query("REPLACE INTO `". TABLE_PREFIX ."customfielddeplinks` (`customfieldgroupid`, `departmentid`) VALUES ". implode(",", $assignsql).";");
		}
	}

	return $customfieldgroupid;
}

/**
* Render the Custom Field Group Form
*/
function renderCustomFieldGroupForm($type)
{
	global $_SWIFT, $module, $dbCore;

	?>
	<script language="Javascript">
	function switchFields(fieldtype)
	{
		var deplist = browserObject("departmentid");
		if (!deplist)
		{
			alert("Invalid Display Object\nPlease make sure that all correct display objects are on the page");
			return;
		}
//Mahesh Slaria: Staff & user ticket creation
		if (fieldtype == <?php echo CUSTOMFIELD_USERTICKET, ' || fieldtype == ', CUSTOMFIELD_STAFFTICKET, ' || fieldtype == ', CUSTOMFIELD_STAFFUSERTICKET; ?>)
		{
			deplist.style.display = "";
		} else if (fieldtype == <?php echo CUSTOMFIELD_USERGROUP; ?>) {
			deplist.style.display = "none";
		} else {
			deplist.style.display = "none";
		}
	}
	</script>
	<?php
//Mahesh Slaria: Staff & user ticket creation
	if ($_POST["grouptype"] == CUSTOMFIELD_USERTICKET || $_POST["grouptype"] == CUSTOMFIELD_STAFFTICKET || $_POST["grouptype"] == CUSTOMFIELD_STAFFUSERTICKET)
	{
		$depdisplay = "display:;";
	} else {
		$depdisplay = "display:none;";
	}

	printFormStart();
	printMainTableHeader($_SWIFT["language"]["cfgroupdetails"]);

	printTextRow("title", $_SWIFT["language"]["grouptitle"], $_SWIFT["language"]["desc_grouptitle"], "text", $_POST["title"]);

	// ======= BEGIN CUSTOM FIELD GROUP TYPE SELECTION =======
	// KACT 5/pages/418
	$options[0]["title"] = $_SWIFT["language"]["grouptypeuser"];
	$options[0]["value"] = CUSTOMFIELD_USER;
	$options[1]["title"] = $_SWIFT["language"]["grouptypeusergroup"];
	$options[1]["value"] = CUSTOMFIELD_USERGROUP;
	$optindex = 2;
	if ($module->isRegistered(MODULE_TICKETS))
	{
		$options[$optindex]["title"] = $_SWIFT["language"]["grouptypestaffticket"];
		$options[$optindex]["value"] = CUSTOMFIELD_STAFFTICKET;
		$optindex++;
		$options[$optindex]["title"] = $_SWIFT["language"]["grouptypeuserticket"];
		$options[$optindex]["value"] = CUSTOMFIELD_USERTICKET;
		$optindex++;
		$options[$optindex]["title"] = $_SWIFT["language"]["grouptypestaffuserticket"];
		$options[$optindex]["value"] = CUSTOMFIELD_STAFFUSERTICKET;//Mahesh Slaria: Staff & user ticket creation
		$optindex++;
		$options[$optindex]["title"] = $_SWIFT["language"]["grouptypetimetrack"];
		$options[$optindex]["value"] = CUSTOMFIELD_TIMETRACK;
		$optindex++;
	}
	if ($module->isRegistered(MODULE_TEAMWORK))
	{
		$options[$optindex]["title"] = $_SWIFT["language"]["grouptypecontact"];
		$options[$optindex]["value"] = CUSTOMFIELD_CONTACT;
		$optindex++;
		$options[$optindex]["title"] = $_SWIFT["language"]["grouptypeevent"];
		$options[$optindex]["value"] = CUSTOMFIELD_EVENT;
		$optindex++;
		$options[$optindex]["title"] = $_SWIFT["language"]["grouptypetask"];
		$options[$optindex]["value"] = CUSTOMFIELD_TASK;
		$optindex++;
	}

	printSelectRow("grouptype", $_SWIFT["language"]["grouptype"], $_SWIFT["language"]["desc_grouptype"], $options, "switchFields(this.value);");

	if ($type == INSERT)
	{
		// Get the last display order
		$_disporder = $dbCore->queryFetch("SELECT `displayorder` FROM `". TABLE_PREFIX ."customfieldgroups` ORDER BY `displayorder` DESC LIMIT 1;");
		if (empty($_disporder["displayorder"]))
		{
			$_POST["displayorder"] = 1;
		} else {
			$_POST["displayorder"] = $_disporder["displayorder"]+1;
		}
	}

	printNumberRow("displayorder", $_SWIFT["language"]["displayorder"], $_SWIFT["language"]["desc_displayorder"], $_POST["displayorder"]);

	// Departments
	$options = array();
	$index = 0;
	$dbCore->query("SELECT * FROM `". TABLE_PREFIX ."departments` WHERE `departmentmodule` = '". MODULE_TICKETS ."' ORDER BY `title` ASC;");
	while ($dbCore->nextRecord())
	{
		$options[$index]["value"] = $dbCore->Record["departmentid"];
		$options[$index]["title"] = $dbCore->Record["title"];
		//Mahesh Slaria: Staff & user ticket creation
		if ($type == EDIT && ($_POST["grouptype"] == CUSTOMFIELD_USERTICKET || $_POST["grouptype"] == CUSTOMFIELD_STAFFTICKET || $_POST["grouptype"] == CUSTOMFIELD_STAFFUSERTICKET))
		{
			if (in_array($dbCore->Record["departmentid"], $_POST["departmentidlist"]))
			{
				$options[$index]["checked"] = true;
			} else {
				$options[$index]["checked"] = false;
			}
		} else {
			// Always checked in case of insert
			$options[$index]["checked"] = true;
		}
		$index++;
	}

	getRowBG();
	printCheckboxListRow("departmentid", $_SWIFT["language"]["cfdepartments"], $_SWIFT["language"]["desc_cfdepartments"], $options, $depdisplay);

	printSubmitRow(iif($type==INSERT,$_SWIFT["language"]["insertgroup"], $_SWIFT["language"]["updategroup"]));

	printMainTableFooter();

	addHiddenField("_m", "core");
	addHiddenField("_a", iif($type==INSERT, "insertcfgroup", "editcfgroup"));
	addHiddenField("step", "1");
	if ($type == EDIT)
	{
		addHiddenField("customfieldgroupid", $_POST["customfieldgroupid"]);
	}
	printFormEnd();
}

/**
* Returns the custom field data for updating and rendering
*/
function fetchCustomFieldData($grouptype, $cdepartmentid = false, $linktypeid = false)
{
	global $dbCore, $_CFCACHE;

	if ($_CFCACHE[$grouptype]["cached"] == true)
	{
		return $_CFCACHE[$grouptype];
	}

	$customfieldgroups = $customfields = $customfieldgroupidlist = $customfieldidlist = $customfieldoptions = $customfielddata = $customfielddeplinks = $_selected = array();

	if ($linktypeid)
	{
		if (_is_array($linktypeid))
		{
			$_linktypeidlist = $linktypeid;
		} else {
			$_linktypeidlist = array($linktypeid);
		}

		$dbCore->query("SELECT * FROM `". TABLE_PREFIX ."customfieldlinks` WHERE `linktype` = '". intval($grouptype) ."' AND `typeid` IN(". buildIN($_linktypeidlist) .");");
		while ($dbCore->nextRecord())
		{
			$customfieldgroupidlist[] = $dbCore->Record["customfieldgroupid"];
		}

		if (!count($customfieldgroupidlist))
		{
			return array();
		}

		$dbCore->query("SELECT * FROM `". TABLE_PREFIX ."customfieldgroups` WHERE `customfieldgroupid` IN (". buildIN($customfieldgroupidlist) .");");
		while ($dbCore->nextRecord())
		{
			$customfieldgroups[$dbCore->Record["customfieldgroupid"]] = $dbCore->Record;
		}
	} else {
		//Mahesh Slaria: Staff & user ticket creation
		if ($grouptype == CUSTOMFIELD_USERTICKET || $grouptype == CUSTOMFIELD_STAFFTICKET || $grouptype == CUSTOMFIELD_STAFFUSERTICKET)
		{
			$dbCore->query("SELECT * FROM `". TABLE_PREFIX ."customfielddeplinks`;");
			while ($dbCore->nextRecord())
			{
				$customfielddeplinks[$dbCore->Record["departmentid"]][] = $dbCore->Record["customfieldgroupid"];
			}
		}

		// First load all custom field groups for this group type
		$dbCore->query("SELECT * FROM `". TABLE_PREFIX ."customfieldgroups` AS cfg WHERE cfg.grouptype = '". intval($grouptype) ."' ORDER BY cfg.displayorder ASC;");
		while ($dbCore->nextRecord())
		{
			unset($noadd);
			//Mahesh Slaria: Staff & user ticket creation
			if (($grouptype == CUSTOMFIELD_USERTICKET || $grouptype == CUSTOMFIELD_STAFFTICKET || $grouptype == CUSTOMFIELD_STAFFUSERTICKET) && (!@in_array($dbCore->Record["customfieldgroupid"], $customfielddeplinks[$cdepartmentid]))) // Check for department
			{
				$noadd = true;
			}
			if (!$noadd)
			{
				$customfieldgroups[$dbCore->Record["customfieldgroupid"]] = $dbCore->Record;
				$customfieldgroupidlist[] = $dbCore->Record["customfieldgroupid"];
			}
		}
	}

	$_CFCACHE[$grouptype]["cached"] = true;
	$_CFCACHE[$grouptype]["customfieldgroups"] = $customfieldgroups;
	$_CFCACHE[$grouptype]["customfieldgroupidlist"] = $customfieldgroupidlist;

	if (!count($customfieldgroupidlist))
	{
		return false;
	}

	// Now load all the fields and their options
	$dbCore->query("SELECT *, customfieldoptions.displayorder AS optiondisplayorder, customfields.displayorder AS fielddisplayorder, customfields.customfieldid AS ccustomfieldid FROM `". TABLE_PREFIX ."customfields` AS customfields LEFT JOIN `". TABLE_PREFIX ."customfieldoptions` AS customfieldoptions ON (customfields.customfieldid = customfieldoptions.customfieldid) WHERE customfields.customfieldgroupid IN (". buildIN($customfieldgroupidlist) .") ORDER BY customfields.displayorder ASC, customfieldoptions.displayorder ASC;");
	while ($dbCore->nextRecord())
	{
		// Add the customfieldid to our list if it doesnt exist
		if (!in_array($dbCore->Record["ccustomfieldid"], $customfieldidlist))
		{
			$customfieldidlist[] = $dbCore->Record["ccustomfieldid"];
		}

		// Load up the values
		if (!isset($customfields[$dbCore->Record["customfieldgroupid"]][$dbCore->Record["ccustomfieldid"]]))
		{
			$customfielddata[$dbCore->Record["ccustomfieldid"]] = $dbCore->Record;
			$customfielddata[$dbCore->Record["ccustomfieldid"]]["customfieldid"] = $dbCore->Record["ccustomfieldid"];
			$customfields[$dbCore->Record["customfieldgroupid"]][$dbCore->Record["ccustomfieldid"]] = $dbCore->Record;
			$customfields[$dbCore->Record["customfieldgroupid"]][$dbCore->Record["ccustomfieldid"]]["customfieldid"] = $dbCore->Record["ccustomfieldid"];
			$customfields[$dbCore->Record["customfieldgroupid"]][$dbCore->Record["ccustomfieldid"]]["options"] = array();
		}

		if ($dbCore->Record["fieldtype"] == FIELD_CHECKBOX || $dbCore->Record["fieldtype"] == FIELD_RADIO)
		{
			$optioncount = count($customfieldoptions[$dbCore->Record["customfieldid"]]);
			$customfieldoptions[$dbCore->Record["customfieldid"]][$optioncount]["title"] = $dbCore->Record["optionvalue"];
			$customfieldoptions[$dbCore->Record["customfieldid"]][$optioncount]["value"] = htmlspecialchars($dbCore->Record["optionvalue"]);
			$customfieldoptions[$dbCore->Record["customfieldid"]][$optioncount]["checked"] = iif($dbCore->Record["isselected"]==1, true, false);
		} else if ($dbCore->Record["fieldtype"] == FIELD_SELECT || $dbCore->Record["fieldtype"] == FIELD_SELECTMULTIPLE) {
			// [VARUN]: 12/4/2006 -  FS#1130  Select Type Custom Fields reset to default value when fields are filled wrong
			$optioncount = count($customfieldoptions[$dbCore->Record["customfieldid"]]);
			$customfieldoptions[$dbCore->Record["customfieldid"]][$optioncount]["title"] = $dbCore->Record["optionvalue"];
			$customfieldoptions[$dbCore->Record["customfieldid"]][$optioncount]["value"] = $dbCore->Record["optionvalue"];
			if (isset($_POST[$dbCore->Record["fieldname"]]) && $_POST[$dbCore->Record["fieldname"]] == $dbCore->Record["optionvalue"])
			{
				$customfieldoptions[$dbCore->Record["customfieldid"]][$optioncount]["selected"] = true;
				$_selected[] = $dbCore->Record["customfieldid"];
			} else if (!in_array($dbCore->Record["customfieldid"], $_selected) && !isset($_POST[$dbCore->Record["fieldname"]])) {
				if ($dbCore->Record["isselected"] == true && $dbCore->Record["fieldtype"] == FIELD_SELECT)
				{
					$_selected[] = $dbCore->Record["customfieldid"];
				}
				$customfieldoptions[$dbCore->Record["customfieldid"]][$optioncount]["selected"] = iif($dbCore->Record["isselected"]==1, true, false);
			} else {
				$customfieldoptions[$dbCore->Record["customfieldid"]][$optioncount]["selected"] = false;
			}
		}
	}
//	print_r($customfieldoptions);
	$_CFCACHE[$grouptype]["customfieldidlist"] = $customfieldidlist;
	$_CFCACHE[$grouptype]["customfielddata"] = $customfielddata;
	$_CFCACHE[$grouptype]["customfields"] = $customfields;
	$_CFCACHE[$grouptype]["customfieldoptions"] = $customfieldoptions;
	
	return $_CFCACHE[$grouptype];
}

/**
* Deletes the custom field value for specific group and typeid
*/
function deleteCustomFieldValue($grouptype, $typeidlist, $cdepartmentid = false, $linktypeid = false)
{
	global $dbCore, $_SWIFT;
	$customfieldgroups = $customfields = $customfieldgroupidlist = $customfieldidlist = $customfieldvalues = $customfieldoptions = $valuesql = $_maxidlist = array();
	$groupdata = fetchCustomFieldData($grouptype, $cdepartmentid, $linktypeid);
	if (is_array($groupdata))
	{
		extract($groupdata);
	}

	if (!count($customfieldidlist))
	{
		return false;
	}
	
	$dbCore->query("DELETE FROM `". TABLE_PREFIX ."customfieldlinks` WHERE `linktype` = '". intval($grouptype) ."' AND `typeid` IN (". buildIN($typeidlist) .");");
	
	$dbCore->query("DELETE FROM `". TABLE_PREFIX . "customfieldvalues` WHERE `customfieldid` IN (". buildIN($customfieldidlist) .") AND typeid IN (". buildIN($typeidlist) .");");
}

/**
*Mahesh Slaria: Delete Ticket Custom Field values
*/

function deleteTicketCustomFieldValue($grouptype, $fieldlinkid)
{
	global $dbCore, $_SWIFT;
	$customfieldidlist = $typeidlist = array();

	$dbCore->query("SELECT *, customfields.customfieldid AS customfieldid, customfieldvalues.typeid AS typeid FROM `". TABLE_PREFIX ."customfieldlinks` AS customfieldlinks LEFT JOIN `". TABLE_PREFIX ."customfields` AS customfields ON (customfieldlinks.customfieldgroupid = customfields.customfieldgroupid) LEFT JOIN `". TABLE_PREFIX ."customfieldvalues` AS customfieldvalues ON (customfieldlinks.typeid = customfieldvalues.typeid AND customfieldvalues.customfieldid = customfields.customfieldid) WHERE `linktype` = '".intval($grouptype)."' AND `customfieldlinkid` = '".intval($fieldlinkid)."';");
	while ($dbCore->nextRecord())
	{
		$customfieldidlist[] = $dbCore->Record["customfieldid"];
		$typeidlist[] = $dbCore->Record["typeid"];
	}

	if (empty($customfieldidlist) || empty($typeidlist))
	{
		//echo "Empty: Nothing found";
		return false;
	}

	$dbCore->query("DELETE FROM `". TABLE_PREFIX ."customfieldlinks`WHERE `linktype` = '". intval($grouptype) ."' AND `customfieldlinkid`= '". intval($fieldlinkid)."';");

	//echo "DELETE FROM `". TABLE_PREFIX ."customfieldlinks`WHERE `linktype` = '". intval($grouptype) ."' AND `customfieldlinkid`= '". intval($fieldlinkid)."';";

	$dbCore->query("DELETE FROM `". TABLE_PREFIX . "customfieldvalues` WHERE `customfieldid` IN (". buildIN($customfieldidlist) .") AND typeid IN (". buildIN($typeidlist) .");");

	//echo "DELETE FROM `". TABLE_PREFIX . "customfieldvalues` WHERE `customfieldid` IN (". buildIN($customfieldidlist) .") AND typeid IN (". buildIN($typeidlist) .");";
	return true;
}




/**
* Checks for regexp validation and required status
*/
function checkCustomFieldContent($grouptype, $cdepartmentid = false, $linktypeid = false)
{
	global $dbCore, $_SWIFT, $_CFAILURE;

	$groupdata = fetchCustomFieldData($grouptype, $cdepartmentid, $linktypeid);
	if (is_array($groupdata))
	{
		extract($groupdata);
	}

	if (!_is_array($customfielddata))
	{
		return true;
	}

	if (defined("ISMODERNBILLV5") && MBAREA != "submitticket")
	{
		$_CHECKVAL = $_GET;
	} else {
		$_CHECKVAL = $_POST;
	}

	$_CFAILURE = array();
	foreach ($customfielddata as $key=>$val)
	{
		// ======= IS REQUIRED CHECK =======
		if (($val["isrequired"] == 1 && empty($_CHECKVAL[$val["fieldname"]]) && !is_array($_CHECKVAL[$val["fieldname"]])) || ($val["isrequired"] == 1 && is_array($_CHECKVAL[$val["fieldname"]]) && !count($_CHECKVAL[$val["fieldname"]])))
		{
			$_CFAILURE[] = $key;
		// ======= REGEXP VALIDATION =======
		} else if (!empty($val["regexpvalidate"]) && !@preg_match($val['regexpvalidate'], $_CHECKVAL[$val["fieldname"]])) {
			if (empty($_CHECKVAL[$val["fieldname"]]) && $val["isrequired"] != 1) {
				// Do nothing
			} else {
				$_CFAILURE[] = $key;
			}
		}
	}

	if (count($_CFAILURE))
	{
		return false;
	}

	return true;
}

/**
* Updates the values for various custom field groups
*/
function updateCustomFields($grouptype, $typeid, $cdepartmentid = false, $linktypeid = false)
{
	global $dbCore, $_SWIFT;

	$customfieldgroups = $customfields = $customfieldgroupidlist = $customfieldidlist = $customfieldvalues = $customfieldoptions = $valuesql = $groupsql = $deletesql = array();
	$groupdata = fetchCustomFieldData($grouptype, $cdepartmentid, $linktypeid);
	if (is_array($groupdata))
	{
		extract($groupdata);
	}

	if (defined("ISMODERNBILLV5") && MBAREA != "submitticket")
	{
		$_CHECKVAL = $_GET;
	} else {
		$_CHECKVAL = $_POST;
	}

	foreach ($customfieldgroups as $groupkey=>$groupval)
	{
		if (!is_array($customfields[$groupval["customfieldgroupid"]]))
		{
			continue;
		}

		$groupsql[] = "('". intval($grouptype) ."', '". intval($typeid) ."', '". intval($groupval["customfieldgroupid"]) ."')";

		foreach ($customfields[$groupval["customfieldgroupid"]] as $key=>$val)
		{
			$deletesql[] = "(`customfieldid` = '". intval($val["customfieldid"]) ."' AND `typeid` = '". intval($typeid) ."')";
			// If the post variable is set, we update the field value
			if (isset($_CHECKVAL[$val["fieldname"]]) && !is_array($_CHECKVAL[$val["fieldname"]]))
			{
				$valuesql[] = "('". intval($val["customfieldid"]) ."', '". intval($typeid) ."', '". $dbCore->escape($_CHECKVAL[$val["fieldname"]]) ."', '0')";
			} else if (is_array($_CHECKVAL[$val["fieldname"]])) {
				foreach ($_CHECKVAL[$val["fieldname"]] as $vkey=>$vval)
				{
					$valuesql[] = "('". intval($val["customfieldid"]) ."', '". intval($typeid) ."', '". $dbCore->escape($vval) ."', '1')";
				}
			}
		}
	}

  // Varun's patch
  if (count($groupsql)) {
    $dbCore->query("REPLACE INTO `". TABLE_PREFIX ."customfieldlinks` (`linktype`, `typeid`, `customfieldgroupid`) VALUES ". implode(",", $groupsql).";");
  }

  if (count($deletesql)) {
    $dbCore->query("DELETE FROM `". TABLE_PREFIX ."customfieldvalues` WHERE ". implode(" OR ", $deletesql).";");
  }

  if (!count($valuesql)) {
    return false;
  }

  $dbCore->query("INSERT INTO `". TABLE_PREFIX ."customfieldvalues` (`customfieldid`, `typeid`, `fieldvalue`, `isserialized`) VALUES ". implode(",", $valuesql).";");

	return true;

}

/**
* Generate the data for client custom fields
*/
function renderClientStaticCustomFields($grouptype, $cdepartmentid = false)
{
	global $dbCore, $_SWIFT, $_CFAILURE;

	$customfieldgroups = $customfields = $customfieldgroupidlist = $customfieldidlist = $customfieldvalues = $customfieldoptions = $render = array();
	$groupdata = fetchCustomFieldData($grouptype, $cdepartmentid);
	if (is_array($groupdata))
	{
		extract($groupdata);
	}

	$index = $findex = 0;
	foreach ($customfieldgroups as $groupkey=>$groupval)
	{
		$render[$findex]["type"] = "desc";
		$render[$findex]["value"] = $groupval["title"];
		$render[$findex]["fields"] = array();
		$fields = &$render[$findex]["fields"];

		if (!is_array($customfields[$groupval["customfieldgroupid"]]))
		{
			continue;
		}

		foreach ($customfields[$groupval["customfieldgroupid"]] as $key=>$val)
		{
			$fields[$index] = $val;
			switch ($val["fieldtype"])
			{
				case FIELD_TEXT:
					$fields[$index]["type"] = "text";
					$fields[$index]["name"] = $val["fieldname"];
					$fields[$index]["title"] = $val["title"];
					$fields[$index]["description"] = $val["description"];
					$fields[$index]["value"] = htmlspecialchars($_POST[$val["fieldname"]]);
					$index++;
					break;
				case FIELD_TEXTAREA:
					$fields[$index]["type"] = "textarea";
					$fields[$index]["name"] = $val["fieldname"];
					$fields[$index]["title"] = $val["title"];
					$fields[$index]["description"] = $val["description"];
					$fields[$index]["value"] = nl2br(htmlspecialchars($_POST[$val["fieldname"]]));
					$index++;
					break;
				case FIELD_PASSWORD:
					$fields[$index]["type"] = "password";
					$fields[$index]["name"] = $val["fieldname"];
					$fields[$index]["title"] = $val["title"];
					$fields[$index]["description"] = $val["description"];
					$fields[$index]["value"] = htmlspecialchars($_SWIFT["language"]["pwhidden"]);
					$index++;
					break;
				case FIELD_CHECKBOX:
					$fields[$index]["type"] = "checkbox";
					$fields[$index]["name"] = $val["fieldname"];
					$fields[$index]["title"] = $val["title"];
					$fields[$index]["description"] = $val["description"];
					$fields[$index]["value"] = returnCFProcessed($val["fieldname"]);
					$index++;
					break;
				case FIELD_RADIO:
					$fields[$index]["type"] = "radio";
					$fields[$index]["name"] = $val["fieldname"];
					$fields[$index]["title"] = $val["title"];
					$fields[$index]["description"] = $val["description"];
					$fields[$index]["value"] = returnCFProcessed($val["fieldname"]);
					$index++;
					break;
				case FIELD_SELECT:
					$fields[$index]["type"] = "select";
					$fields[$index]["name"] = $val["fieldname"];
					$fields[$index]["title"] = $val["title"];
					$fields[$index]["description"] = $val["description"];
					$fields[$index]["value"] = htmlspecialchars($_POST[$val["fieldname"]]);
					$index++;
					break;
				case FIELD_SELECTMULTIPLE:
					$fields[$index]["type"] = "selectmultiple";
					$fields[$index]["name"] = $val["fieldname"];
					$fields[$index]["title"] = $val["title"];
					$fields[$index]["description"] = $val["description"];
					$fields[$index]["value"] = returnCFProcessed($val["fieldname"]);
					$index++;
					break;
				case FIELD_CUSTOM:
					// User will add HTML code for this manually
					break;			
			}
		}

		$findex++;
	}

	return $render;	
}

/**
* Returns the processed custom field values
*/
function returnCFProcessed($fieldname)
{
	$result = array();
	$index = 0;
	if (is_array($_POST[$fieldname]))
	{
		foreach ($_POST[$fieldname] as $key=>$val)
		{
			$result[$index]["value"] = htmlspecialchars($val);
			$index++;
		}
	} else {
		$result = htmlspecialchars($_POST[$fieldname]);
	}

	return $result;
}

/**
* Parses the CF Data
*/
function parseCFData($typeid, &$customfieldidlist, &$customfieldvalues, &$customfielddata, &$customfieldoptions)
{
	global $dbCore;

	$processoptions = false;
	if ($typeid && count($customfieldidlist))
	{
		$processoptions = true;
		$dbCore->query("SELECT * FROM `". TABLE_PREFIX ."customfieldvalues` WHERE `customfieldid` IN (". buildIN($customfieldidlist) .") AND `typeid` = '". intval($typeid) ."';");
		while ($dbCore->nextRecord())
		{
			if ($dbCore->Record["isserialized"] == 1)
			{
				$customfieldvalues[$dbCore->Record["customfieldid"]][] = $dbCore->Record["fieldvalue"];
			} else {
				$customfieldvalues[$dbCore->Record["customfieldid"]] = $dbCore->Record["fieldvalue"];
			}
		}
	}

	if ($processoptions)
	{
		foreach ($customfieldoptions as $key=>$val)
		{
			if ($customfielddata[$key]["fieldtype"] == FIELD_CHECKBOX || $customfielddata[$key]["fieldtype"] == FIELD_RADIO)
			{
				$selecttype = "checked";
			} else if ($customfielddata[$key]["fieldtype"] == FIELD_SELECTMULTIPLE || $customfielddata[$key]["fieldtype"] == FIELD_SELECT) {
				$selecttype = "selected";
			} else {
				continue;
			}
			if ($customfielddata[$key]["fieldtype"] == FIELD_CHECKBOX || $customfielddata[$key]["fieldtype"] == FIELD_SELECTMULTIPLE)
			{
				// Go through all the options and select/unselect based on the available values
				foreach ($val as $optionkey=>$optionval)
				{
					if (@in_array($optionval["value"], $customfieldvalues[$key]))
					{
						$customfieldoptions[$key][$optionkey][$selecttype] = true;
					} else {
						$customfieldoptions[$key][$optionkey][$selecttype] = false;
					}
				}
			} else if ($customfielddata[$key]["fieldtype"] == FIELD_RADIO || $customfielddata[$key]["fieldtype"] == FIELD_SELECT) {
				foreach ($val as $optionkey=>$optionval)
				{
					if (!is_array($customfieldvalues[$key]) && $customfieldvalues[$key] == $optionval["value"])
					{
						$customfieldoptions[$key][$optionkey][$selecttype] = true;
					} else {
						$customfieldoptions[$key][$optionkey][$selecttype] = false;
					}
				}
			}
		}
	}
}


/**
* Generate the data for client custom fields
*/
function renderClientCustomFields($grouptype, $typeid = 0, $cdepartmentid = 0, $linktypeid = false)
{
	global $dbCore, $_SWIFT, $_CFAILURE, $template;

	$customfieldgroups = $customfields = $customfieldgroupidlist = $customfieldidlist = $customfieldvalues = $customfieldoptions = $render = array();
	$groupdata = fetchCustomFieldData($grouptype, $cdepartmentid, $linktypeid);
	if (is_array($groupdata))
	{
		extract($groupdata);
	}

	parseCFData($typeid, $customfieldidlist, $customfieldvalues, $customfielddata, $customfieldoptions);
	$index = $findex = 0;

	foreach ($customfieldgroups as $groupkey=>$groupval)
	{
		$render[$findex]["type"] = "desc";
		$render[$findex]["value"] = $groupval["title"];
		$render[$findex]["fields"] = array();
		$fields = &$render[$findex]["fields"];

		if (!is_array($customfields[$groupval["customfieldgroupid"]]))
		{
			continue;
		}

		foreach ($customfields[$groupval["customfieldgroupid"]] as $key=>$val)
		{
			if (is_array($_CFAILURE) && in_array($val["customfieldid"], $_CFAILURE))
			{
				$val["title"] = '<span class="redtext">'. htmlspecialchars($val["title"]) .'</span>';
			}

			if ($val["isrequired"] == 1)
			{
//				$val["title"] .= '&nbsp;<span class="redtext">*</span>';
			}

			if (!empty($_POST[$val["fieldname"]]))
			{
				$val["defaultvalue"] = htmlspecialchars($_POST[$val["fieldname"]]);
			}

			if (!empty($typeid) && $val["usereditable"] == 0)
			{
				unset($finalvalue);
				if (is_array($customfieldvalues[$val["customfieldid"]]))
				{
					foreach ($customfieldvalues[$val["customfieldid"]] as $valkey=>$valval)
					{
						$finalvalue .= htmlspecialchars($valval)."<BR />".SWIFT_CRLF;
						$fields[$index]["type"] = "hidden";
						$fields[$index]["name"] = $val["fieldname"]."[]";
						$fields[$index]["value"] = htmlspecialchars($valval);
						$index++;
					}
				} else {
					$finalvalue = nl2br(htmlspecialchars($customfieldvalues[$val["customfieldid"]]));
					$fields[$index]["type"] = "hidden";
					$fields[$index]["name"] = $val["fieldname"];
					$fields[$index]["value"] = htmlspecialchars($customfieldvalues[$val["customfieldid"]]);
					$index++;
				}
				if (empty($finalvalue))
				{
					$finalvalue = "&nbsp;";
				}

				$fields[$index]["type"] = "plaintext";
				$fields[$index]["name"] = $val["fieldname"];
				$fields[$index]["title"] = $val["title"];
				$fields[$index]["description"] = $val["description"];
				$fields[$index]["value"] = $finalvalue;   // this should not have htmlspecialchars, because it's specialcharsed above and may contain break elements
				$index++;
				continue;
			}

			$template->assign("cfeditable", true);
			// Render the field data now
			switch ($val["fieldtype"])
			{

				case FIELD_TEXT:
					$fields[$index]["type"] = "text";
					$fields[$index]["name"] = $val["fieldname"];
					$fields[$index]["title"] = $val["title"];
					$fields[$index]["description"] = $val["description"];
					$fields[$index]["isrequired"] = $val["isrequired"];
					$fields[$index]["value"] = iif(empty($customfieldvalues[$val["customfieldid"]]), $val["defaultvalue"], $customfieldvalues[$val["customfieldid"]]);
					$index++;
					break;
				case FIELD_TEXTAREA:
					$fields[$index]["type"] = "textarea";
					$fields[$index]["name"] = $val["fieldname"];
					$fields[$index]["title"] = $val["title"];
					$fields[$index]["description"] = $val["description"];
					$fields[$index]["isrequired"] = $val["isrequired"];
					$fields[$index]["value"] = iif(empty($customfieldvalues[$val["customfieldid"]]), $val["defaultvalue"], $customfieldvalues[$val["customfieldid"]]);
					$index++;
					break;
				case FIELD_PASSWORD:
					$fields[$index]["type"] = "password";
					$fields[$index]["name"] = $val["fieldname"];
					$fields[$index]["title"] = $val["title"];
					$fields[$index]["description"] = $val["description"];
					$fields[$index]["isrequired"] = $val["isrequired"];
					$fields[$index]["value"] = iif(empty($customfieldvalues[$val["customfieldid"]]), $val["defaultvalue"], $customfieldvalues[$val["customfieldid"]]);
					$index++;
					break;
				case FIELD_CHECKBOX:
					$fields[$index]["type"] = "checkbox";
					$fields[$index]["name"] = $val["fieldname"];
					$fields[$index]["title"] = $val["title"];
					$fields[$index]["description"] = $val["description"];
					$fields[$index]["isrequired"] = $val["isrequired"];
					$fields[$index]["value"] = $customfieldoptions[$val["customfieldid"]];
					$index++;
					break;
				case FIELD_RADIO:
					$fields[$index]["type"] = "radio";
					$fields[$index]["name"] = $val["fieldname"];
					$fields[$index]["title"] = $val["title"];
					$fields[$index]["description"] = $val["description"];
					$fields[$index]["isrequired"] = $val["isrequired"];
					$fields[$index]["value"] = $customfieldoptions[$val["customfieldid"]];
					$index++;
					break;
				case FIELD_SELECT:
					$fields[$index]["type"] = "select";
					$fields[$index]["name"] = $val["fieldname"];
					$fields[$index]["title"] = $val["title"];
					$fields[$index]["description"] = $val["description"];
					$fields[$index]["isrequired"] = $val["isrequired"];
					$fields[$index]["value"] = $customfieldoptions[$val["customfieldid"]];
					$index++;
					break;
				case FIELD_SELECTMULTIPLE:
					$fields[$index]["type"] = "selectmultiple";
					$fields[$index]["name"] = $val["fieldname"];
					$fields[$index]["title"] = $val["title"];
					$fields[$index]["description"] = $val["description"];
					$fields[$index]["isrequired"] = $val["isrequired"];
					$fields[$index]["value"] = $customfieldoptions[$val["customfieldid"]];
					$index++;
					break;
				case FIELD_CUSTOM:
					// User will add HTML code for this manually
					break;
			}
		}

		$findex++;
	}

	return $render;
}

/**
* Render the Custom Fields for given group
*/
function renderStaffCustomFields($grouptype, $cdepartmentid = false, $typeid = 0, $linktypeid = false)
{
	global $dbCore, $_SWIFT, $_CFAILURE;

	$customfieldgroups = $customfields = $customfieldgroupidlist = $customfieldidlist = $customfieldvalues = $customfieldoptions = array();
	$groupdata = fetchCustomFieldData($grouptype, $cdepartmentid, $linktypeid);
	if (is_array($groupdata))
	{
		extract($groupdata);
	}

	// If a typeid is set, we also load the related values
	//Mahesh Slaria: Custom Fields edit values.....
	parseCFData($typeid, $customfieldidlist, $customfieldvalues, $customfielddata, $customfieldoptions);
	// Ok! Finally! Phew! Now we have all the required data. We need to first loop through all groups, then the fields and build up the data accordingly
	foreach ($customfieldgroups as $groupkey=>$groupval)
	{
		printDescRow($groupval["title"]);

		foreach ($customfields[$groupval["customfieldgroupid"]] as $key=>$val)
		{
			// We are not allowed to edit this field.
			if (!empty($typeid) && $val["staffeditable"] == 0)
			{
				unset($finalvalue);
				if (is_array($customfieldvalues[$val["customfieldid"]]))
				{
					foreach ($customfieldvalues[$val["customfieldid"]] as $valkey=>$valval)
					{
						$finalvalue .= htmlspecialchars($valval)."<BR />".SWIFT_CRLF;
						addHiddenField($val["fieldname"]."[]", $valval);
					}
				} else {
					$finalvalue = $customfieldvalues[$val["customfieldid"]];
					addHiddenField($val["fieldname"], $customfieldvalues[$val["customfieldid"]]);
				}
				if (empty($finalvalue))
				{
					$finalvalue = "&nbsp;";
				}

				printDefaultRow('<span class="tabletitle">'. $val["title"] .'</span>'. iif($val["description"], '<BR /><span class="tabledescription">'. $val["description"] .'</span>'), $finalvalue);
				continue;
			}

			if (is_array($_CFAILURE) && in_array($val["customfieldid"], $_CFAILURE))
			{
				$val["title"] = '<span class="redtext">'. htmlspecialchars($val["title"]) .'</span>';
			}

			if ($val["isrequired"] == 1)
			{
				$val["title"] .= '&nbsp;<span class="redtext">*</span>';
			}

			if (!empty($_POST[$val["fieldname"]]))
			{
				$val["defaultvalue"] = $_POST[$val["fieldname"]];
			}
			
			// We have to display editable stuff now
			switch ($val["fieldtype"])
			{
				
				// jch may 28 08 added maxlength clause to field_text and field_textarea to close bug 464
				
				case FIELD_TEXT:
					printTextRow($val["fieldname"], $val["title"], $val["description"], "text", iif(empty($customfieldvalues[$val["customfieldid"]]), $val["defaultvalue"], $customfieldvalues[$val["customfieldid"]]), "30", "255");
					break;
				case FIELD_TEXTAREA:
					printTextareaRow($val["fieldname"], $val["title"], $val["description"], iif(empty($customfieldvalues[$val["customfieldid"]]), $val["defaultvalue"], $customfieldvalues[$val["customfieldid"]]), "50", "4", false, '', '', 255);
					break;
				case FIELD_PASSWORD:
					printTextRow($val["fieldname"], $val["title"], $val["description"], "password", iif(empty($customfieldvalues[$val["customfieldid"]]), $val["defaultvalue"], $customfieldvalues[$val["customfieldid"]]));
					break;
				case FIELD_CHECKBOX:
					printCheckboxListRow($val["fieldname"], $val["title"], $val["description"], $customfieldoptions[$val["customfieldid"]]);
					break;
				case FIELD_RADIO:
					printRadioRow($val["fieldname"], $val["title"], $val["description"], $customfieldoptions[$val["customfieldid"]]);
					break;
				case FIELD_SELECT:
					printSelectRow($val["fieldname"], $val["title"], $val["description"], $customfieldoptions[$val["customfieldid"]]);
					break;
				case FIELD_SELECTMULTIPLE:
					printSelectMultipleRow($val["fieldname"], $val["title"], $val["description"], $customfieldoptions[$val["customfieldid"]], 6, "300");
					break;
				case FIELD_CUSTOM:
					printDefaultRow('<span class="tabletitle">'. $val["title"] .'</span>'. iif($val["description"], '<BR /><span class="tabledescription">'. $val["description"] .'</span>'), $val["defaultvalue"]);
					break;			
			}
		}
	}

	// I cant believe I finished the above crap.. god I hate big functions.
	return true;
}
?>