<?php
//=======================================
//###################################
// Kayako Infotech Ltd. - SWIFT Framework
//
// Source Copyright 2001-2008 Kayako Infotech Ltd.
// Unauthorized reproduction is not allowed
// License Number: $%LICENSE%$
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//                   www.kayako.com
//###################################
//=======================================

if (!defined("INSWIFT")) {
	trigger_error("Unable to process " . htmlentities($_SERVER['PHP_SELF']), E_USER_ERROR);
}


/**
* Send SMS Alert using Kayako Gateway
*/
function sendSMSAlert(&$ticketobj, $cellnumber, $message)
{
	global $dbCore, $_SWIFT, $template;

	if ($_SWIFT["settings"]["gateway_enable"] != 1)
	{
		return false;
	}

	$data = implode("", file("http://master.kayako.net/gateway.php?username=".urlencode($_SWIFT["settings"]["gateway_username"])."&password=".urlencode($_SWIFT["settings"]["gateway_password"]) ."&message=".urlencode($message) ."&number=".urlencode($cellnumber)));

	if (trim($data) != "0" && $_SWIFT["settings"]["gat_emailfailure"] == 1) {
		// Somethin went wrong while sending the message. Send a Status Delivery report to the admin user
		$_staff = $dbCore->queryFetch("SELECT * FROM `". TABLE_PREFIX ."staff` AS staff LEFT JOIN `". TABLE_PREFIX ."staffgroup` AS staffgroup ON (staff.staffgroupid = staffgroup.staffgroupid) WHERE staffgroup.isadmin = '1' LIMIT 1;");
		if (empty($_staff["staffid"]))
		{
			return false;
		}

		// See if tgroupid is set?
		$template->setGroup(iif(empty($ticketobj->ticket["tgroupid"]), 1, $ticketobj->ticket["tgroupid"]));

		$template->loadLanguageSection("ticketemails", TEMPLATE_DB);

		$ticketobj->loadTemplateVariables();
		$template->assign("deliverytime", edate($_SWIFT["settings"]["dt_datetimeformat"], DATENOW));
		$template->assign("cellnumber", $cellnumber);
		$template->assign("message", $message);
		$template->assign("gatewayresult", $data);
		$template->assign("ishtml", true);
		$_templateresulthtml = $template->displayTemplate("email_smsreport", TEMPLATE_DB);
		$template->assign("ishtml", false);
		$_templateresulttext = $template->displayTemplate("email_smsreport", TEMPLATE_DB);

		require_once ("./includes/functions_mail.php");
		$mailObj = new SWIFT_Mail();

		$mailObj->setSubject($ticketobj->getEmailSubject(SUBJECT_USER, $_SWIFT["language"]["smsfailure"]));
		$mailObj->setData($_templateresulthtml, $_templateresulttext);
		$returnemail = $ticketobj->getReturnEmail();
		$returnname = $ticketobj->getReturnName();
		$mailObj->sendMail(array($_staff["email"]), $returnemail, $returnname, true);

		return false;
	}

	return true;
}
?>