<?php
//=======================================
//###################################
// Kayako Infotech Ltd. - SWIFT Framework
//
// Source Copyright 2001-2008 Kayako Infotech Ltd.
// Unauthorized reproduction is not allowed
// License Number: $%LICENSE%$
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//                   www.kayako.com
//###################################
//=======================================

if (!defined("INSWIFT")) {
    trigger_error("Unable to process " . htmlentities($_SERVER['PHP_SELF']), E_USER_ERROR);
}

$__LANG = array (
    'diagnostics' => 'Diagnostics',
    'phpinfo' => 'PHP Info',
    'desc_phpinfo' => 'Your server\'s PHP configuration details are listed below. For more information on the phpinfo() function visit <a href="http://www.php.net/phpinfo" target="_blank">http://www.php.net/phpinfo</a>.',
    'mysqlinfo' => 'MySQL Info',
    'desc_mysqlinfo' => 'Your server\'s MySQL configuration details are listed below. The value of these variables are specified in the my.cnf file which is usually located in the <i>etc</i> directory.',
    'variable' => 'Variable',
    'value' => 'Value',
    'cachetitle' => 'Cache Title',
    'cacheinfo' => 'Cache Info',
    'desc_cacheinfo' => 'Frequently generated information and data is cached, reducing the requirement to run repetitive database queries.',

    // Report Bug
    'reportbug' => 'Report Bug',
    'desc_reportbug' => 'You can report a bug to the Kayako team by providing a brief description of the issue below. It is recommended that you keep the debug information, as it helps us trace the problem more quickly. Please make sure that the e-mail address specified is correct.',
    'bugdetails' => 'Bug Report',
    'submitbug' => 'Submit Bug',
    'bugsubject' => 'Subject',
    'desc_bugsubject' => 'Enter a subject for the bug report.',
    'bugfromname' => 'Full Name',
    'desc_bugfromname' => 'Enter your name or the name of the person who should be contacted at your organization.',
    'bugfromemail' => 'E-mail Address',
    'desc_bugfromemail' => 'This is the e-mail address that is used as the <b>From</b> address for the report dispatched to Kayako. Please make sure this is a valid e-mail address.',
    'debuginfo' => '### Debug Info ###',
    'dphpversion' => 'PHP Version: %s',
    'dphpuploadsize' => 'Max Upload Size: %s',
    'dphpsafemode' => 'Safe Mode: %s',
    'dswifturl' => 'Installation URL: %s',
    'dswiftproduct' => 'Product: %s',
    'dswiftversion' => 'Version: %s',
    'dswiftbuilddate' => 'Build Date: %s',
    'dswiftbuildtype' => 'Build Type: %s',
    'dmysqlversion' => 'MySQL Version: %s',
    'duseragent' => 'User Agent: %s',
    'dserversoftware' => 'Server Software: %s',
    'dos' => 'Operating System: %s',
    'specifyvalidemail' => 'ERROR: Please specify a valid e-mail address',
    'bugreportdispatched' => 'Bug report dispatched to bugs@kayako.com',

    // for admin bug report dialog, new fields added feb 11 2008 by jch
	'php_ini_memory_limit'                  => 'php.ini script RAM allocation limit: %s',
	'php_uname'                             => 'Server extended OS information: %s',
	'swift_language_base_charset'           => 'SWIFT Language base charset: %s',
	'swift_language_html_charset'           => 'SWIFT Language html charset: %s',
	'swift_language_text_charset'           => 'SWIFT Language text charset: %s',
	'swift_language_html_encoding'          => 'SWIFT Language html encoding: %s',
	'swift_language_text_encoding'          => 'SWIFT Language text encoding: %s',
	'php_installed_modules'                 => 'PHP modules installed: %s',
	'disk_free_space'                       => 'Current server free disk space: %s of %s bytes',
	'php_ini_max_execution_time'            => 'PHP INI Max Execution Time: %s',
	'php_ini_display_errors'                => 'PHP Error Display: %s',
	'php_ini_quiet_eval'                    => 'PHP Quiet Evaluation Mode: %s',
	'php_ini_error_reporting'               => 'PHP Error Reporting Level: %s',
	'php_ini_output_buffering'              => 'PHP Output Buffering: %s',
	'zend_version'                          => 'Zend Version: %s',
	'php_ini_register_globals'              => 'Register Globals: %s',
	'php_ini_magic_quotes_gpc'              => 'Magic Quotes GPC: %s',
	'php_ini_magic_quotes_runtime'          => 'Magic Quotes Runtime: %s',
	'php_ini_post_max_size'                 => 'Maximum POST size: %s',
	'php_ini_upload_max_size'               => 'Maximum upload size: %s',
	'php_ini_allow_calltime_pass_reference' => 'PHP allows call-time reference passage: %s',
	'php_ini_allow_url_fopen'               => 'PHP allows URL fopen(): %s',
	'php_ini_always_populate_raw_post_data' => 'Force-populate POST with raw data: %s',
	'php_ini_default_charset'               => 'Server default character set: %s',
	'php_ini_default_mimetype'              => 'Server default MIME type: %s',
	'php_ini_display_startup_errors'        => 'PHP displays startup errors: %s',
	'php_ini_expose_php'                    => 'PHP is exposed: %s',
	'php_ini_ignore_repeated_errors'        => 'PHP ignores repeat errors: %s',
	'php_ini_max_input_time'                => 'INI Max output time: %s',
	'php_ini_output_handler'                => 'Global output handler: %s',
	'php_ini_report_zend_debug'             => 'Report Zend debugging calls: %s',
	'php_ini_safe_mode'                     => 'PHP is in safe mode: %s',
	'php_ini_bug_compat_42'                 => 'INI Compatibility mode 42: %s',
	'php_ini_bug_compat_warn'               => 'Warn of INI compatibility modes: %s',
	'php_ini_track_errors'                  => 'PHP tracks errors: %s',
	'php_ini_upload_max_filesize'           => 'Maximum file upload size: %s',
	'php_ini_zend_1_compatibility_mode'     => 'Zend 1 compatibility mode: %s',
	'php_rusage'                            => 'RUsage: %s',
		 
    // License Information
    'licenseinfo' => 'License Information',
    'desc_licenseinfo' => '',
    'liccreated' => 'Created On: ',
    'licnever' => '-- Never --',
    'licexpiry' => 'Expiration Date: ',
    'licuniqueid' => 'Unique ID: ',
    'licproduct' => 'Product: ',
    'licdomains' => 'Registered Domains',
    'licdomform' => 'Domain #%s',
    'licfullname' => 'Registered Name: ',

    // Active Sessions
    'activesessions' => 'Active Sessions',
    'desc_activesessions' => '',
    'sess'.SESSION_API => 'API',
    'sess'.SESSION_STAFF => 'Staff',
    'sess'.SESSION_ADMIN => 'Admin',
    'sess'.SESSION_CLIENT => 'Client',
    'sess'.SESSION_WINAPP => 'Winapp',
    'sess'.SESSION_CLI => 'CLI',
    'sess'.SESSION_VISITOR => 'Visitor',
    'sess'.SESSION_WAP => 'WAP',
    'sess'.SESSION_CHAT => 'Chat',
    'sess'.SESSION_MONITOR => 'Monitor',
    'sess'.SESSION_SYNCML => 'SyncML',
    'sess'.SESSION_ARCHIVE => 'Archive',
    'sess'.SESSION_PDA => 'PDA',
    'sess'.SESSION_RSS => 'RSS',
    'sess'.SESSION_SYNCWORKS => 'SyncWorks',
    'sess'.SESSION_INSTAALERT => 'InstaAlert',
    'sessionlist' => 'Session List',
    'ipaddress' => 'IP Address',
    'lastactivity' => 'Last Activity',
    'sessiontype' => 'Session Type',
    'useragent' => 'User Agent',
    'killsession' => 'Kill Session',
    'sessiondelconfirm' => 'Session killed successfully',
);

?>