<?php
//=======================================
//###################################
// Kayako Infotech Ltd. - SWIFT Framework
//
// Source Copyright 2001-2008 Kayako Infotech Ltd.
// Unauthorized reproduction is not allowed
// License Number: $%LICENSE%$
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//                   www.kayako.com
//###################################
//=======================================

/**
* BASE LANGUAGE CODES
*/

global $_SWIFT;

$__LANG = array (
  /*
   *  **** NOTICE ****
   *
   * The following entries control the encoding of the help desk in several ways:
   *
   * 1. The encoding used when rendering HTML pages in web browsers
   * 2. The encoding used when inserting data into the database
   * 3. The encoding used when sending e-mails from the desk
   *
   * The default setting, UTF-8, is sufficient for most languages and help desk usage scenarios.
   * UTF-8 is designed to alleviate problems encountered often when dealing with different codepages.
   * For example, if the help desk is in UTF-8, and someone sends an e-mail in Russian KOI8-R, the desk will
   * correctly convert it to UTF-8 and it will be displayable.  Someone else could then send an e-mail in
   * Greek ISO-8859-7 and it again would be converted to UTF-8 and would also be displayable along side the
   * Russian ticket and others.
   *
   * In contrast, if you change the settings below to something other than UTF-8, say KOI8-R, and an e-mail arrives
   * in another codepage, say Greek ISO-8859-7, the desk will attempt to convert it to KOI8-R, which will fail.  The ticket will contain
   * nothing but jibberish characters.
   *
   * In another scenario, if you set up your help desk while it is configured to use UTF-8 and then later change the encoding,
   * your database will contain UTF-8 information, but your pages and other information will be rendered in a different encoding, causing problems.
   * 
   * DO NOT modify these settings unless you are aware of the potential consequences.
   *
   * In addition, you should be aware that only the "charset" variable below is actually controlled from here.  The others
   * are all overwritten by values in the current language pack, so if you change these values, make sure to change them in
   * the language pack as well.
   */
  'charset'       => 'UTF-8',
  'html_encoding' => '8bit',
  'text_encoding' => '8bit',
  'html_charset'  => 'UTF-8',
  'text_charset'  => 'UTF-8',
  /* END encoding settings */
  'yes' => 'Yes',
  'no' => 'No',
  'short_all_tickets' => 'All',
  'module_notreg' => '%s module is not registered',
  'event_notreg' => '%s event is not registered',
  'unable_to_execute' => 'Unable to execute %s',
  'action_notreg' => '%s action is not registered',
  'username' => 'Username',
  'password' => 'Password',
  'rememberme' => 'Remember Me',
  'defaultloginapi' => SWIFTPRODUCT .' Login Routine',
  'login' => 'Login',
  'first' => 'First',
  'last' => 'Last',
  'pagination' => 'Page %s of %s',
  'yes' => 'Yes',
  'no' => 'No',
  'submit' => 'Submit',
  'reset' => 'Reset',
  'poweredby' => 'Powered by %s',
  'copyright' => 'Copyright &copy; 2001-%s Kayako Infotech Ltd.',  
  'invaliduser' => 'Invalid Username or Password',
  'invalid_sessionid' => 'Session Expired Due to Inactivity',
  'staff_not_admin' => 'User does not have admin privileges',
  'redirect_login' => 'Processing Login...',
  'redirect_dashboard' => 'Redirecting to Dashboard...',
  'no_wait' => 'Please click here if your browser does not automatically redirect you',
  'select_un_all' => 'Select/Unselect All Items',
  'sort_desc' => 'Sort Descending',
  'sort_asc' => 'Sort Ascending',
  'options' => 'Options',
  'delete' => 'Delete',
  'settings' => 'Settings',
  'search' => 'Search',
  'quicksearch' => 'Quick Search',
  'mass_action' => 'Mass Action',
  'massfieldaction' => 'Action: ',
  'advanced_search' => 'Advanced Search',
  'searchfieldquery' => 'Query: ',
  'searchfieldfield' => 'Field: ',
  'searchbutton' => 'Search',
  'settingsfieldresultsperpage' => 'Results Per Page: ',
  'actionconfirm' => 'Are you sure you wish to continue?',
  'clidefault' => "%s v%s\nCopyright (c) 2001-%s Kayako Infotech Ltd.\n",
  'loggedout' => 'Logged out successfully',
  'firstselect' => '- Select -',
  'exportasxml' => 'XML',
  'exportascsv' => 'CSV',
  'exportassql' => 'SQL',
  'exportaspdf' => 'PDF',
  'view' => 'View',
  'dashboard' => 'Dashboard',
  'help' => 'Help',
  'size' => 'Size',
  'home' => 'Home',
  'logout' => 'Logout',
  'clientarea' => 'Support Center',
  'staffcp' => 'Staff CP',
  'admincp' => 'Admin CP',
  'winapp' => 'Winapp',
  'pdainterface' => 'PDA Interface',
  'bytes' => 'Bytes',
  'kb' => 'KiB',
  'mb' => 'MiB',
  'gb' => 'GiB',
  'thousandsseperator' => ',',
  'manage' => 'Manage',
  'title' => 'Title',
  'disable' => 'Disable',
  'enable' => 'Enable',
  'edit' => 'Edit',
  'back' => 'Back',
  'forward' => 'Forward',
  'insert' => 'Insert',
  'edit' => 'Edit',
  'update' => 'Update',
  'public' => 'Public',
  'private' => 'Private',
  'requiredfieldempty' => 'One of the required field(s) is empty',
  'clierror' => '[ERROR]: ',
  'cliwarning' => '[WARNING]: ',
  'cliok' => '[OK]: ',
  'cliinfo' => '[INFO]: ',
  'clifatalerror' => 'FATAL ERROR',
  'clienterchoice' => 'Please Type your Choice: ',
  'clinotvalidchoice' => '"%s" is Not a Valid Choice: ',
  'description' => 'Description',
  'success' => 'Success',
  'failure' => 'Failure',
  'status' => 'Status',
  'date' => 'Date',
  'seconds' => 'Seconds',
  'email' => 'E-mail',
  'subject' => 'Subject',
  'contents' => 'Contents',
  'sections' => 'Sections',
  'twodesc' => '%s (%s)', // Change only for RTL Languages
  'sunday' => 'Sunday',
  'monday' => 'Monday',
  'tuesday' => 'Tuesday',
  'wednesday' => 'Wednesday',
  'thursday' => 'Thursday',
  'friday' => 'Friday',
  'saturday' => 'Saturday',
  'hourrenderus' => '%s:%s %s',
  'hourrendereu' => '%s:%s',
  'am' => 'AM',
  'pm' => 'PM',
  'jump' => 'Jump',
  'newprvmsgconfirm' => 'You have a new private message\nClick OK to open the private message list in a new window.',
  'nopermission' => 'ERROR: You do not have proper permissions to carry out this action.<BR />You can edit the Group Access Masks under <i>Admin CP &gt; Staff &gt; Manage Groups &gt; Edit</i>',
    'generationdate' => 'XML Generated On: %s',
    'commentdelconfirm' => 'Comment deleted successfully',
    'commentstatusconfirm' => 'Comment status change completed successfully',
    'commentupdconfirm' => 'Comment by "%s" updated successfully',
    'unapprove' => 'Unapprove',
    'approve' => 'Approve',
    'approvedcomments' => 'Approved Comments',
    'unapprovedcomments' => 'Unapproved Comments',
    'fullname' => 'Full Name',
    'editcomment' => 'Edit Comment',
    'onlineusers' => 'Online Staff',
    'quickjump' => 'Quick Jump',
    'vardate1' => '%dd%dh%dm',
    'vardate2' => '%dh%dm%ds',
    'vardate3' => '%dm%ds',
    'vardate4' => '%ds',
    'choiceadd' => 'Add >',
    'choicerem' => '< Remove',
    'choicemup' => 'Move Up',
    'choicemdn' => 'Move Down',
    'ticketsubjectformat' => '[%s#%s]: %s',
    'forwardticketsubjectformat' => '[%s~%s]: %s',
    'loggedinas' => 'Logged In: ',
    'tcustomize' => 'Customize...',
    'reports' => 'Reports',
    'demomode' => 'Cannot carry out action in demo mode',
    'viewall' => 'View All',
    'allpages' => 'All Pages',
	'iprestrictdenial' => 'Access Denied (%s): IP not allowed (%s), please add the IP in the allowed list under /config/config.php',

    /**
    * ###############################################
    * MODULE LIST
    * ###############################################
    */
    'module_tickets' => 'Tickets',
    'module_bugs' => 'Bugs',
    'module_knowledgebase' => 'Knowledgebase',
    'module_parser' => 'Mail Parser',
    'module_livesupport' => 'Live Support',
);


if (SWIFT_AREA == SWIFT_ADMIN)
{
    /**
    * Admin Area Navigation Bar
    */

    $_SWIFT["adminbar"] = array (

        14 => array ('Settings', 'bar_settings.gif', MODULE_CORE, '', '', 'index.php?_m=core&_a=settings'),
        0 => array ('Templates', 'bar_templates.gif', MODULE_CORE),
        1 => array ('Languages', 'bar_languages.gif', MODULE_CORE),
        2 => array ('Custom Fields', 'bar_customfields.gif', MODULE_CORE),
        13 => array ('Live Support', 'bar_livesupport.gif', MODULE_LIVESUPPORT),
        3 => array ('Reports', 'bar_reports.gif', 'reports'),
        4 => array ('Mail Parser', 'bar_mailparser.gif', MODULE_PARSER),
        5 => array ('Tickets', 'bar_tickets.gif', MODULE_TICKETS),
        6 => array ('SLA', 'bar_sla.gif', MODULE_TICKETS),
        7 => array ('Escalations', 'bar_escalations.gif', MODULE_TICKETS),
        17 => array ('Reports', 'bar_reports.gif', MODULE_REPORTS),
        15 => array ('Teamwork', 'bar_teamwork.gif', MODULE_TEAMWORK),
        16 => array ('Ticket Purchaser', 'bar_teamwork.gif', MODULE_PURCHASE),
        8 => array ('Bugs', 'bar_bugs.gif', 'bugs'),
        9 => array ('Logs', 'bar_logs.gif', MODULE_CORE),
        10 => array ('Scheduled Tasks', 'bar_cron.gif', MODULE_CORE),
        11 => array ('Database', 'bar_database.gif', MODULE_CORE),
        12 => array ('Diagnostics', 'bar_diagnostics.gif', MODULE_CORE),

    );

    $_SWIFT["adminbaritems"] = array (
        0 => array (
                0 => array ('Manage Groups', 'index.php?_m=core&_a=managetemplategroups'),
                1 => array ('Manage Templates', 'index.php?_m=core&_a=managetemplates'),
                2 => array ('Insert Group', 'index.php?_m=core&_a=inserttemplategroup'),
                3 => array ('Search Templates', 'index.php?_m=core&_a=searchtemplates'),
                4 => array ('LoginShare', 'index.php?_m=core&_a=manageloginshare'),
                5 => array ('Import/Export', 'index.php?_m=core&_a=importexporttemplates'),
                6 => array ('Restore Templates', 'index.php?_m=core&_a=restoretemplates'),
                7 => array ('Diagnostics', 'index.php?_m=core&_a=templatediagnostics'),
            ),

        1 => array (
                0 => array ('Manage Languages', 'index.php?_m=core&_a=managelanguages'),
                1 => array ('Manage Phrases', 'index.php?_m=core&_a=managephrases'),
                2 => array ('Insert Language', 'index.php?_m=core&_a=insertlanguage'),
                3 => array ('Search Phrases', 'index.php?_m=core&_a=searchlanguage'),
                4 => array ('Import/Export', 'index.php?_m=core&_a=importexportlanguage'),
            ),

        2 => array (
                0 => array ('Manage Groups', 'index.php?_m=core&_a=managecfgroups'),
                1 => array ('Manage Fields', 'index.php?_m=core&_a=managecfields'),
                2 => array ('Insert Group', 'index.php?_m=core&_a=insertcfgroup'),
                3 => array ('Insert Field', 'index.php?_m=core&_a=insertcfield'),
            ),

        4 => array (
                0 => array ('Manage E-mail Queues', 'index.php?_m=parser&_a=manageemailqueues'),
				1 => array ('Manage Parser Rules', 'index.php?_m=parser&_a=managerules'),
                2 => array ('Manage Breaklines', 'index.php?_m=parser&_a=managebreaklines'),
                3 => array ('Manage E-mail Bans', 'index.php?_m=parser&_a=emailbans'),
                4 => array ('Manage Loop Blockages', 'index.php?_m=parser&_a=manageloopblockage'),
				5 => array ('Manage Loop Rules', 'index.php?_m=parser&_a=managelooprules'),
                6 => array ('Insert New E-mail Queue', 'index.php?_m=parser&_a=insertemailqueue'),
                7 => array ('Insert New Parser Rule', 'index.php?_m=parser&_a=insertparserrule'),
                8 => array ('Insert New Breakline', 'index.php?_m=parser&_a=managebreaklines&showinsertbreakline=1'),
                9 => array ('Insert New E-mail Ban', 'index.php?_m=parser&_a=emailbans&showinsertban=1'),
               10 => array ('Catch-All Rules', 'index.php?_m=parser&_a=catchallrules'),
		       11 => array ('Parser Log', 'index.php?_m=parser&_a=parserlog&offset=0'),
		),
			
			
        5 => array (
                0 => array ('Manage Statuses', 'index.php?_m=tickets&_a=managestatus'),
                1 => array ('Manage Priorities', 'index.php?_m=tickets&_a=managepriorities'),
                2 => array ('Attachment Types', 'index.php?_m=tickets&_a=attachmenttypes'),
                3 => array ('Insert Status', 'index.php?_m=tickets&_a=insertstatus'),
                4 => array ('Insert Priority', 'index.php?_m=tickets&_a=insertpriority'),
                5 => array ('Purge Attachments', 'index.php?_m=tickets&_a=purgeattachments'),
                6 => array ('Maintenance', 'index.php?_m=tickets&_a=maintenance'),

            ),

        6 => array (
                0 => array ('Manage Plans', 'index.php?_m=tickets&_a=manageplans'),
                1 => array ('Manage Schedules', 'index.php?_m=tickets&_a=manageschedules'),
                3 => array ('Insert Plan', 'index.php?_m=tickets&_a=insertplan'),
                4 => array ('Insert Schedule', 'index.php?_m=tickets&_a=insertschedule'),
            ),

        7 => array (
                0 => array ('Manage Rules', 'index.php?_m=tickets&_a=manageescalationrules'),
                1 => array ('Insert New Rule', 'index.php?_m=tickets&_a=insertescalationrule'),
        ),

        17 => array (
                0 => array ('Manage Permissions', 'index.php?_m=tickets&_a=manageescalationrules'),
                1 => array ('Manage Events', 'index.php?_m=tickets&_a=insertescalationrule'),
                2 => array ('Insert Event', 'index.php?_m=tickets&_a=insertescalationrule'),
        ),

        9 => array (
                1 => array ('Task Log', 'index.php?_m=core&_a=tasklog'),
        ),

        10 => array (
                0 => array ('Manage', 'index.php?_m=core&_a=managetasks'),
                1 => array ('Task Log', 'index.php?_m=core&_a=tasklog'),
            ),

        11 => array (
                0 => array ('Repair/Optimize', 'index.php?_m=core&_a=repair'),
                1 => array ('Backup', 'index.php?_m=core&_a=backup'),
            ),

        12 => array (
                0 => array ('Active Sessions', 'index.php?_m=core&_a=activesessions'),
                1 => array ('Cache Info', 'index.php?_m=core&_a=cacheinfo'),
                2 => array ('PHP Info', 'index.php?_m=core&_a=phpinfo'),
                3 => array ('MySQL Info', 'index.php?_m=core&_a=mysqlinfo'),
                4 => array ('Report Bug', 'index.php?_m=core&_a=reportbug'),
                5 => array ('License Info', 'index.php?_m=core&_a=licenseinfo'),
                6 => array ('Rebuild Cache', '../staff/index.php?_ca=rebuildcache&verbose=1'),
            ),

        13 => array (
                0 => array ('Visitor Bans', 'index.php?_m=livesupport&_a=visitorbans'),
            ),

        15 => array (
                0 => array ('Manage Statuses', 'index.php?_m=teamwork&_a=managestatus'),
                1 => array ('Manage Priorities', 'index.php?_m=teamwork&_a=managepriorities'),
                2 => array ('Manage Labels', 'index.php?_m=teamwork&_a=managelabels'),
                3 => array ('Manage Categories', 'index.php?_m=teamwork&_a=managecategories'),
                4 => array ('Insert Status', 'index.php?_m=teamwork&_a=insertstatus'),
                5 => array ('Insert Priority', 'index.php?_m=teamwork&_a=insertpriority'),
                6 => array ('Insert Label', 'index.php?_m=teamwork&_a=insertlabel'),
                7 => array ('Insert Category', 'index.php?_m=teamwork&_a=insertcategory'),
            ),

        16 => array (
                0 => array ('Manage System Packages', 'index.php?_m=purchase&_a=managepackages'),
                1 => array ('Insert System Package', 'index.php?_m=purchase&_a=insertpackage'),
                2 => array ('Manage Invoices', 'index.php?_m=purchase&_a=manageinvoices'),
                3 => array ('Create Invoice', 'index.php?_m=purchase&_a=createinvoice'),
                4 => array ('Manage Orders', 'index.php?_m=purchase&_a=manageorders'),
                5 => array ('Create Order', 'index.php?_m=purchase&_a=createorder'),
                6 => array ('Manage Users', 'index.php?_m=purchase&_a=manageusers'),
                7 => array ('Create User', 'index.php?_m=purchase&_a=createuser'),
            ),

    );

    // Log stuff
    if (SWIFTPRODUCT == "SupportSuite" || SWIFTPRODUCT == "eSupport")
    {
        $_SWIFT["adminbaritems"][9][2] = array ('Parser Log', 'index.php?_m=parser&_a=parserlog&offset=0');
    }


    /**
    * Admin Area Menu Links
    * Translate the Highlighted Text: 0 => array (>>>'Home'<<<, 100),
    * ! IMPORTANT ! The following array does NOT have a Zero based index
    */

    $_SWIFT["adminmenu"] = array (

        1 => array ('Home', 80, NULL, 1),
        2 => array ('Staff', 100, NULL, 2),
        3 => array ('Departments', 120, NULL, 3),
    );

    /**
    * Item Format Example: 0 => array ('Name Of Item to Display', 'www.link-to-item.com', PREFIX_SPACING, SUFFIX_BAR_AND_SPACING),
    * The PREFIX_SPACING and SUFFIX_BAR_AND_SPACING are required for the theme to display the seperater items for the menu items
    */
    $_SWIFT["adminlinks"] = array (

        1 => array (
                0 => array ('Dashboard', "index.php?_m=core&_a=dashboard", false, true),
                1 => array ('Settings', 'index.php?_m=core&_a=settings', true, true),
                2 => array ('Help', 'index.php?_m=core&_a=help', true, false),
                ),

        2 => array (
                0 => array ('Manage Staff', 'index.php?_m=core&_a=managestaff', false, true),
                1 => array ('Manage Groups', 'index.php?_m=core&_a=managestaffgroups', true, true),
                2 => array ('Insert Staff', 'index.php?_m=core&_a=insertstaff', true, true),
                3 => array ('Insert Group', 'index.php?_m=core&_a=insertstaffgroup', true, true),
                4 => array ('Mass Mail', 'index.php?_m=core&_a=staffmassmail', true, false),
                ),

        3 => array (
                0 => array ('Manage Departments', 'index.php?_m=core&_a=managedepartments', false, true),
                1 => array ('Insert New', 'index.php?_m=core&_a=insertdepartment', true, false)
                ),
    );
} else if (SWIFT_AREA == SWIFT_STAFF) {
    /**
    * Staff Area Menu Links
    * Translate the Highlighted Text: 0 => array (>>>'Home'<<<, 100),
    * ! IMPORTANT ! The following array does NOT have a Zero based index
    */

    $_SWIFT["staffmenu"] = array (
        1 => array ('Home', 80, MODULE_CORE, 1),
        2 => array ('Tickets', 100, MODULE_TICKETS, 2, 't_entab'),
        3 => array ('Live Support', 120, MODULE_LIVESUPPORT, 3, 'ls_entab'),
        8 => array ('Teamwork', 120, MODULE_TEAMWORK, 2, 'tw_entab'),
        4 => array ('Knowledgebase', 140, MODULE_KNOWLEDGEBASE, 4, 'kb_entab'),
        5 => array ('Downloads', 110, MODULE_DOWNLOADS, 5, 'dl_entab'),
        6 => array ('Troubleshooter', 140, MODULE_TROUBLESHOOTER, 6, 'tr_entab'),
        7 => array ('News', 90, MODULE_NEWS, 1, 'nw_entab'),
        9 => array ('Users', 90, MODULE_CORE, 3, 'cu_entab'),
    );

    /**
    * Item Format Example: 0 => array ('Name Of Item to Display', 'www.link-to-item.com', PREFIX_SPACING, SUFFIX_BAR_AND_SPACING),
    * The PREFIX_SPACING and SUFFIX_BAR_AND_SPACING are required for the theme to display the seperater items for the menu items
    */
    $_SWIFT["stafflinks"] = array (

        1 => array (
                0 => array ('Dashboard', "index.php?_m=core&_a=dashboard", false, true),
                1 => array ('Preferences', '#', true, true, array("dpreferences", "MENU_PREFERENCES")),
                2 => array ('Private Messages%PRV%', 'index.php?_m=core&_a=privatemessages', true, false),
                ),

        2 => array (
                0 => array ('Manage Tickets', 'index.php?_m=tickets&_a=manage', false, true),
                1 => array ('Search', '#', true, true, array("ticketsearch", "MENU_TICKETSEARCH")),
                2 => array ('New Ticket', '#', true, true, array("newticket", "MENU_TICKETNEW")),
                3 => array ('Predefined Replies', '#', true, true, array("ticketpred", "MENU_TICKETPRED")),
                4 => array ('Alerts', '#', true, true, array("ticketalerts", "MENU_TICKETALERTS")),
                6 => array ('Filters', '#', true, true, array("ticketfilters", "MENU_TICKETFILTERS")),
                5 => array ('Reports', '#', true, false, array("reportt", "MENU_T_REPORTS")),
                ),

        3 => array (
                0 => array ('Messages', '#', false, true, array("lsmsgs", "MENU_LSMESSAGES")),
                1 => array ('Chat History', 'index.php?_m=livesupport&_a=chathistory', true, true),
                2 => array ('Ad Tracking', '#', true, true, array("lsadtracking", "MENU_LSADTRACKING")),
                3 => array ('Canned', '#', true, true, array("lscanned", "MENU_LSCANNED")),
                4 => array ('Tag Generator', '#', true, false, array("lstags", "MENU_LSTAGS")),
                ),

        8 => array (
                0 => array ('Manage Calendar', 'index.php?_m=teamwork&_a=calendar', false, true),
                1 => array ('Manage Tasks', 'index.php?_m=teamwork&_a=tasks', true, true),
                2 => array ('Manage Contacts', 'index.php?_m=teamwork&_a=contacts', true, true),
                3 => array ('Insert Contact', 'index.php?_m=teamwork&_a=insertcontact', true, true),
                4 => array ('Insert Event', 'index.php?_m=teamwork&_a=insertevent', true, true),
                5 => array ('Insert Task', 'index.php?_m=teamwork&_a=inserttask', true, false),
                ),

        4 => array (
                0 => array ('Manage Categories', 'index.php?_m=knowledgebase&_a=managecategories', false, true),
                1 => array ('Manage Articles', 'index.php?_m=knowledgebase&_a=managequestions', true, true),
                2 => array ('Quick Jump', '#', true, true, array("kbcachemenu", "MENU_JSCACHE_KNOWLEDGEBASE", "kbmenuloaded")),
                3 => array ('Insert Category', 'index.php?_m=knowledgebase&_a=insertcategory', true, true),
                4 => array ('Insert Article', 'index.php?_m=knowledgebase&_a=insertquestion', true, true),
                5 => array ('Comments%COMMENTKB%', 'index.php?_m=knowledgebase&_a=comments', true, true),
                6 => array ('Import/Export', 'index.php?_m=knowledgebase&_a=importexport', true, true),
                7 => array ('Reports', '#', true, false, array("reportkb", "MENU_KB_REPORTS")),
                ),

        5 => array (
                0 => array ('Manage Categories', 'index.php?_m=downloads&_a=managecategories', false, true),
                1 => array ('Manage Files', 'index.php?_m=downloads&_a=managefiles', true, true),
                2 => array ('Quick Jump', '#', true, true, array("dlcachemenu", "MENU_JSCACHE_DOWNLOADS", "dlmenuloaded")),
                3 => array ('Insert Category', 'index.php?_m=downloads&_a=insertcategory', true, true),
                4 => array ('Insert File', 'index.php?_m=downloads&_a=insertfile', true, true),
                5 => array ('Comments%COMMENTDL%', 'index.php?_m=downloads&_a=comments', true, true),
                6 => array ('Reports', '#', true, false, array("reportdl", "MENU_DL_REPORTS")),
                ),

        6 => array (
                0 => array ('Manage Categories', 'index.php?_m=troubleshooter&_a=managecategories', false, true),
                1 => array ('Manage Steps', 'index.php?_m=troubleshooter&_a=managesteps', true, true),
                2 => array ('Insert Category', 'index.php?_m=troubleshooter&_a=insertcategory', true, true),
                3 => array ('Comments%COMMENTTR%', 'index.php?_m=troubleshooter&_a=comments', true, true),
                4 => array ('Import/Export', 'index.php?_m=troubleshooter&_a=importexport', true, true),
                5 => array ('Reports', '#', true, false, array("reporttr", "MENU_TR_REPORTS")),
                ),

        7 => array (
                0 => array ('Manage News', 'index.php?_m=news&_a=managenews', false, true),
                1 => array ('Manage Subscribers', 'index.php?_m=news&_a=managesubscribers', true, true),
                2 => array ('Insert News', 'index.php?_m=news&_a=insertnews', true, true),
                3 => array ('Comments%COMMENTNW%', 'index.php?_m=news&_a=comments', true, true),
                4 => array ('Import/Export', 'index.php?_m=news&_a=importexport', true, false),
                ),

        9 => array (
                0 => array ('Manage Users', 'index.php?_m=core&_a=manageusers', false, true),
                1 => array ('Manage Groups', 'index.php?_m=core&_a=manageusergroups', true, true),
                2 => array ('Insert User', 'index.php?_m=core&_a=insertuser', true, true),
                3 => array ('Insert Group', 'index.php?_m=core&_a=insertusergroup', true, true),
                4 => array ('Mass Mail', 'index.php?_m=core&_a=usermassmail', true, false),
                ),
    );
}


?>