<?php
//=======================================
//###################################
// Kayako Infotech Ltd. - SWIFT Framework
//
// Source Copyright 2001-2008 Kayako Infotech Ltd.
// Unauthorized reproduction is not allowed
// License Number: $%LICENSE%$
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//                   www.kayako.com
//###################################
//=======================================

if (!defined("INSWIFT")) {
    trigger_error("Unable to process " . htmlentities($_SERVER['PHP_SELF']), E_USER_ERROR);
}

/**
* ###############################################
* Setting Groups, Items and other text.
* Descript Text Example: d_startofweek or d_general
* ###############################################
*/

$__LANG = array (
    'settings' => 'Settings',
    'desc_settings' => 'From here you can manage all functional and system-related settings and configurations.',
    'systemsettings' => 'System Settings',
    'groups' => 'Groups',
    'settingsfor' => 'Settings for: %s',
    'updatesettings' => 'Update Settings',
    'settingsupdatedfor' => 'Updated all settings for group "%s"',

    // ======= SETTING GROUPS =======
    'settings_general' => 'General',
    'settings_cpu' => 'CPU Optimization &amp; Server',
    'settings_security' => 'Security',
    'settings_datetime' => 'Date &amp; Time',
    'settings_livesupport' => 'Live Support',
    'settings_tickets' => 'Tickets',
    'settings_parser' => 'Mail Parser',
    'settings_tr' => 'Troubleshooter',
    'settings_users' => 'User Registration',
    'settings_nw' => 'News',
    'settings_dl' => 'Downloads',
    'settings_kb' => 'Knowledgebase',
    'settings_tw' => 'Teamwork',

    // ======= GENERAL SETTINGS =======
    'general_companyname' => 'Company Name',
    'd_general_companyname' => 'The name here is used to brand the client support interface and the outgoing e-mails.',
    'general_producturl' => 'Product URL',
    'd_general_producturl' => 'Enter the full path to the product installation URL. This value should include a trailing slash. '.SWIFTPRODUCT.' will not work properly if this is incorrect.',
    'general_returnemail' => 'Default Return E-mail Address',
    'd_general_returnemail' => 'This address is used as the default "From" address in outgoing e-mail. This address must correspond to an active e-mail queue in order to accept customer replies.',
    'general_redirecttype' => 'Redirect Type',
    'd_general_redirecttype' => 'Select <i>HTML Meta Refresh</i> to present a confirmation of an action before redirecting to the next page.',
    'refreshunix' => 'Header Refresh',
    'refreshwindows' => 'HTML META Refresh',
    'general_defaultlanguage' => 'Default Language',
    'general_themeoptions' => 'Default Theme Options',
    'g_cpmenu' => 'Tab Menu Navigation Style',
    'd_g_cpmenu' => 'Choose the <i>Hover</i> navigation style to activate a tab by placing the mouse cursor over it.',
    'general_themeorientation' => 'Client Support Center Navigation Bar Orientation',
    'd_general_themeorientation' => 'Specifies whether the User Login and Information Bar is placed to the left or the right of the client support interface.',
    'navleft' => 'Left',
    'navright' => 'Right',
    'general_themeextended' => 'Extended Display for Client Support Center Theme',
    'd_general_themeextended' => 'Display the client support interface using the entire browser width.',
    'g_commentsapproval' => 'Moderate Comments',
    'd_g_commentsapproval' => 'Require manual approval of comments entered by users.',
    'menuhover' => 'Hover',
    'menuclick' => 'Click',
    'g_jscache' => 'Javascript Cache for Theme Items',
    'd_g_jscache' => 'Cache heavy-output items such as the menu and navigation bar to a file so that pages load faster (rather than loading from the database each time). This disables the real-time view of comments and private message counts in the menu.',
    'g_onlusr' => 'Display Online Users in Staff CP',
    'd_g_onlusr' => 'Show a list of currently online staff users and their current actions.',
    'g_api' => 'API Settings',
    't_apistaffusers' => 'Select the API Staff Users',
    'd_t_apistaffusers' => 'Specify the staff users who are allowed to authenticate with the API interface. Any commands executed via the API will be performed by the authenticated staff user.',
    'g_integrationopt' => 'Integration Options',
    'g_mbtgroup' => 'ModernBill Template Group',
    'd_g_mbtgroup' => 'Select a default template group for ModernBill integration. This group will override the default template group. This can be used to display a different template group when '.SWIFTPRODUCT.' is used via ModernBill and another when accessed normally.',
    'g_whmcstgroup' => 'WHMCS Template Group',
    'd_g_whmcstgroup' => 'Select a default template group for WHMCS integration. This group will override the default template group. This can be used to display a different template group when '.SWIFTPRODUCT.' is used via WHMCS and another when accessed normally.',
    'mbtdefgroup' => '-- Use Default Template Group --',
    'g_supportcenter' => 'Support Center Settings',
    'g_returnlogout' => 'After Logout Return To Default Template Group',
    'd_g_returnlogout' => 'Redirect the user to the default template group after logout.',
	'g_overrideswiftpath' => 'Override $swiftpath and $themepath variables automatically',
	'd_g_overrideswiftpath' => 'If enabled, the system tries to determine the $swiftpath and $themepath variables for templates from the URL. This allows you to create multi-point installations of helpdesk based off a single database.',

    // ======= CPU SAVING & OPTIMIZATION =======
    'cpu_optimization' => 'Optimization Settings',
    'cpu_winappcompresslevel' => 'GZIP Compression Level',
    'd_cpu_winappcompresslevel' => 'Select the compression level for page outputs. Higher values are more resource-intensive, but result in smaller downloads. If set too high, the page load times may actually increase. The default recommended setting is <i>2 - Recommended</i>.',
    'nocompression' => 'No Compression',
    'reccompression' => 'Recommended',
    'highestcompression' => 'Highest',
    'cpu_compresswinappdata' => 'Compress Desktop Application Output',
    'cpu_compressclientdata' => 'Compress Client Support Interface Output',
    'cpu_compressstaffdata' => 'Compress Staff CP Output',
    'cpu_compressadmindata' => 'Compress Admin CP Output',
    'cpu_compresswapdata' => 'Compress WAP Staff CP Output',
    'cpu_compresspdadata' => 'Compress PDA Staff CP Output',
    'cpu_logcleardays' => 'Log Clearing Time (In Days)',
    'd_cpu_logcleardays' => 'Specify the number of days after which logs will be cleared from the system.',
    'cpu_smsgateway' => 'SMS Gateway',
    'gateway_enable' => 'Enable SMS Gateway',
    'd_gateway_enable' => 'The Kayako SMS Gateway can send alerts directly to mobile phones. For more information, see the <a target="_blank" href="http://members.kayako.net">Kayako Members\' Area</a>.',
    'gateway_username' => 'Gateway Username',
    'd_gateway_username' => 'Your SMS Gateway username. This is the same as the e-mail address used to log in to the <a target="_blank" href="http://members.kayako.net">Kayako Members\' Area</a>.',
    'gateway_password' => 'Gateway Password',
    'd_gateway_password' => 'Your SMS Gateway password. This is the same as the password used to log in to the <a target="_blank" href="http://members.kayako.net">Kayako Members\' Area</a>.',
    'cpu_mailsettings' => 'Outgoing Mail Settings',
    'cpu_enablehtmlmails' => 'HTML E-mail',
    'd_cpu_enablehtmlmails' => 'Format all outgoing e-mail using HTML. ' .SWIFTPRODUCT.' will also send a plain text version of the content to be viewed by simple e-mail clients. The look and content of the e-mail can be changed by editing templates under <i>Templates &gt; Manage Templates</i>.',
    'cpu_enablemailqueue' => 'Mail Send-Queue',
    'd_cpu_enablemailqueue' => 'Use a queueing system for outgoing e-mail. '.SWIFTPRODUCT.' will send bulk e-mail in batches. This can prevent server slowdown when sending bulk e-mail.',
    'cpu_mailqueuebatch' => 'E-mails Sent Per Batch',
    'd_cpu_mailqueuebatch' => 'The number of e-mails to send per batch. The higher this value is, the more resource-intensive each batch sending will be.',
    'cpu_smtp' => 'SMTP Settings',
    'cpu_enablesmtp' => 'Enable SMTP',
    'd_cpu_enablesmtp' => 'Select whether an SMTP server should be used to send e-mail. By default, '.SWIFTPRODUCT.' will use the internal PHP mail() function to send e-mail.',
    'cpu_smtphost' => 'SMTP Host',
    'd_cpu_smtphost' => 'The IP address or host name of the SMTP server.<br/><br/>To enable a secure SSL or TLS connection with the server, place <i>\'ssl://\'</i> or <i>\'tls://\'</i> in front of the IP address or host name. Note: OpenSSL support must be enabled in PHP to use SSL or TLS.',
    'cpu_smtpport' => 'SMTP Port',
    'd_cpu_smtpport' => 'The port number of the SMTP server, <i>usually port 25</i>.',
    'cpu_smtpuseauth' => 'Use SMTP Authentication',
    'd_cpu_smtpuseauth' => 'Use the information below to authenticate with the SMTP server.',
    'cpu_smtpuser' => 'SMTP Username',
    'd_cpu_smtpuser' => 'The username '.SWIFTPRODUCT.' will use to authenticate with the SMTP server.',
    'cpu_smtppass' => 'SMTP Password',
    'd_cpu_smtppass' => 'The password '.SWIFTPRODUCT.' will use to authenticate with the SMTP server.',
    'gat_emailfailure' => 'E-mail Failure Reports',
    'd_gat_emailfailure' => 'Send delivery failure reports to the primary administrator e-mail address.',

    // ======= SECURITY =======
    'security_sessioninactivity' => 'Default Session Inactivity Expiration',
    'd_security_sessioninactivity' => 'The time, in seconds, after which a user\'s idle session will be removed from the system.',
    'security_sessionvar' => 'Session Variable Type',
    'security_visitorinactivity' => 'Session Inactivity Expiration For Site Visitors',
    'd_security_visitorinactivity' => 'The time, in seconds, after which visitors (tracked via the '.SWIFTPRODUCT.' Desktop Application) will be marked as idle and their sessions deleted. Increasing this value uses more server resources.',
    'security_cookiedomain' => 'Cookie Domain',
    'd_security_cookiedomain' => 'The cookie domain. Change this value only if multiple installations of '.SWIFTPRODUCT.' are located on the same domain.',
    'security_cookiepath' => 'Cookie Path',
    'd_security_cookiepath' => 'The cookie path. Change this value only if multiple installations of '.SWIFTPRODUCT.' are located on the same domain.',
    'security_securecookie' => 'Enable secure cookie',
    'd_security_securecookie' => 'Enable this setting if you will only <strong>use your desk over a secure connection (HTTPS)</strong>. This setting enables a cookie flag which only lets cookies be transmitted over a secure connection.',
    'cookie' => 'Cookie',
    'url' => 'URL',
    'urlcookie' => 'URL &amp; Cookie',

    // ======= DATE & TIME =======
    'dtcalus' => 'US (mm/dd/yy + 12hr)',
    'dtcaleu' => 'EU (dd/mm/yy + 24hr)',
    'dt_caltype' => 'Calendar Date Type',
    'd_dt_caltype' => 'Toggle the date type used for all Calendar dates. Note: This setting only affects the date values from the date selector.',
    'dt_dateformat' => 'Date Format',
    'd_dt_dateformat' => 'Specify the default format for all dates displayed in the system. '.SWIFTPRODUCT.' uses the PHP date() function. For more information on this function, see <a href="http://www.php.net/date" target="_blank">date()</a>.',
    'dt_timeformat' => 'Time Format',
    'd_dt_timeformat' => 'Display times using the specified format.',
    'dt_datetimeformat' => 'Date &amp; Time Format',
    'd_dt_datetimeformat' => 'Display times and dates in the specified format.',
    'dt_timezonephp' => 'Time Zone',
    'd_dt_timezonephp' => 'The system default time zone. Staff users have the option to override this time zone to reflect their own (via the Staff User Preferences in the Staff Control Panel).',
    'dt_daylightsavings' => 'Enable Automatic Daylight Savings',
    'd_dt_daylightsavings' => 'Select whether or not you wish to enable Daylight Savings Time.',

    // ======= LIVE SUPPORT =======
    'livesupport_clientchatsettings' => 'Visitor &amp; Chat Settings',
    'livesupport_chatwidth' => 'Chat Window Width',
    'd_livesupport_chatwidth' => 'The width of the visitor\'s chat window (in pixels).',
    'livesupport_chatheight' => 'Chat Window Height',
    'd_livesupport_chatheight' => 'The height of the visitor\'s chat window (in pixels).',
    'livesupport_usehttps' => 'Always Use Secure Connection (https) For Chat',
    'd_livesupport_usehttps' => 'If this setting is enabled, all chat sessions will always be conducted over https.',
    'livesupport_clientchatrefresh' => 'Chat Refresh Interval',
    'd_livesupport_clientchatrefresh' => 'The interval, in seconds, at which a client\'s chat data will be refreshed during a live chat session. Lower values will increase the server load.',
    'livesupport_clientpagerefresh' => 'Visitor Page Refresh Interval',
    'd_livesupport_clientpagerefresh' => 'The interval, in seconds, at which visitor data will be refreshed and sent to the server. Lower values will increase the server load considerably.',
    'livesupport_roundrobinretries' => 'Number Of Chat Round Robin Retries',
    'd_livesupport_roundrobinretries' => 'The number of times ' .SWIFTPRODUCT. ' will attempt to look for available staff users when a new chat request is received.  If no available staff users are found after this many attempts, the visitor is instructed to <i>Leave a Message</i>.',
    'livesupport_roundrobintimetry' => 'Round Robin Retry Interval',
    'd_livesupport_roundrobintimetry' => 'The time in seconds that ' .SWIFTPRODUCT. ' will wait between each Round Robin retry.  The total time a visitor will wait if no staff users are available is (<i>number of chat round robin retries * round robin retry delay</i>).  After that amount of time has elapsed without finding an available staff user, the visitor will be instructed to <i>Leave a Message</i>.',
    'livesupport_displayclientchatqueue' => 'Tell Visitor How Many Chats In Queue',
    'd_livesupport_displayclientchatqueue' => 'If enabled, visitors will be shown a message regarding the number of chatters waiting in line before them.',
    'livesupport_cachehtmljscode' => 'Cache HTML JavaScript Code',
    'd_livesupport_cachehtmljscode' => 'Toggle whether '.SWIFTPRODUCT .' should send cache headers to the user\'s browser. It is recommended that you do not change this value.',
    'livesupport_enableuseristyping' => 'Show "User is Typing..."',
    'd_livesupport_enableuseristyping' => 'If enabled, both visitors and staff users will be able to see when the other is typing. Disable this option to reduce server load.',

    'livesupport_messagesettings' => 'Offline Messages Settings',
    'livesupport_enablemessagefw' => 'Enable Forwarding',
    'd_livesupport_enablemessagefw' => 'Forward offline messages received by ' .SWIFTPRODUCT. ' to the e-mail address entered below.',
    'livesupport_deletemessageafterfw' => 'Delete After Forward',
    'd_livesupport_deletemessageafterfw' => 'Automatically delete the forwarded message.',
    'livesupport_fwmessageemail' => 'Forwarding E-mail Addresses',
    'd_livesupport_fwmessageemail' => 'Forward offline messages to these semi-colon separated e-mail addresses.  This will only take effect if the above option, <i>Enable Forwarding</i>, is enabled.<br/><br/>Example: <i>jane.doe@company.com;john.smith@company.com</i>',

    'livesupport_winappsettings' => 'Desktop Application Settings',
    'livesupport_searchbgcolor' => 'Search Engine Visitor Background Color',
    'd_livesupport_searchbgcolor' => 'The background color for a visitor that has been referred to the site by a search engine.',
    'livesupport_searchfrcolor' => 'Search Engine Visitor Foreground Color',
    'd_livesupport_searchfrcolor' => 'The foreground color for a visitor that has been referred to the site by a search engine.',
    'ls_adbgcolor' => 'Ad Tracking Visitor Background Color',
    'd_ls_adbgcolor' => 'The background color for a visitor that has been referred to the site by an <b>Ad Campaign</b> (configured within the Staff Control Panel).',
    'ls_adfrcolor' => 'Ad Tracking Visitor Foreground Color',
    'd_ls_adfrcolor' => 'The foreground color for a visitor that has been referred to the site by an <b>Ad Campaign</b> (configured within the Staff Control Panel).',

    'ls_clientarea' => 'Client Support Interface Settings',
    'ls_displaystatus' => 'Display Live Support Status Icon',
    'd_ls_displaystatus' => 'Show the Live Support button within the client support interface (showing Online, Offline, Busy or Be Right Back).',
    'ls_staffcp' => 'Live Support Staff CP Settings',
    'ls_entab' => 'Display Live Support Tab In Staff CP',
    'd_ls_entab' => 'Show the Live Support tab within the staff control panel.',
    'ls_depname' => 'Use Department Name In Chats',
    'd_ls_depname' => 'Use the department name instead of the staff user\'s name in chats. This will hide the name of the staff user from the visitor.',

    // ======= MAIL PARSER =======
    'pr_generalparser' => 'Parser Settings',
    'pr_contentpriority' => 'E-mail Content Priority',
    'd_pr_contentpriority' => 'Each e-mail that comes into the system can have two content types (HTML and plain-text). This setting specifies which type '.SWIFTPRODUCT.' should use for parsing the e-mail. It is recommended that this value be set to <i>Text</i>.',
    'text' => 'Text',
    'html' => 'HTML',
    'pr_stripscript' => 'Strip &lt;SCRIPT&gt; Tags',
    'd_pr_stripscript' => 'Remove all script tags from incoming e-mail. It is <b>highly</b> recommended this option is enabled. If disabled, users could potentially run arbitrary code in a staff user\'s browser.',
    'pr_logoptions' => 'Parser Log Options',
    'pr_enablelog' => 'Enable Logging',
    'd_pr_enablelog' => 'Log all mail parser activity. It is recommended that this setting is always enabled in order to better trace issues related to the parsing of incoming e-mails.',
    'pr_logchurndays' => 'Log Retention Time',
    'd_pr_logchurndays' => 'The time, in days, that logs will remain in the system.',
    'pr_maxlogsize' => 'Maximum Log Entry Size',
    'd_pr_maxlogsize' => 'The maximum allowable size, in kilobytes, for entries in the parser log. Any entry that is larger than the size specified here will not be stored. This can be used to keep the size of the log database to a minimum.',
    'pr_pop3' => 'POP3/IMAP Fetch Settings',
    'pr_procno' => 'Maximum Number of Messages To Process In Single Pass',
    'd_pr_procno' => 'Once the mail parser reaches this limit, it will end the message processing and the rest of the messages in the inbox, if any, will be processed when the task is next executed.',
    'pr_sizelimit' => 'Message Size Limit',
    'd_pr_sizelimit' => 'Reject any message which is larger than this size (in kilobytes). The size specified here must be less than the <b>php_memory_limit</b> setting in your <i>php.ini</i> (PHP configuration file) -- otherwise, your messages may be left in the queue.',
    'pr_parsereplyto' => 'Reply-To Header Override',
    'd_pr_parsereplyto' => 'Use the <i>Reply-To</i> header entry as the primary e-mail address for the ticket creator. <b>Warning!</b> This may result in security risks if abused, as Reply-To headers are easily faked.',
    'pr_conversion' => 'Automatically Convert Encoding Of Incoming E-mails',
    'd_pr_conversion' => 'If enabled, ' .SWIFTPRODUCT. ' will automatically attempt to convert incoming e-mails to the default encoding of the help desk (<i>e.g. If the help desk is set to UTF-8 and an e-mail is sent in ISO-2022-JP, it will be converted to UTF-8 before being added to the system</i>).',
	  'pr_loopoptions' => 'Loop Control Settings',
	  'pr_loopcut_prevents_autoresponder' => 'Don\'t Send Autoresponder',
	  'd_pr_loopcut_prevents_autoresponder' => 'If enabled, ' . SWIFTPRODUCT . ' will not send the receipt confirmation for the message that triggered a loop control rule.  <em>It is highly recommended that this setting always be enabled.</em>',
	  'pr_loopcut_ignores_cut_mail' => 'Ignore E-mail Message',
	  'd_pr_loopcut_ignores_cut_mail' => 'If enabled, messages that trigger loop control rules will be not be processed.',
    // ======= TICKETS =======
    't_restrictnewticket' => 'Restrict New Ticket Creation To Assigned Departments',
    'd_t_restrictnewticket' => 'Only allow staff users to create tickets in departments to which they are assigned.',
    'tickets_attachments' => 'Attachment Settings',
    'tickets_attachtype' => 'Storage Location For Attachments',
    'd_tickets_attachtype' => 'Specify where the attachments should be stored. If the "files" option is selected, all attachments will be stored in the file system as individual files (with encrypted filenames). If the database option is selected, files will be stored in the database.',
    'database' => 'Database',
    'files' => 'File System ("files" Directory)',
    'tickets_attachchunksize' => 'Database Attachment Chunk Size',
    'd_tickets_attachchunksize' => 'Each attachment that is stored in the database is split into a number of chunks, of the size, in bytes, specified here. This number should not be larger than the <b>maximum packet size</b> setting in your <i>my.cnf</i> (MySQL configuration) file.',
    't_rvalemail' => 'Require Valid E-mail Address',
    'd_t_rvalemail' => 'Require users to provide a valid e-mail address when submitting tickets.',
    'tickets_search' => 'Search Options',
    't_searchsortdate' => 'Sort Results According to Last Activity (Descending)',
    'd_t_searchsortdate' => 'Sort search results according to last activity time (descending). Otherwise, the default view sort order is used.',
    't_cntrelevance' => 'Advanced Ticket Searching',
    'd_t_cntrelevance' => 'Use a more advanced algorithm for searching and determining relevance of results. This setting will increase the search time by up to 40%, but the relevancy of the results will be much higher.',
    'tickets_searchtype' => 'Search Index Type',
    'postindex' => 'Bulletin Post Index',
    'fulltext' => 'MySQL Full Text',
    't_autorecip' => 'Automatically Add CC Users As Recipients',
    'd_t_autorecip' => 'Automatically add CC e-mail addresses in an incoming e-mail to the ticket to be created.',
	  't_autorespondercc' => 'Dispatch Auto Responder for CC Users?',
	  'd_t_autorespondercc' => 'If Enabled, '. SWIFTPRODUCT. ' will automatically dispatch an autoresponder message to the CC users. The autoresponder message is dispatched without the password of the creator even if this option is enabled.',
    'tickets_minwordlength' => 'Minimum Word Length',
    'd_tickets_minwordlength' => 'Specify the minimum length of a word that will be indexed for search. Any word that does not meet this criteria will be ignored by the indexer and will not be searchable. Shorter words tend to occur more frequently, so allowing their indexing will cause a larger, slower index and thus slower per-word searches.',
    'tickets_maxwordlength' => 'Maximum Word Length',
    'd_tickets_maxwordlength' => 'Specify the maximum length of a word that will be indexed for search. Any word that does not meet this criteria will be ignored by the indexer and will not be searchable.',
    'tickets_indexnumbers' => 'Index Numbers',
    'd_tickets_indexnumbers' => 'If enabled, numbers will be indexed and will be searchable.',
    'tickets_minnumberlength' => 'Minimum Number Length',
    'd_tickets_minnumberlength' => 'The minimum length of a number, in characters, that will be indexed. Any number shorter than this number of characters will be ignored by the indexer and will not be searchable.',
    'tickets_faulttolerance' => 'Word Fault Tolerance',
    'd_tickets_faulttolerance' => 'If a word occurs in a ticket post more than the times specified here, it will be ignored and will not be indexed.',
    't_parser' => 'Parser Settings',
    't_pstaffreply' => 'Allow Staff To Reply By E-mail',
    'd_t_pstaffreply' => 'Allow staff users to reply to ticket alerts directly from their e-mail clients.',
    't_sla' => 'SLA Settings',
    't_encustomoverdue' => 'Use Default Overdue Hours',
    'd_t_encustomoverdue' => 'Use the value (in <i>Default Overdue Hours</i>) to calculate overdue times for a ticket when an SLA plan is not assigned to the department, user, usergroup, or ticket itself.',
    't_overduehrs' => 'Default Overdue Hours',
    'd_t_overduehrs' => 'Mark a ticket as overdue after this number of hours. (<i>See the above setting, <i>Use Default Overdue Hours</i>, for clarification</i>).',
    'tickets_resattachments' => 'Restrict Incoming Attachments To Custom Attachment Types',
    'd_tickets_resattachments' => 'If enabled, only file attachments that are listed in Custom Attachment Types under <i>Tickets &gt; Attachment Types</i> will be processed. All other attachment types will be ignored.',
    't_rss' => 'RSS View Syndication',
    't_enrss' => 'Enable RSS Syndication for Ticket Views',
    'd_t_enrss' => 'Allow ticket views (from within the staff control panel) to be syndicated as RSS feeds.',
    't_general' => 'General Ticket Settings',
    't_tpreview' => 'Enable Post Preview in Ticket List',
    'd_t_tpreview' => 'Display a post preview when hovering over a ticket within the Staff Control Panel. If operating a heavy usage support desk, it is recommended that this option be disabled.',
    't_postlimit' => 'Number Of Tickets Posts Per Page',
    'd_t_postlimit' => 'If the <i>"Split Ticket Posts By Page"</i> option is enabled, this specifies how many ticket posts to display on a single page.',
    't_chtml' => 'HTML Conversion (Rendering and Staff Alerts)',
    'd_t_chtml' => 'Choose how HTML content should be treated when displaying tickets in the web interface and when sending staff alerts.<br><dl><dt><b>HTML Entities</b></dt><dd>Converts HTML to normal text so that you can see the code.</dd><dt><b>Strip Tags</b></dt><dd>Removes HTML formatting completely; (e.g. "&lt;b&gt;foo&lt;/b&gt;" = "foo").</dd><dt><b>No Processing</b></dt><dd>Allow HTML code (e.g. "&lt;b&gt;foo&lt;/b&gt;" = "<b>foo</b>").  This setting is <b>not</b> recommended as it can allow malicious code to be executed in staff users\' web browsers and/or e-mail client applications.</dd></dl><i>Note: This setting does not affect the final content stored in the database!</i>',
    't_ochtml' => 'HTML Conversion (Staff Replies)',
    'd_t_ochtml' => 'Choose how to handle HTML content in e-mail replies sent by staff users.  This will affect the content that ultimately reaches the client user.<br><dl><dt><b>HTML Entities</b></dt><dd>Converts HTML to normal text so that you can see the code.</dd><dt><b>Strip Tags</b></dt><dd>Removes HTML formatting completely; (e.g. "&lt;b&gt;foo&lt;/b&gt;" = "foo").</dd><dt><b>No Processing</b></dt><dd>Allow HTML code (e.g. "&lt;b&gt;foo&lt;/b&gt;" = "<b>foo</b>").  This setting is <b>not</b> recommended as it can allow malicious code to be executed in e-mail client applications.</dd></dl><i>Note: This setting does not affect the final content stored in the database!</i>',
    't_allowhtml' => 'Allow HTML Tags',
    'd_t_allowhtml' => 'If enabled, some (specified below) HTML tags will be allowed, even if rendering is set to <i>Strip Tags</i>.',
    't_allowabletags' => 'Allowable HTML Tags',
    'd_t_allowabletags' => 'If the option above is enabled, the following HTML tags will be allowed.',    
    't_postorder' => 'Display Order for Ticket Posts',
    'tcentities' => 'HTML Entities',
    'tchtml' => 'No Processing',
    'tcstrip' => 'Strip Tags',
    'd_t_postorder' => 'Specify whether to display the oldest or newest ticket posts first.',
    't_enpagin' => 'Split Ticket Posts By Page',
    'd_t_enpagin' => 'Display ticket posts for a ticket on separate pages instead of all on a single page. Choose how many ticket posts to display per page below.',
    'newestfirst' => 'Newest First',
    'oldestfirst' => 'Oldest First',
    't_overduecolor' => 'Overdue Tickets Background Color',
    'd_t_overduecolor' => 'The background color of tickets that have been marked as overdue.',
    't_resultlimit' => 'Search Results Limit',
    'd_t_resultlimit' => 'The limit of results that are returned following a search. Setting this value too high can cause searches to become more resource intensive and take longer to execute.',
    't_tidinsub' => 'Set Ticket ID in Subject for Outgoing E-mail',
    'd_t_tidinsub' => 'Insert a ticket ID into the subject of e-mails sent when staff create new tickets. Although it is highly recommended that this option be enabled, '.SWIFTPRODUCT.' can still check which ticket a message belongs to by searching for the ticket ID within the e-mail body, by comparing the subject or by checking the Message-ID e-mail header.',
    't_mailset' => 'Mail Settings',
    't_stmsgid' => 'Check the Message-ID for Staff Replies',
    'd_t_stmsgid' => SWIFTPRODUCT.' can check the Message-ID header to confirm the identity of a staff user replying to a ticket alert. This adds an extra layer of security and makes sure the replier is a valid staff user. However, it requires that the end mailing client sends the In-Reply-To header, which is not supported by all e-mail clients (in particular, wireless e-mail clients).',
    't_entab' => 'Display Tickets Tab',
    'd_t_entab' => 'Display the Tickets tab within the staff control panel.',
    't_clientarea' => 'Client Support Interface Settings',
    't_cperpage' => 'Tickets to Display Per Page',
    'd_t_cperpage' => 'The number of tickets that will be listed to users when viewing their ticket list.',
    't_eticketid' => 'Ticket ID Type',
    'd_t_eticketid' => 'Choose how ' .SWIFTPRODUCT. ' should generate new ticket identifiers. It is recommended that this is set to <i>Random</i> to increase security against spoofing attacks.<br /><br />Examples:<br /><i>Sequential:</i> "[#194]: &lt;subject here&gt;"<br /><i>Random:</i> "[ABC-123456]:&lt;subject here&gt;"',
    'tsequential' => 'Sequential',
    'trandom' => 'Random',
    't_maxattach' => 'Maximum Number of Attachments When Replying',
    'd_t_maxattach' => 'The maximum number of files that can be attached to a ticket reply. If particularly large files are allowed, it is recommended that the <i>upload_max_filesize</i> setting in your php.ini (PHP configuration file) be edited to reflect the size.',
    't_slaresets' => 'Clear Overdue Time for Tickets After Staff Reply',
    'd_t_slaresets' => 'If enabled, the SLA overdue time will be automatically cleared whenever a staff user replies to a ticket. A new overdue time will be calculated when the client replies back to the ticket.',
    't_cthirdparty' => 'Users Can View Third-Party Replies',
    'd_t_cthirdparty' => 'If enabled, users will be able to view third-party replies made to their tickets from within the client support interface.',
    't_cenattach' => 'Users Can Upload Attachments',
    'd_t_cenattach' => 'If enabled, users will be able to upload file attachments when they create or reply to a ticket.',
    't_cmaxattach' => 'Maximum Number of Attachments',
    'd_t_cmaxattach' => 'The number of attachments a user can add to a new ticket or ticket reply.',
    't_cpostorder' => 'Display Order for Ticket Posts',
    'd_t_cpostorder' => 'Choose whether to display the oldest or newest ticket posts first to users in the client support interface.',
    't_pdainterf' => 'PDA Staff Control Panel Interface',
    't_pdenpagin' => 'Split Ticket Posts by Page',
    'd_t_pdenpagin' => 'Display ticket posts for a ticket will be displayed on separate pages instead of a single page. You may choose how many ticket posts to display per page below.',
    't_pdpostlimit' => 'Number of Tickets Posts Per Page',
    'd_t_pdpostlimit' => 'If you have enabled the <i>"Split Ticket Posts By Page"</i> option, this specifies how many ticket posts to display on a single page. This applies only to the PDA staff control panel interface.',
    't_pdpostorder' => 'Display Order For Ticket Posts',
    'd_t_pdpostorder' => 'Whether to display the oldest or newest ticket posts first.',
    't_signores' => 'Ignore Words Containing Symbols',
    'd_t_signores' => 'If enabled, words containing any of the following symbols will be ignored:<br /><br /><i>- ~ ` @ # $ ^ & * ( ) _ = + [ ] { } | / < > , . ; \' " \\</i>',
    't_ccaptcha' => 'Enable CAPTCHA for Ticket Submission',
    'd_t_ccaptcha' => 'Require users who register via the client support interface to enter text displayed in a special image to attempt to verify whether they are human.',
    't_autoclose' => 'Ticket Automatic Close Settings',
    't_enautoclose' => 'Enable Auto Closure System',
    'd_t_enautoclose' => 'Automatically change the status of tickets that have lingered in the system for the specified amount of time.',
    't_acstatus' => 'Affected Ticket Statuses',
    'd_t_acstatus' => 'Select the ticket statuses the automatic close system will affect.  Select multiple statuses by holding the CTRL key and selecting multiple entries.',
    't_acdep' => 'Affected Departments',
    'd_t_acdep' => 'Select the departments that the automatic close system will affect. Select multiple departments by holding the CTRL key and selecting multiple entries.',
    't_acstatusch' => 'Target Status',
    'd_t_acstatusch' => 'Select the status to which tickets will be changed automatically once they have lingered for the specified time.',
    't_acinactive' => 'Automatic Closure Inactivity Threshold',
    'd_t_acinactive' => 'After a ticket has remained inactive for this amount of time (in hours), the system will send a notice to the user created the ticket, warning the user of the pending automatic status change.',
    't_acnoticeclose' => 'Final Automatic Close Threshold',
    'd_t_acnoticeclose' => 'After this amount of time (in hours) has elapsed (this starts after the "Automatic Closure Inactivity Threshold" has been reached), the target tickets\' status will automatically be changed.',

    't_sendacwarningmail' => 'Send Pending Closure Notification To User',
    'd_t_sendacwarningmail' => 'If enabled, the ticket creator will be e-mailed informing them that their ticket is due to close if they do not update it.',

    't_sendacfinalmail' => 'Send Final Closure Notification To User',
    'd_t_sendacfinalmail' => 'If enabled, the ticket creator will be e-mailed informing them that their ticket has been closed.',

    't_arnews' => 'Send Latest News In Auto Responder Message',
    'd_t_arnews' => 'If enabled and if the News module is active, the five most recent news items will be sent inside of the ticket autoresponder (ticket receipt).',
    't_ticketlock' => 'Ticket Lock Settings',
    't_entlock' => 'Enable/Disable Ticket Locking',
    't_entplock' => 'Enable Reply Ticket Locking',
    'd_t_entplock' => 'Allow staff users to see other staff user\'s replies in real-time (as they draft their reply) when viewing the same ticket.',
    't_plockthreshold' => 'Threshold for Post Ticket Locking',
    'd_t_plockthreshold' => 'Any update to the reply made after this threshold (in seconds) will not be displayed to other staff users.',
    'd_t_entlock' => 'The ticket locking feature in '. SWIFTPRODUCT . ' will lock a ticket when a staff user opens the ticket. Other staff users will still be able to access the ticket, but a lock icon will be displayed letting other staff users know that the ticket is being viewed.',
    't_locktimeout' => 'Ticket Lock Timeout',
    'd_t_locktimeout' => 'Once this amount of time (in seconds) has elapsed (i.e. if the staff user causing the lock has been idle for this amount of time) the lock icon will not be displayed.',
    't_canirs' => 'Enable the Instant Response System (IRS)',
    'd_t_canirs' => 'If enabled, when users draft their initial ticket submissions, '.SWIFTPRODUCT. ' will search the knowledgebase for relevant articles in real-time.  This feature cuts down on the amount of new tickets submitted, as users may frequently find the answers they are looking for before submitting their tickets.',
    't_maxwcnt' => 'Maximum Word Count for IRS',
    'd_t_maxwcnt' => 'After the amount of words specified here have been entered by the user, the IRS system will no longer continue looking up knowledgebase articles for suggestion.',
    't_reciplist' => 'List Recipients Before Replying',
    'd_t_reciplist' => 'Display the list of added recipients in a ticket. This adds an overhead of additional database queries in the ticket listing page.',
    't_staffcp' => 'Staff Control Panel Settings',
    't_scanirs' => 'Enable Instant Response System (IRS)',
    'd_t_scanirs' => 'Like the IRS in the client support interface, ' .SWIFTPRODUCT. ' will suggest knowledgebase articles as staff users draft their replies.',
    't_advanced' => 'Advanced Ticket Settings',
    't_postlist' => 'Assign Post List Variable to Staff Replies',
    'd_t_postlist' => 'Include the entire history of the ticket to date in replies sent by staff members.  This does add overhead and could potentially slow down replies.',
    't_mergrecip' => 'Add Users As Recipients When Merging',
    'd_t_mergrecip' => 'When two tickets are merged, add the creators of both tickets as recipients in the ticket that results from the merge.  This ensures that the creators of both tickets will receive future correspondence associated with the resultant ticket.',
	't_searchticketidinbody' => 'Lookup Ticket ID in Email Body?',
	'd_t_searchticketidinbody' => 'If Enabled, '. SWIFTPRODUCT .' will try to lookup the Ticket ID in the body of the email if it cannot be located in the email subject.',

    // ======= TROUBLESHOOTER =======
    'tr_staffcp' => 'Troubleshooter Staff Control Panel Settings',
    'tr_general' => 'Client Support Interface Troubleshooter Settings',
    'tr_staffwysiwyg' => 'Enable WYSIWYG Editor',
    'd_tr_staffwysiwyg' => 'Use the advanced WYSIWYG editor (rich text) for creating troubleshooter articles.',
    'tr_enableclient' => 'Display Troubleshooter Widget',
    'd_tr_enableclient' => 'Show the troubleshooter icon and link on the index.php page of the client support interface.',
    'tr_enablepopularcat' => 'Enable Popular Troubleshooters Box',
    'd_tr_enablepopularcat' => 'Show a list of the most popular troubleshooters on the index.php page of the client support interface.',
    'tr_maxpopularcat' => 'Maximum Number Of Popular Troubleshooters To Display',
    'd_tr_maxpopularcat' => 'The maximum number of troubleshooters to display in the popular troubleshooters box.',
    'tr_displayviews' => 'Display Number Of Views',
    'd_tr_displayviews' => 'Display the number of views each troubleshooter has received in the popular troubleshooters box.',
    'tr_displaynavbar' => 'Display Troubleshooters in Navigation Bar',
    'd_tr_displaynavbar' => 'Display troubleshooters at every step in the navigation bar.',
    'tr_captcha' => 'Enable CAPTCHA for Comments',
    'd_tr_captcha' => 'If enabled, users will be required to verify a CAPTCHA image before submitting a comment.',    
    'tr_entab' => 'Display Troubleshooter Tab',
    'd_tr_entab' => 'Show the Troubleshooter tab within the Staff Control Panel.',
    't_cstatusupd' => 'Default Ticket Status for Client Reply',
    'd_t_cstatusupd' => 'Automatically set tickets to this status when a client has replied.',
    'tsnochange' => '-- Do Not Change --',
    't_canrecip' => 'Users Can Specify Custom Recipients',
    'd_t_canrecip' => 'Allow users to specify custom "CC Recipients" to tickets that they create.',
    't_enhistory' => 'Send Complete History in Staff Replies?',
    'd_t_enhistory' => 'Include the entire history of the ticket to date in replies sent by staff members.  This does add overhead and could potentially slow down replies.',

    // ======= USER REGISTRATION =======
    'u_enablesveri' => 'Manual Staff Verification',
    'd_u_enablesveri' => 'If enabled, newly registered users will not receive a confirmation e-mail.  Instead, a staff member must manually validate the registration or choose to send out the confirmation e-mail (<i>Staff CP > Users</i>). This option will override the following option (<i>User E-mail Verification</i>).',
    'user_enableemailverification' => 'User E-mail Verification',
    'd_user_enableemailverification' => 'If enabled, '.SWIFTPRODUCT.' will verify the e-mail address of the user when they register via the client support interface. Verification involves sending an e-mail to the user containing an activation link which they must click to activate the account.',
    'user_enablecaptcha' => 'Enable CAPTCHA for New User Registration',
    'd_user_enablecaptcha' => 'Require users that register via the client support interface to enter text displayed in a special image to verify that they are human.',
    'user_autodelete' => 'Auto Clear',
    'user_adelunveri' => 'Automatically Clear Unverified Users',
    'd_user_adelunveri' => 'Purge unverified user accounts after a given amount of time (set below).',
    'user_delcleardays' => 'Auto Clear Timeline',
    'd_user_delcleardays' => 'The time (in days) after which unverified user accounts will be automatically purged from the system (if the above option is enabled).',
    'u_sendpw' => 'Send Password in Auto Responder (Ticket Receipt)',
    'd_u_sendpw' => 'Send the user\'s password to them whenever they create a new ticket.',

    // ======= NEWS =======
    'nw_general' => 'News Settings',
    'nw_wysiwyg' => 'Enable WYSIWYG Editor',
    'd_nw_wysiwyg' => 'Use the advanced WYSIWYG editor (rich text) for creating news articles.',
    'nw_newsclient' => 'Client Support Interface News Settings',
    'nw_enableclient' => 'Display News Widget',
    'd_nw_enableclient' => 'Display the news icon and link on the index.php page of the client support interface.',
    'nw_enablenewsnav' => 'Display Latest News on Index Page (Navigation Bar)',
    'd_nw_enablenewsnav' => 'Display the latest news articles at the bottom of the navigation bar.',
    'nw_maxnewslist' => 'Maximum Number of Recent News Articles',
    'd_nw_maxnewslist' => 'The maximum number of most recent news articles that will be displayed in the navigation bar.',
    'nw_navdisplaydate' => 'Display Date Beside News Items',
    'd_nw_navdisplaydate' => 'Display the date a news posting was made alongside the title of the posting.',
    'nw_navdateformat' => 'Navigation News Date Format',
    'd_nw_navdateformat' => 'The format in which the posting date of news items is displayed. For more information, see the documentation for the PHP <a href="http://www.php.net/date" target="_blank">date()</a> function.',
    'nw_captcha' => 'Enable CAPTCHA for Comments',
    'd_nw_captcha' => 'If enabled, users will be required to verify a CAPTCHA image before submitting a comment.',        
    'nw_rss' => 'RSS Syndication Settings',
    'nw_enablerss' => 'Enable RSS Content Syndication',
    'd_nw_enablerss' => 'Allow users to subscribe to RSS feeds of posted news items.',
    'nw_maxrss' => 'Maximum Limit of Latest News Items for RSS Feed',
    'd_nw_maxrss' => 'The maximum number of news articles that will be syndicated into an RSS feed at any one time.',
    'nw_entab' => 'Display News Tab',
    'd_nw_entab' => 'Display the News tab within the Staff Control Panel.',
    'nw_svalidate' => 'Validate Subscriber E-mail Address',
    'd_nw_svalidate' => 'Specify whether '.SWIFTPRODUCT.' should verify the e-mail address of the user when they subscribe to news postings through the client support interface. Verification involves sending an e-mail to the user containing an activation link which they must click to activate the account.',
    'nw_pageno' => 'Number of News Items Per Page',
    'd_nw_pageno' => 'The number of news items shown on one page.',

    // ======= DOWNLOADS =======
    'dl_clientarea' => 'Downloads Settings',
    'dl_enableclient' => 'Display Downloads Widget',
    'd_dl_enableclient' => 'Show the Downloads icon and link on the index.php page of the client support interface.',
    'dl_enpopularfiles' => 'Display Popular Downloads Box',
    'd_dl_enpopularfiles' => 'Show a list of the most popular downloads on the index.php page of the client support interface.',
    'tr_maxpopularcat' => 'Maximum Number Of Troubleshooters To Display',
    'dl_maxpopularfiles' => 'Maximum Number Of Popular Downloads',
    'dl_dispdownloadcnt' => 'Display Download Count In Popular Downloads Box',
    'dl_enlatestfiles' => 'Display Latest Downloads Box',
    'd_dl_enlatestfiles' => 'Show a list of the most recently uploaded downloads on the index.php page of the client support interface.',
    'dl_maxlatestfiles' => 'Maximum Number Of Latest Downloads To Display',
    'dl_displaydldate' => 'Display Posting Date Of Latest Downloads',
    'dl_dispdateformat' => 'Posting Date Format',
    'd_dl_dispdateformat' => 'Specify the format used to display dates in download items. For more information, see the documentation for the PHP <a href="http://www.php.net/date" target="_blank">date()</a> function.',
    'dl_captcha' => 'Enable CAPTCHA for Comments',
    'd_dl_captcha' => 'If enabled, users will be required to verify a CAPTCHA image before submitting a comment.',    
    'dl_staffcp' => 'Downloads Staff Control Panel Settings',
    'dl_entab' => 'Display Downloads Tab',
    'd_dl_entab' => 'Show the Downloads tab within the staff control panel.',
    'dl_rss' => 'RSS Syndication Settings',
    'dl_enrss' => 'Enable RSS Content Syndication',
    'd_dl_enrss' => 'Allow users to subscribe to RSS feeds for new download item postings.',
    'dl_rsslinkfile' => 'Link Directly To Download',
    'd_dl_rsslinkfile' => 'Show a link directly to the download in the RSS feed for each download item. If disabled, a link to the download page will be included.',
    'dl_catindex' => 'Client Support Interface Category Index Settings',
    'dl_defaultdisp' => '-- Default Display Order --',
    'dl_alphabetical' => 'Alphabetical',
    'dl_chrono' => 'Chronological',
    'dl_totalitems' => 'Total Items',
    'dl_datemodified' => 'Date Modified',
    'dl_totaldownloads' => 'Total Downloads',
    'dl_asc' => 'Ascending',
    'dl_desc' => 'Descending',
    'dl_catdisplayorder' => 'Category Display Order Override',
    'd_dl_catdisplayorder' => 'Use this display order instead of the display order chosen when the categories were created. Select <i>Default Display Order</i> to use the display order specified when creating the categories.',
    'dl_catorder' => 'Category Display Order',
    'd_dl_catorder' => 'Select the default category display order.',
    'dl_itdisplayorder' => 'Download Items Display Order Override',
    'd_dl_itdisplayorder' => 'Use this display order instead of the display order chosen when the download items were created. Select <i>Default Display Order</i> to use the display order specified when creating the download items.',
    'dl_itorder' => 'Download Items Order Of Display',
    'd_dl_itorder' => 'The way the downloads will be ordered.',
    'dl_maxcatarticles' => 'Item Limit Under Subcategories',
    'd_dl_maxcatarticles' => 'The maximum number of downloads displayed under download subcategories.',
    'dl_displaymore' => 'Display More Download Link',
    'd_dl_displaymore' => 'Show a "Display More" link under download subcategories, showing users more downloads are available within a category.',
    'dl_catarticledetails' => 'Display Item Description In List',
    'd_dl_catarticledetails' => 'Show the description for a download item when listing items in a category.',
    'dl_climit' => 'Download Description Character Limit',
    'd_dl_climit' => 'The maximum number of characters shown for the download description (see the setting above).',

    // ======= KNOWLEDGEBASE =======
    'kb_clientarea' => 'General Knowledgebase Settings',
    'kb_clientareaindex' => 'Client Support Interface Index Page Settings',
    'kb_categoryindex' => 'Category Index Settings',
    'kb_enableclient' => 'Display Knowledgebase Widget',
    'd_kb_enableclient' => 'Show the knowledgebase icon and link on the index.php page of the client support interface.',
    'kb_enpopulararticles' => 'Display Popular Articles Box',
    'd_kb_enpopulararticles' => 'Show a list of the most popular knowledgebase articles on the index.php page of the client support interface.',
    'kb_maxpopulararticles' => 'Maximum Number Of Popular Articles',
    'kb_dispviews' => 'Display View Count Next To Popular Articles',
    'kb_enlatestarticles' => 'Display Latest Articles Box',
    'd_kb_enlatestarticles' => 'Show a list of the most recent knowledgebase articles on the <i>index.php</i> page of the client support interface.',
    'kb_maxlatestarticles' => 'Maximum Number Of Latest Articles',
    'kb_displayarticledate' => 'Display Creation Date Next To Latest Articles',
    'kb_dateformat' => 'Creation Date Format',
    'd_kb_dateformat' => 'Specify the format used to display creation dates in articles. For more information, see the documentation for the PHP <a href="http://www.php.net/date" target="_blank">date()</a> function.',
    'kb_maxcatarticles' => 'Maximum Number of Articles to Display under Category List',
    'kb_displaymore' => 'Display "More Topics" Link Under Category List',
    'kb_catarticledetails' => 'Display Article Details Under Category List',
    'kb_alphabetical' => 'Alphabetical',
    'kb_chrono' => 'Chronological',
    'kb_totalarticles' => 'Total Articles',
    'kb_catdisplayorder' => 'Override Category Display Order Field',
    'd_kb_catdisplayorder' => 'Specify the display order to be used when sorting categories. Select <i>Default Display Order</i> to use the display order specified when creating article categories.',
    'kb_catorder' => 'Category Order Of Display',
    'kb_asc' => 'Ascending',
    'kb_desc' => 'Descending',
    'kb_arorder' => 'Article Order Of Display',
    'd_kb_ardisplayorder' => 'Use the specified display order to sort articles. Select <i>Default Display Order</i> to use the display order specified when creating articles.',
    'kb_ardisplayorder' => 'Override <i>Article Display Order</i> Field',
    'kb_captcha' => 'Enable CAPTCHA for Comments',
    'd_kb_captcha' => 'If enabled, users will be required to verify a CAPTCHA image before submitting a comment.',
    'kb_datemodified' => 'Date Modified',
    'kb_views' => 'Total Views',
    'kb_rating' => 'Article Rating',
    'kb_defaultdisp' => '-- Default Display Order --',
    'kb_enrss' => 'Enable RSS Content Syndication',
    'kb_rss' => 'RSS Syndication Settings',
    'd_kb_enrss' => 'Enable users to subscribe to new article postings.',
    'kb_climit' => 'Article Preview Character Limit',
    'd_kb_climit' => 'The maximum number of characters that will be displayed for an article preview under a category index. To disable article previews, set this value to "0".',
    'kb_rssclimit' => 'RSS Feed Character Limit',
    'd_kb_rssclimit' => 'The maximum number of characters of an article that will be syndicated into an RSS feed.',
    'kb_enrating' => 'Enable Article Rating',
    'd_kb_enrating' => 'Allow staff to rate articles.',
    'kb_staffcp' => 'Knowledgebase Staff Control Panel Settings',
    'kb_staffwysiwyg' => 'Enable WYSIWYG Editor',
    'd_kb_staffwysiwyg' => 'Use the advanced WYSIWYG editor (rich text) for creating new articles.',
    'kb_entab' => 'Display Knowledgebase Tab',
    'd_kb_entab' => 'Enable the Knowledgebase tab within the Staff Control Panel.',
    'kb_parcount' => 'Count Articles In Subcategories',
    'd_kb_parcount' => 'If enabled, ' .SWIFTPRODUCT. ' will include articles stored in subcategories when counting articles in a category. Deeply nested knowledgebase structures can be very resource intensive.',

    // ======= TEAMWORK =======
    # 'tw_syncworks' => 'SyncWorks Settings',
    'tw_syncworks' => 'There are no settings available for this module.',

    //======== PURCHASER ======
    'settings_purchase' => 'Ticket Purchaser',
    'purchase_admin_email' => 'Billing Email',
    'purchase_money_format' => 'Currency Symbol Position',
    'purchase_number_format_style' => 'Number Format',
    'purchase_money_sign' => 'Currency Symbol',
    'purchase_bluepay_account' => 'Bluepay Account Number',
    'purchase_bluepay_key' => 'Bluepay Secret Key',
    'purchase_bluepay_mode' => 'Bluepay Transaction Mode',
    'purchase_bluepay_mode_test' => 'Test',
    'purchase_bluepay_mode_live' => 'Live',
    'purchase_invoice_address' => 'Billing address to display on invoices',

);

?>