<?php
//=======================================
//###################################
// Kayako Infotech Ltd. - SWIFT Framework
//
// Source Copyright 2001-2008 Kayako Infotech Ltd.
// Unauthorized reproduction is not allowed
// License Number: $%LICENSE%$
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//                   www.kayako.com
//###################################
//=======================================

if (!defined("INSWIFT")) {
	trigger_error("Unable to process " . htmlentities($_SERVER['PHP_SELF']), E_USER_ERROR);
}

ob_start();
require_once ("./includes/functions_html.php");

/**
* ###############################################
* CLIENT LOGIN
* ###############################################
*/

$loginEmailAddr = htmlspecialchars($_REQUEST["loginemail"]);

if ($eventaction == "login")
{
	// Do we need to cookie the username and password?
	$loginemailcookie = $cookie->getSCookie("loginemail");
	$loginpasscookie = $cookie->getSCookie("loginpassword");

	if ($loginemailcookie != $loginEmailAddr || decryptCookiePassword($loginpasscookie) != $_REQUEST["loginpassword"])
	{
		unset($_COOKIE['loginemail']);
		unset($_COOKIE['loginpassword']);
		$cookie->emptySCookie("loginemail");
		$cookie->emptySCookie("loginpassword");
	}

	if ($_POST["rememberme"] && (empty($loginemailcookie) || $loginemailcookie != $loginEmailAddr))
	{
		$expiry = DATENOW + 60*60*24*365;
		unset($_COOKIE['loginemail']);
		unset($_COOKIE['loginpassword']);

		$path = ($_SWIFT["settings"]["security_cookiepath"] == "") ? "/" : $_SWIFT["settings"]["security_cookiepath"];
		$domain = ($_SWIFT["settings"]["security_cookiedomain"] == "") ? "" : $_SWIFT["settings"]["security_cookiedomain"];
		$secure = (($_SWIFT["settings"]["security_securecookie"] == 1) && IS_HTTPS) ? true : false;

		SetCookie("SWIFT_".'loginemail', $loginEmailAddr, $expiry, $path, $domain, $secure);
		SetCookie("SWIFT_".'loginpassword', encryptCookiePassword($_POST["loginpassword"]), $expiry, $path, $domain, $secure);

		// SetCookie("SWIFT_".'loginemail', $_POST['loginemail'], $expiry, iif($_SWIFT["settings"]["security_cookiepath"]=="", "/", $_SWIFT["settings"]["security_cookiepath"]), iif($_SWIFT["settings"]["security_cookiedomain"]=="", "", $_SWIFT["settings"]["security_cookiedomain"]));
		// SetCookie("SWIFT_".'loginpassword', encryptCookiePassword($_POST["loginpassword"]), $expiry, iif($_SWIFT["settings"]["security_cookiepath"]=="", "/", $_SWIFT["settings"]["security_cookiepath"]), iif($_SWIFT["settings"]["security_cookiedomain"]=="", "", $_SWIFT["settings"]["security_cookiedomain"]));

	} else if (!$_POST["rememberme"]){
		unset($_COOKIE['loginemail']);
		unset($_COOKIE['loginpassword']);
		$cookie->emptySCookie("loginemail");
		$cookie->emptySCookie("loginpassword");
	}

	if (trim($loginEmailAddr) != "" && trim($_REQUEST["loginpassword"]) != "")
	{
		$loginresult = $loginshare->authorize(strtolower($loginEmailAddr), $_REQUEST["loginpassword"]);
	} else {
		$loginresult = -5;
	}

	if ($_SWIFT["user"]["usergroupid"] != $_SWIFT["tgroup"]["regusergroupid"] && $_SWIFT["tgroup"]["restrictgroups"] == 1 && $loginresult == 1)
	{
		// Restriction is in place
		$loginshare->logout();
		$tgroup = $_SWIFT["tgroup"]["title"];


		if (!empty($_POST["querystring"]) && !stristr($_POST["querystring"], "&do=va") && !stristr($_POST["querystring"], "loginresult=0"))
		{
			$_redirecturl = "index.php?loginresult=0&group=".urlencode($tgroup)."&".$_POST["querystring"];
		} else {
			$_redirecturl = "index.php?loginresult=0&group=".urlencode($tgroup);
		}

		printRedirect($_SWIFT["language"]["processinglogin"], htmlspecialchars($_redirecturl), true);
		ob_end_flush();
		exit;
	}

	// Lookup for a different template group
	$tgroup = $_SWIFT["tgroup"]["title"];

	// Does this user belong to this user group?
	if ($_SWIFT["user"]["usergroupid"] != $_SWIFT["tgroup"]["regusergroupid"])
	{
		foreach ($_SWIFT["tgroupcache"] as $key=>$val)
		{
			if ($val["regusergroupid"] == $_SWIFT["user"]["usergroupid"] && !empty($_SWIFT["user"]["usergroupid"]) && $_SWIFT["tgroup"]["tgroupid"] != $val["tgroupid"])
			{
				$tgroup = $val["title"];
				break;
			}
		}
	}

	// Are we supposed to redirect with parameters?
	if (!empty($_POST["querystring"]) && !stristr($_POST["querystring"], "&do=va") && !stristr($_POST["querystring"], "loginresult=0"))
	{
		$_redirecturl = "index.php?loginresult=".urlencode($loginresult)."&group=".urlencode($tgroup)."&".$_POST["querystring"];
	} else {
		$_redirecturl = "index.php?loginresult=".urlencode($loginresult)."&group=".urlencode($tgroup);
	}

	printRedirect($_SWIFT["language"]["processinglogin"], htmlspecialchars($_redirecturl), true);
	ob_end_flush();
	exit;



/**
* ###############################################
* CLIENT LOGOUT
* ###############################################
*/
} else if ($eventaction == "logout") {
	$logoutresult = $loginshare->logout();

	// erase the cookies
//	$cookie->emptySCookie("loginemail");
//	$cookie->emptySCookie("loginpassword");

	if ($_SWIFT["settings"]["g_returnlogout"] == '1')
	{
		// Reset Template Group
		$cookie->parseCookie("client");
		$cookie->addCookie("client", "groupid", false);
		$cookie->buildCookie("client", true);
	}
	
	printRedirect($_SWIFT["language"]["loggingout"], "index.php?logoutresult=".urlencode($logoutresult), true);
	ob_end_flush();
	exit;
}
?>