<?php

//=======================================
//###################################
// Kayako Infotech Ltd. - SWIFT Framework
//
// Source Copyright 2001-2008 Kayako Infotech Ltd.
// Unauthorized reproduction is not allowed
// License Number: $%LICENSE%$
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//                   www.kayako.com
//###################################
//=======================================

if (!defined("INSWIFT")) {
    trigger_error("Unable to process " . htmlentities($_SERVER['PHP_SELF']), E_USER_ERROR);
}

if (!$staffauth->isAdmin()) {
    trigger_error("You do not have permission to access " . htmlentities($_SERVER['PHP_SELF']), E_USER_ERROR);
}

require_once ("./includes/functions_html.php");
require_once ("./modules/parser/functions_parser_loopcontrol.php");

$template->loadLanguageSection("emailparser");





  function GetLoopCutterGridOptionsForCutsInPlace() {
    
    $options = array();
    
    $options["recordsperpage"]    = "20";
    $options["sortby"]            = "restoretime";
    $options["sortorder"]         = "asc";
    
    $options["idname"]            = "emailloopcutsinplaceid";
    $options["quicksearch"]       = false;

    $options["callback"]          = "LoopCutterCutsInPlaceRowCallback";
	$options["advancedsearch"][0] = array('title' => 'Address', 'query' => 'SELECT * FROM `'. TABLE_PREFIX .'emailloopcutsinplace` WHERE `address` LIKE \'%$_searchstr%\' $_sortjoin;');
    
    return $options;
    
  }





  function GetLoopCutterGridOptionsForThreshholds() {

	global $_SWIFT;
		
    $options = array();
    
    $options["recordsperpage"]      = "20";
    $options["sortby"]              = "restoreafter";
    $options["sortorder"]           = "asc";
    
    $options["idname"]              = "emailloopthreshholdsid";
    $options["quicksearch"]         = false;
    
    $options["callback"]            = "LoopCutterThreshholdsRowCallback";
    
    $options["toolbar"][0]["title"] = $_SWIFT['language']['pr_insert_new_loopcutter_rule_title'];
    $options["toolbar"][0]["url"]   = "javascript:switchDisplay('insertloopcontrol');"; 

	$options["advancedsearch"][0]   = array('title' => 'Timeframe', 'query' => 'SELECT * FROM `'. TABLE_PREFIX .'emailloopthreshholds` WHERE `length` = $_searchstr $_sortjoin;');
	
    return $options;
    
  }





  function GetLoopCutterGridFieldsForThreshholds() {

// KACT 5/pages/412
	global $_SWIFT;
		
    $fields = array();
    
    $fields[0]["name"]  = "length";
    $fields[0]["title"] = $_SWIFT['language']['pr_threshhold_grid_timeframe_title']; 
    $fields[0]["width"] = "";
    
    $fields[1]["name"]  = "maxhits";
    $fields[1]["title"] = $_SWIFT['language']['pr_threshhold_grid_maxhits_title']; 
	$fields[1]["width"] = "200";
	$fields[1]["align"] = "center";
    
    $fields[2]["name"]  = "restoreafter";
    $fields[2]["title"] = $_SWIFT['language']['pr_threshhold_grid_restoreafter_title']; 
	$fields[2]["width"] = "180";
	$fields[2]["align"] = "center";
    
    $fields[3]["type"]  = "custom";
    $fields[3]["name"]  = "options";
    $fields[3]["title"] = $_SWIFT["language"]["options"]; 
    $fields[3]["width"] = "150";
    $fields[3]["align"] = "center";	
    
    return $fields;
    
  }





  function GetLoopCutterGridFieldsForCutsInPlace() {
    
// KACT 5/pages/412
	global $_SWIFT;
		
    $fields = array();
    
    $fields[0]["name"]  = "address";
    $fields[0]["title"] = $_SWIFT['language']['pr_threshhold_grid_address_title']; 
	$fields[0]["width"] = "";
	
    $fields[1]["name"]  = "restoretime";
    $fields[1]["title"] = $_SWIFT['language']['pr_threshhold_grid_restoreafter_title']; 
	$fields[1]["width"] = "200";
	$fields[1]["align"] = "center";

    $fields[2]["type"]  = "custom";
    $fields[2]["name"]  = "options";
    $fields[2]["title"] = $_SWIFT["language"]["options"]; 
    $fields[2]["width"] = "150";
    $fields[2]["align"] = "center";	

    return $fields;
    
  }





  function GetLoopCutterQueriesForCutsInPlace() {
    return array(
      'SELECT * FROM `'                      . TABLE_PREFIX .'emailloopcutsinplace` $_sortjoin;', 
      'SELECT COUNT(*) AS totalitems FROM `' . TABLE_PREFIX .'emailloopcutsinplace`;', 
      'SELECT * FROM `'                      . TABLE_PREFIX .'emailloopcutsinplace` WHERE `address` LIKE \'%$_searchstr%\' $_sortjoin;', 
    );
  }





  function GetLoopCutterQueriesForThreshholds() {
    return array(
      'SELECT * FROM `'                      . TABLE_PREFIX .'emailloopthreshholds` $_sortjoin;', 
      'SELECT COUNT(*) AS totalitems FROM `' . TABLE_PREFIX .'emailloopthreshholds`;', 
      'SELECT * FROM `'                      . TABLE_PREFIX .'emailloopthreshholds` WHERE `restoreafter` LIKE \'%$_searchstr%\' $_sortjoin;', 
    ); 
  }





  function LoopCutterThreshholdsRowCallback($arg) {

    global $_SWIFT;

    $record                 = &$arg[0];
    $fields                 = &$arg[1];
    
    $record['length']       = $record['length']       . ' seconds';
    $record['restoreafter'] = $record['restoreafter'] . ' seconds';
        
	$deleteaction           = "index.php?_m=parser&_a=deletelooprule&deleteloopruleid={$record["emailloopthreshholdsid"]}";
	
    $record["options"]      = "<a onClick=\"javascript:doConfirm('{$_SWIFT["language"]["actionconfirm"]}', '$deleteaction');\" href=\"#\" title=\"{$_SWIFT["language"]["delete"]}\"><img src=\"{$_SWIFT["themepath"]}icon_delete.gif\" border=\"0\">&nbsp;{$_SWIFT["language"]["delete"]}</a>&nbsp;";

    return $record;

  }





  function LoopCutterCutsInPlaceRowCallback($arg) {
    
    global $_SWIFT;
    
    $record                = &$arg[0];
    $fields                = &$arg[1];
    
	$deleteaction          = "index.php?_m=parser&_a=deleteloopblockage&deleteblockruleid={$record["emailloopcutsinplaceid"]}";
    
    $record['address']     = htmlentities($record['address']);
    $record['restoretime'] = strColorDate(-(mktime() - $record['restoretime']));
    
    $record["options"]     = "<a onClick=\"javascript:doConfirm('{$_SWIFT["language"]["actionconfirm"]}', '$deleteaction');\" href=\"#\" title=\"{$_SWIFT["language"]["delete"]}\"><img src=\"{$_SWIFT["themepath"]}icon_delete.gif\" border=\"0\">&nbsp;{$_SWIFT["language"]["delete"]}</a>&nbsp;";
    
    return $record;
    
  }





  function WriteInsertLoopControlPanel() {

	global $_SWIFT;
	
    echo '<div id="insertloopcontrol" style="display: none;">';
    
	printFormStart();
	printMainTableHeader($_SWIFT['language']['pr_new_loop_control_header_text']);  
	
	printTextRow("newloopcontrolwatchlength",  $_SWIFT['language']['pr_newloopcontrolwatchlength_title'],  $_SWIFT['language']['pr_newloopcontrolwatchlength_desc']);
	printTextRow("newloopcontrolmaxcontacts",  $_SWIFT['language']['pr_newloopcontrolmaxcontacts_title'],  $_SWIFT['language']['pr_newloopcontrolmaxcontacts_desc']);
	printTextRow("newloopcontrolrestoreafter", $_SWIFT['language']['pr_newloopcontrolrestoreafter_title'], $_SWIFT['language']['pr_newloopcontrolrestoreafter_desc']);
	
	printSubmitRow($_SWIFT["language"]["insert"]);
	
	printMainTableFooter();
	addHiddenField("_m", "parser");
	addHiddenField("_a", "addlooprule");
	addHiddenField("insertlooprule", "1");
	printFormEnd();	
    
    echo '<br/></div>';  // yes, to stay style consistent, that br has to be *inside* the div, grr
	
  }





  function RunLoopCutterAdminPanel($eventaction) {
	
	
	global $_SWIFT;
	
	global $interface;
	global $infomessage;
	global $errormessage;
	
	$WriteLoopControlPanel = false;
	
    switch ($eventaction) {

	  case "managelooprules" : 
	  case "addlooprule"     :
	  case "editlooprule"    :
	  case "deletelooprule"  :
		$breadcrumb = $_SWIFT["language"]["pr_mangelooprules"];
		$fillertext = $_SWIFT["language"]["pr_desc_looprules_filler"];
        $gtitle     = $_SWIFT["language"]["pr_loopcontrolrules"];
        $navaction  = "managelooprules";
	    $fields     = GetLoopCutterGridFieldsForThreshholds();
	    $options    = GetLoopCutterGridOptionsForThreshholds();
        list($contentsQuery, $countQuery, $searchQuery) = GetLoopCutterQueriesForThreshholds();
        $WriteLoopControlPanel = true;
        $gridname = "looprulegrid";
	    break;

	  case "manageloopblockage" : 
	  case "deleteloopblockage" :
		$breadcrumb = $_SWIFT["language"]["pr_manageloopblockages"];
		$fillertext = $_SWIFT["language"]["pr_desc_loopblockages_filler"];
        $gtitle     = $_SWIFT["language"]["pr_loopblockages"];
		$navaction  = "manageloopblockage";        
	    $fields     = GetLoopCutterGridFieldsForCutsInPlace();
	    $options    = GetLoopCutterGridOptionsForCutsInPlace();
        list($contentsQuery, $countQuery, $searchQuery) = GetLoopCutterQueriesForCutsInPlace();
        $gridname = "loopblockgrid";
	    break;
		
	}	
	
	$interface->adminHeader($_SWIFT["language"]["mailparser"]." &gt; ".$breadcrumb, 1);
	
	$interface->adminNavBar('<a href="index.php?_m=parser&_a=manageemailqueues" title="'.$_SWIFT["language"]["mailparser"].'">'.$_SWIFT["language"]["mailparser"].'</a> &raquo; <a href="index.php?_m=parser&_a='.$navaction.'" title="'.$breadcrumb.'">'.$breadcrumb.'</a>', $fillertext , 4);
	
	
	if ($eventaction == 'addlooprule') {
		AddLoopRule($_POST['newloopcontrolwatchlength'], $_POST['newloopcontrolmaxcontacts'], $_POST['newloopcontrolrestoreafter']); 		
		$infomessage .= $_SWIFT['language']['pr_new_loop_control_rule_added_desc'];  
	}
	
	if ($eventaction == 'deletelooprule') {
		if (trim($_GET['deleteloopruleid']) != '') { RemoveLoopRuleById($_GET['deleteloopruleid']); }  // if the grid was re-sorted, this will be null, so skip it
		$infomessage .= $_SWIFT['language']['pr_loop_rule_deleted'];  
	}
	
	if ($eventaction == 'deleteloopblockage') {
		if (trim($_GET['deleteblockruleid']) != '') { RemoveLoopBlockById($_GET['deleteblockruleid']); }  // if the grid was re-sorted, this will be null, so skip it
		$infomessage .= $_SWIFT['language']['pr_loop_block_deleted'];
	}
	
	
	printInfoBox($infomessage);
	printErrorBox($errormessage);

    RemoveObsoleteLoopBlocks();
    
    if ($WriteLoopControlPanel) { WriteInsertLoopControlPanel(); }
	
	$grid = new Grid();	
	
	$grid->start($gridname, $gtitle, $contentsQuery, $countQuery, $searchQuery, $fields, $options);
	$grid->display($gridname);
	
	$interface->adminFooter();
		
		
  }





  RunLoopCutterAdminPanel($eventaction);





?>