<?php
//=======================================
//###################################
// Kayako Infotech Ltd. - SWIFT Framework
//
// Source Copyright 2001-2008 Kayako Infotech Ltd.
// Unauthorized reproduction is not allowed
// License Number: $%LICENSE%$
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//                   www.kayako.com
//###################################
//=======================================

if (!defined("INSWIFT")) {
	trigger_error("Unable to process " . htmlentities($_SERVER['PHP_SELF']), E_USER_ERROR);
}

if (!$staffauth->isAdmin()) {
	trigger_error("You do not have permission to access " . htmlentities($_SERVER['PHP_SELF']), E_USER_ERROR);
}

require_once ("./modules/teamwork/functions_misc.php");
require_once ("./includes/functions_html.php");

$template->loadLanguageSection("admin_teamwork");

/**
* ###############################################
* FUNCTION DECLARATIONS
* ###############################################
*/

/**
* Callback for Calendar Categories
*/
function _calendarCategoryFields($arg)
{
	global $_SWIFT;
	$record = &$arg[0];
	$fields = &$arg[1];

	$record["title"] = '<a href="index.php?_m=teamwork&_a=editcategory&calendarcategoryid='. $record["calendarcategoryid"] .'"><img src="'. $_SWIFT["themepath"] .'icon_folderyellow3.gif" border="0" align="absmiddle" /> '.htmlspecialchars($record["title"]).'</a>';

	if ($record["categorytype"] == CATEGORY_CONTACT)
	{
		$record["categorytype"] = '<img src="'. $_SWIFT["themepath"] .'icon_contacts.gif" border="0" align="absmiddle" /> '.$_SWIFT["language"]["contact"];
	} else if ($record["categorytype"] == CATEGORY_EVENT) {
		$record["categorytype"] = '<img src="'. $_SWIFT["themepath"] .'icon_event.gif" border="0" align="absmiddle" /> '.$_SWIFT["language"]["event"];
	}

	$record["options"] = '<a href="index.php?_m=teamwork&_a=editcategory&calendarcategoryid='. $record["calendarcategoryid"] .'" title="'. $_SWIFT["language"]["edit"] .'"><img src="'. $_SWIFT["themepath"] .'icon_edit.gif" border="0">&nbsp;'. $_SWIFT["language"]["edit"] .'</a>&nbsp;&nbsp;&nbsp;&nbsp;<a onClick="javascript:doConfirm(\''. $_SWIFT["language"]["actionconfirm"] .'\', \'index.php?_m=teamwork&_a=managecategories&do=delete&calendarcategoryid='. $record["calendarcategoryid"] .'\');" href="#" title="'. $_SWIFT["language"]["delete"] .'"><img src="'. $_SWIFT["themepath"] .'icon_delete.gif" border="0">&nbsp;'. $_SWIFT["language"]["delete"] .'</a>&nbsp;';

	return $record;
}

/**
* Delete Callback
*/
function _maDeleteCalendarCategory()
{
	global $dbCore, $_SWIFT;

	if ($_SWIFT["isdemo"] == true)
	{
		return false;
	}

	if (is_array($_POST["itemid"]))
	{
		deleteCalendarCategory($_POST["itemid"]);
		$_SWIFT["infomessage"] = $_SWIFT["language"]["catmuldelconfirm"];
	}
}


/**
* ###############################################
* MANAGE CATEGORIES
* ###############################################
*/
if ($eventaction == "managecategories")
{
	if ($_GET["do"] == "delete" && !empty($_GET["calendarcategoryid"]) && $_SWIFT["isdemo"] != true)
	{
		$_SWIFT["infomessage"] = $_SWIFT["language"]["catmuldelconfirm"];

		deleteCalendarCategory(array($_GET["calendarcategoryid"]));
	}

	if (!empty($_GET["insertcat"]))
	{
		$_SWIFT["infomessage"] = sprintf($_SWIFT["language"]["catinsertconfirm"], htmlspecialchars($_GET["insertcat"]));
	} else if (!empty($_GET["updatecat"])) {
		$_SWIFT["infomessage"] = sprintf($_SWIFT["language"]["catupdateconfirm"], htmlspecialchars($_GET["updatecat"]));
	}

	$options["recordsperpage"] = "15";
	$options["sortby"] = "categorytype";
	$options["sortorder"] = "asc";
	$options["massaction"][0]["title"] = $_SWIFT["language"]["delete"];
	$options["massaction"][0]["callback"] = "_maDeleteCalendarCategory";

	$options["idname"] = "calendarcategoryid";
	$options["quicksearch"] = true;

	$options["advancedsearch"][0]["title"] = $_SWIFT["language"]["title"];
	$options["advancedsearch"][0]["query"] = 'SELECT * FROM `'. TABLE_PREFIX .'calendarcategories` WHERE `title` LIKE \'%$_searchstr%\' $_sortjoin;';

	$options["callback"] = "_calendarCategoryFields";

	$options["toolbar"][0]["title"] = $_SWIFT["language"]["insertcategory"];
	$options["toolbar"][0]["url"] = "index.php?_m=teamwork&_a=insertcategory";

	$fields[0]["name"] = "title";
	$fields[0]["title"] = $_SWIFT["language"]["categorytitle"];
	$fields[0]["width"] = "";

	$fields[1]["name"] = "categorytype";
	$fields[1]["title"] = $_SWIFT["language"]["categorytype"];
	$fields[1]["width"] = "180";
	$fields[1]["align"] = "center";

	$fields[2]["name"] = "displayorder";
	$fields[2]["title"] = $_SWIFT["language"]["displayorder"];
	$fields[2]["width"] = "120";
	$fields[2]["align"] = "center";

	$fields[3]["type"] = "custom";
	$fields[3]["name"] = "options";
	$fields[3]["title"] = $_SWIFT["language"]["options"];
	$fields[3]["width"] = "150";
	$fields[3]["align"] = "center";

	$grid = new Grid();

	$interface->adminHeader($_SWIFT["language"]["teamwork"]." &gt; ".$_SWIFT["language"]["managecategories"], 1);

	$interface->adminNavBar('<a href="index.php?_m=core&_a=dashboard" title="'.$_SWIFT["language"]["dashboard"].'">'.$_SWIFT["language"]["dashboard"].'</a> &raquo; <a href="index.php?_m=teamwork&_a=managestatus" title="'.$_SWIFT["language"]["teamwork"].'">'.$_SWIFT["language"]["teamwork"].'</a> &raquo; <a href="index.php?_m=teamwork&_a=managecategories" title="'.$_SWIFT["language"]["managecategories"].'">'.$_SWIFT["language"]["managecategories"].'</a>', $_SWIFT["language"]["desc_categories"] , 15);

	$grid->start("teamcategories", $_SWIFT["language"]["categorylist"], 'SELECT * FROM `'. TABLE_PREFIX .'calendarcategories` $_sortjoin;', 'SELECT COUNT(*) AS totalitems FROM `'. TABLE_PREFIX .'calendarcategories`;', 'SELECT * FROM `'. TABLE_PREFIX .'calendarcategories` WHERE `title` LIKE \'%$_searchstr%\' $_sortjoin;', $fields, $options);

	printInfoBox($_SWIFT["infomessage"]);
	printErrorBox($_SWIFT["errormessage"]);

	$grid->display("teamcategories");

	$interface->adminFooter();






/**
* ###############################################
* INSERT CATEGORY
* ###############################################
*/
} else if ($eventaction == "insertcategory") {
	if ($_POST["step"] == "1")
	{
		if (trim($_POST["title"]) == "" || trim($_POST["displayorder"]) == "")
		{
			$errormessage = $_SWIFT["language"]["requiredfieldempty"];
		} else if ($_SWIFT["isdemo"] == true) {
			$errormessage = $_SWIFT["langauge"]["demomode"];
		} else {
			insertCalendarCategory($_POST["categorytype"], $_POST["title"], $_POST["displayorder"]);

			printRedirect(sprintf($_SWIFT["language"]["catinsertconfirm"], htmlspecialchars($_POST["title"])), "index.php?_m=teamwork&_a=managecategories&insertcat=".urlencode($_POST["title"]));
			exit;
		}
	}

	$interface->adminHeader($_SWIFT["language"]["teamwork"]." &gt; ".$_SWIFT["language"]["insertcategory"], 1);

	$interface->adminNavBar('<a href="index.php?_m=core&_a=dashboard" title="'.$_SWIFT["language"]["dashboard"].'">'.$_SWIFT["language"]["dashboard"].'</a> &raquo; <a href="index.php?_m=teamwork&_a=managestatus" title="'.$_SWIFT["language"]["teamwork"].'">'.$_SWIFT["language"]["teamwork"].'</a> &raquo; <a href="index.php?_m=teamwork&_a=managecategories" title="'.$_SWIFT["language"]["managecategories"].'">'.$_SWIFT["language"]["managecategories"].'</a> &raquo; <a href="index.php?_m=teamwork&_a=insertcategory" title="'.$_SWIFT["language"]["insertcategory"].'">'.$_SWIFT["language"]["insertcategory"].'</a>', $_SWIFT["language"]["desc_categories"] , 15);

	printInfoBox($_SWIFT["infomessage"]);
	printErrorBox($_SWIFT["errormessage"]);

	renderCalendarCategoryForm(INSERT);

	$template->assign("backurl", "index.php?_m=teamwork&_a=managecategories");
	$interface->adminFooter();






/**
* ###############################################
* EDIT CATEGORY
* ###############################################
*/
} else if ($eventaction == "editcategory") {
	$_calendarcategory = $dbCore->queryFetch("SELECT * FROM `". TABLE_PREFIX ."calendarcategories` WHERE `calendarcategoryid` = '". intval($_REQUEST["calendarcategoryid"]) ."';");
	if (empty($_calendarcategory["calendarcategoryid"]))
	{
		trigger_error($_SWIFT["language"]["invalidcategory"], E_USER_ERROR);
	}

	if ($_POST["step"] == "1")
	{
		if (trim($_POST["title"]) == "" || trim($_POST["displayorder"]) == "")
		{
			$errormessage = $_SWIFT["language"]["requiredfieldempty"];
		} else if ($_SWIFT["isdemo"] == true) {
			$errormessage = $_SWIFT["language"]["demomode"];
		} else {
			updateCalendarCategory($_calendarcategory["calendarcategoryid"], $_POST["categorytype"], $_POST["title"], $_POST["displayorder"]);

			printRedirect(sprintf($_SWIFT["language"]["catupdateconfirm"], htmlspecialchars($_POST["title"])), "index.php?_m=teamwork&_a=managecategories&updatecat=".urlencode($_POST["title"]));
			exit;
		}
	}

	$_POST = array_merge($_POST, $_calendarcategory);

	$interface->adminHeader($_SWIFT["language"]["teamwork"]." &gt; ".$_SWIFT["language"]["editcategory"], 1);

	$interface->adminNavBar('<a href="index.php?_m=core&_a=dashboard" title="'.$_SWIFT["language"]["dashboard"].'">'.$_SWIFT["language"]["dashboard"].'</a> &raquo; <a href="index.php?_m=teamwork&_a=managestatus" title="'.$_SWIFT["language"]["teamwork"].'">'.$_SWIFT["language"]["teamwork"].'</a> &raquo; <a href="index.php?_m=teamwork&_a=managecategories" title="'.$_SWIFT["language"]["managecategories"].'">'.$_SWIFT["language"]["managecategories"].'</a> &raquo; <a href="index.php?_m=teamwork&_a=editcategory&calendarcategoryid='. intval($_calendarcategory["calendarcategoryid"]) .'" title="'.$_SWIFT["language"]["editcategory"].'">'.$_SWIFT["language"]["editcategory"].'</a>', $_SWIFT["language"]["desc_categories"] , 15);

	printInfoBox($_SWIFT["infomessage"]);
	printErrorBox($_SWIFT["errormessage"]);

	renderCalendarCategoryForm(EDIT);

	$template->assign("backurl", "index.php?_m=teamwork&_a=managecategories");
	$interface->adminFooter();
}



?>