<?php
//=======================================
//###################################
// Kayako Infotech Ltd. - SWIFT Framework
//
// Source Copyright 2001-2008 Kayako Infotech Ltd.
// Unauthorized reproduction is not allowed
// License Number: $%LICENSE%$
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//                   www.kayako.com
//###################################
//=======================================

if (!defined("INSWIFT")) {
	trigger_error("Unable to process " . htmlentities($_SERVER['PHP_SELF']), E_USER_ERROR);
}

if (!$staffauth->isAdmin()) {
	trigger_error("You do not have permission to access " . htmlentities($_SERVER['PHP_SELF']), E_USER_ERROR);
}

require_once ("./modules/teamwork/functions_misc.php");
require_once ("./includes/functions_html.php");

$template->loadLanguageSection("admin_teamwork");

/**
* ###############################################
* FUNCTION DECLARATIONS
* ###############################################
*/

/**
* Callback for Calendar Labels
*/
function _calendarLabelFields($arg)
{
	global $_SWIFT;
	$record = &$arg[0];
	$fields = &$arg[1];

	$record["title"] = '<a href="index.php?_m=teamwork&_a=editlabel&calendarlabelid='. $record["calendarlabelid"] .'"><img src="'. $_SWIFT["themepath"] .'icon_teamworklabel.gif" border="0" align="absmiddle" /> <font color="'. $record["labelcolorcode"] .'">'.htmlspecialchars($record["title"]).'</font></a>';

	if ($record["labeltype"] == LABEL_TASK)
	{
		$record["labeltype"] = '<img src="'. $_SWIFT["themepath"] .'icon_task.gif" border="0" align="absmiddle" /> '.$_SWIFT["language"]["task"];
	} else if ($record["labeltype"] == LABEL_EVENT) {
		$record["labeltype"] = '<img src="'. $_SWIFT["themepath"] .'icon_event.gif" border="0" align="absmiddle" /> '.$_SWIFT["language"]["event"];
	}

	$record["options"] = '<a href="index.php?_m=teamwork&_a=editlabel&calendarlabelid='. $record["calendarlabelid"] .'" title="'. $_SWIFT["language"]["edit"] .'"><img src="'. $_SWIFT["themepath"] .'icon_edit.gif" border="0">&nbsp;'. $_SWIFT["language"]["edit"] .'</a>&nbsp;&nbsp;&nbsp;&nbsp;<a onClick="javascript:doConfirm(\''. $_SWIFT["language"]["actionconfirm"] .'\', \'index.php?_m=teamwork&_a=managelabels&do=delete&calendarlabelid='. $record["calendarlabelid"] .'\');" href="#" title="'. $_SWIFT["language"]["delete"] .'"><img src="'. $_SWIFT["themepath"] .'icon_delete.gif" border="0">&nbsp;'. $_SWIFT["language"]["delete"] .'</a>&nbsp;';

	return $record;
}

/**
* Delete Callback
*/
function _maDeleteCalendarLabel()
{
	global $dbCore, $_SWIFT;

	if ($_SWIFT["isdemo"] == true)
	{
		return false;
	}

	if (is_array($_POST["itemid"]))
	{
		deleteCalendarLabels($_POST["itemid"]);
		$_SWIFT["infomessage"] = $_SWIFT["language"]["labelmuldelconfirm"];
	}
}


/**
* ###############################################
* MANAGE LABELS
* ###############################################
*/
if ($eventaction == "managelabels")
{
	if ($_GET["do"] == "delete" && !empty($_GET["calendarlabelid"]) && $_SWIFT["isdemo"] != true)
	{
		$_SWIFT["infomessage"] = $_SWIFT["language"]["labelmuldelconfirm"];

		deleteCalendarLabels(array($_GET["calendarlabelid"]));
	}

	if (!empty($_GET["insertlabel"]))
	{
		$_SWIFT["infomessage"] = sprintf($_SWIFT["language"]["labelinsertconfirm"], htmlspecialchars($_GET["insertlabel"]));
	} else if (!empty($_GET["updatelabel"])) {
		$_SWIFT["infomessage"] = sprintf($_SWIFT["language"]["labelupdateconfirm"], htmlspecialchars($_GET["updatelabel"]));
	}

	$options["recordsperpage"] = "15";
	$options["sortby"] = "labeltype";
	$options["sortorder"] = "asc";
	$options["massaction"][0]["title"] = $_SWIFT["language"]["delete"];
	$options["massaction"][0]["callback"] = "_maDeleteCalendarLabel";

	$options["idname"] = "calendarlabelid";
	$options["quicksearch"] = true;

	$options["advancedsearch"][0]["title"] = $_SWIFT["language"]["title"];
	$options["advancedsearch"][0]["query"] = 'SELECT * FROM `'. TABLE_PREFIX .'calendarlabels` WHERE `title` LIKE \'%$_searchstr%\' $_sortjoin;';

	$options["callback"] = "_calendarLabelFields";

	$options["toolbar"][0]["title"] = $_SWIFT["language"]["insertlabel"];
	$options["toolbar"][0]["url"] = "index.php?_m=teamwork&_a=insertlabel";

	$fields[0]["name"] = "title";
	$fields[0]["title"] = $_SWIFT["language"]["labeltitle"];
	$fields[0]["width"] = "";

	$fields[1]["name"] = "labeltype";
	$fields[1]["title"] = $_SWIFT["language"]["labeltype"];
	$fields[1]["width"] = "180";
	$fields[1]["align"] = "center";

	$fields[2]["name"] = "displayorder";
	$fields[2]["title"] = $_SWIFT["language"]["displayorder"];
	$fields[2]["width"] = "120";
	$fields[2]["align"] = "center";

	$fields[3]["type"] = "custom";
	$fields[3]["name"] = "options";
	$fields[3]["title"] = $_SWIFT["language"]["options"];
	$fields[3]["width"] = "150";
	$fields[3]["align"] = "center";

	$grid = new Grid();

	$interface->adminHeader($_SWIFT["language"]["teamwork"]." &gt; ".$_SWIFT["language"]["managelabels"], 1);

	$interface->adminNavBar('<a href="index.php?_m=core&_a=dashboard" title="'.$_SWIFT["language"]["dashboard"].'">'.$_SWIFT["language"]["dashboard"].'</a> &raquo; <a href="index.php?_m=teamwork&_a=managestatus" title="'.$_SWIFT["language"]["teamwork"].'">'.$_SWIFT["language"]["teamwork"].'</a> &raquo; <a href="index.php?_m=teamwork&_a=managelabels" title="'.$_SWIFT["language"]["managelabels"].'">'.$_SWIFT["language"]["managelabels"].'</a>', $_SWIFT["language"]["desc_labels"] , 15);


	$grid->start("teamlabels", $_SWIFT["language"]["labellist"], 'SELECT * FROM `'. TABLE_PREFIX .'calendarlabels` $_sortjoin;', 'SELECT COUNT(*) AS totalitems FROM `'. TABLE_PREFIX .'calendarlabels`;', 'SELECT * FROM `'. TABLE_PREFIX .'calendarlabels` WHERE `title` LIKE \'%$_searchstr%\' $_sortjoin;', $fields, $options);

	printInfoBox($_SWIFT["infomessage"]);
	printErrorBox($_SWIFT["errormessage"]);

	$grid->display("teamlabels");

	$interface->adminFooter();





/**
* ###############################################
* INSERT LABEL
* ###############################################
*/
} else if ($eventaction == "insertlabel") {
	if ($_POST["step"] == "1")
	{
		if (trim($_POST["title"]) == "" || trim($_POST["displayorder"]) == "")
		{
			$errormessage = $_SWIFT["language"]["requiredfieldempty"];
		} else if ($_SWIFT["isdemo"] == true) {
			$errormessage = $_SWIFT["language"]["demomode"];
		} else {
			insertCalendarLabel($_POST["labeltype"], $_POST["title"], $_POST["labelcolorcode"], $_POST["displayorder"]);

			printRedirect(sprintf($_SWIFT["language"]["labelinsertconfirm"], htmlspecialchars($_POST["title"])), "index.php?_m=teamwork&_a=managelabels&insertlabel=".urlencode($_POST["title"]));
			exit;
		}
	}

	$interface->adminHeader($_SWIFT["language"]["teamwork"]." &gt; ".$_SWIFT["language"]["insertlabel"], 1);

	$interface->adminNavBar('<a href="index.php?_m=core&_a=dashboard" title="'.$_SWIFT["language"]["dashboard"].'">'.$_SWIFT["language"]["dashboard"].'</a> &raquo; <a href="index.php?_m=teamwork&_a=managestatus" title="'.$_SWIFT["language"]["teamwork"].'">'.$_SWIFT["language"]["teamwork"].'</a> &raquo; <a href="index.php?_m=teamwork&_a=managelabels" title="'.$_SWIFT["language"]["managelabels"].'">'.$_SWIFT["language"]["managelabels"].'</a> &raquo; <a href="index.php?_m=teamwork&_a=insertlabel" title="'.$_SWIFT["language"]["insertlabel"].'">'.$_SWIFT["language"]["insertlabel"].'</a>', $_SWIFT["language"]["desc_labels"] , 15);

	printInfoBox($_SWIFT["infomessage"]);
	printErrorBox($_SWIFT["errormessage"]);

	renderCalendarLabelForm(INSERT);

	$template->assign("backurl", "index.php?_m=teamwork&_a=managelabels");
	$interface->adminFooter();



/**
* ###############################################
* EDIT LABEL
* ###############################################
*/
} else if ($eventaction == "editlabel") {
	$_calendarlabel = $dbCore->queryFetch("SELECT * FROM `". TABLE_PREFIX ."calendarlabels` WHERE `calendarlabelid` = '". intval($_REQUEST["calendarlabelid"]) ."';");
	if (empty($_calendarlabel["calendarlabelid"]))
	{
		trigger_error($_SWIFT["language"]["invalidlabel"], E_USER_ERROR);
	}

	if ($_POST["step"] == "1")
	{
		if (trim($_POST["title"]) == "" || trim($_POST["displayorder"]) == "")
		{
			$errormessage = $_SWIFT["language"]["requiredfieldempty"];
		} else if ($_SWIFT["isdemo"] == true) {
			$errormessage = $_SWIFT["language"]["demomode"];
		} else {
			updateCalendarLabel($_calendarlabel["calendarlabelid"], $_POST["labeltype"], $_POST["title"], $_POST["labelcolorcode"], $_POST["displayorder"]);

			printRedirect(sprintf($_SWIFT["language"]["labelupdateconfirm"], htmlspecialchars($_POST["title"])), "index.php?_m=teamwork&_a=managelabels&updatelabel=".urlencode($_POST["title"]));
			exit;
		}
	}

	$_POST = array_merge($_POST, $_calendarlabel);

	$interface->adminHeader($_SWIFT["language"]["teamwork"]." &gt; ".$_SWIFT["language"]["editlabel"], 1);

	$interface->adminNavBar('<a href="index.php?_m=core&_a=dashboard" title="'.$_SWIFT["language"]["dashboard"].'">'.$_SWIFT["language"]["dashboard"].'</a> &raquo; <a href="index.php?_m=teamwork&_a=managestatus" title="'.$_SWIFT["language"]["teamwork"].'">'.$_SWIFT["language"]["teamwork"].'</a> &raquo; <a href="index.php?_m=teamwork&_a=managelabels" title="'.$_SWIFT["language"]["managelabels"].'">'.$_SWIFT["language"]["managelabels"].'</a> &raquo; <a href="index.php?_m=teamwork&_a=editlabel&calendarlabelid='. intval($_calendarlabel["calendarlableid"]) .'" title="'.$_SWIFT["language"]["editlabel"].'">'.$_SWIFT["language"]["editlabel"].'</a>', $_SWIFT["language"]["desc_labels"] , 15);

	printInfoBox($_SWIFT["infomessage"]);
	printErrorBox($_SWIFT["errormessage"]);

	renderCalendarLabelForm(EDIT);

	$template->assign("backurl", "index.php?_m=teamwork&_a=managelabels");
	$interface->adminFooter();

}



?>