<?php
//=======================================
//###################################
// Kayako Infotech Ltd. - SWIFT Framework
//
// Source Copyright 2001-2008 Kayako Infotech Ltd.
// Unauthorized reproduction is not allowed
// License Number: $%LICENSE%$
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//                   www.kayako.com
//###################################
//=======================================

if (!defined("INSWIFT")) {
    trigger_error("Unable to process " . htmlentities($_SERVER['PHP_SELF']), E_USER_ERROR);
}


debug("======== cron_autoclose.php ========");


if ( $_SWIFT["settings"]["t_enautoclose"] == 1 )
{
    debug("Autoclose system is enabled, starting up...");


    if ( _is_array($_SWIFT["settings"]["t_acstatus"]) ) $acTicketStatusList = $_SWIFT["settings"]["t_acstatus"];
    $debugTemp = print_r($acTicketStatusList, true);
    debug("List of autoclose statuses: " . $debugTemp);


    if ( _is_array($_SWIFT["settings"]["t_acdep"]) ) $acDepartmentList = $_SWIFT["settings"]["t_acdep"];
    $debugTemp = print_r($acDepartmentList, true);
    debug("List of departments monitored by autoclose system: " . $debugTemp);


    $acTargetStatus = $_SWIFT["statuscache"][$_SWIFT["settings"]["t_acstatusch"]];
    debug("Auto close target status: " . $acTargetStatus["ticketstatusid"]);


    if ( count($acTicketStatusList)
        && count($acDepartmentList)
        && !empty($acTargetStatus["ticketstatusid"])
        && !empty($_SWIFT["settings"]["t_acinactive"])
        && !empty($_SWIFT["settings"]["t_acnoticeclose"])
    )
    {

        $acInactiveNoticeThreshold = DATENOW - ($_SWIFT["settings"]["t_acinactive"]*60*60);
        debug("Auto close inactive notice threshold: " . $acInactiveNoticeThreshold . " (".date("F j, Y, g:i a",$acInactiveNoticeThreshold) . ")");


        $acTime = DATENOW + ($_SWIFT["settings"]["t_acnoticeclose"]*60*60);
        debug("Auto close final time: " . $acTime . " (". date("F j, Y, g:i a",$acTime) . ")");

        debug("Time now: " . DATENOW . " (" .date("F j, Y, g:i a",DATENOW) . ")");


        // Fetching the list of tickets whose 'lastactivity' time is before the $acInactiveNoticeThreshold
        $dbCore->query("SELECT `ticketstatusid`, `ticketid`, `email`, `tgroupid`, `autoclosetimeline` FROM `". TABLE_PREFIX ."tickets` WHERE `departmentid` IN (". buildIN($acDepartmentList) .") AND `ticketstatusid` IN (". buildIN($acTicketStatusList) .") AND `lastactivity` <= '". intval($acInactiveNoticeThreshold) ."';");
        debug("Query to select tickets: " ."SELECT `ticketstatusid`, `ticketid`, `email`, `tgroupid`, `autoclosetimeline` FROM `". TABLE_PREFIX ."tickets` WHERE `departmentid` IN (". buildIN($acDepartmentList) .") AND `ticketstatusid` IN (". buildIN($acTicketStatusList) .") AND `lastactivity` <= '". intval($acInactiveNoticeThreshold) ."';");


        ////////////////////
        // $_SWIFT["settings"]["t_acnoticeclose"]   =   After this amount of time (in hours) has elapsed (this starts after the "Automatic Closure Inactivity Threshold" has been reached), the target tickets\' status will automatically be changed.
        // $_SWIFT["settings"]["t_acinactive"]      =   After a ticket has remained inactive for this amount of time (in hours), the system will send a notice to the user created the ticket, warning the user of the pending automatic status change.
        ////////////////////


        $acWarningTickets   = array();
        $acWarningTicketIDs = array();
        $acFinalTickets     = array();
        $acFinalTicketIDs   = array();


        // Loop through the list of tickets
        while ( $dbCore->nextRecord() )
        {
            // Check to see if no autoclosetimeline has been set
            if ( empty($dbCore->Record["autoclosetimeline"]) )
            {
                // We need to send notices out to these tickets, and update their autoclosetimeline

                $acWarningTickets[] = $dbCore->Record;

                $acWarningTicketIDs[] = $dbCore->Record["ticketid"];

                debug("Ticket " . $dbCore->Record["ticketid"] . "has an empty autoclosetimeline. Adding to warning list.");
            }
            else if ( !empty($dbCore->Record["autoclosetimeline"]) && ($dbCore->Record["autoclosetimeline"] < DATENOW) )
            {
                // Make sure that the ticket is not already set to the $acTargetStatus
                if ( $dbCore->Record["ticketstatusid"] != $acTargetStatus["ticketstatusid"] )
                {
                    $acFinalTickets[] = $dbCore->Record;

                    $acFinalTicketIDs[] = $dbCore->Record["ticketid"];

                    debug("Ticket " . $dbCore->Record["ticketid"] . "does NOT have an empty autoclosetimeline, and is older than autoclosetimeline. Adding to close list.");
                }
            }
        }

        debug("Updating the autoclosetimeline of the warning tickets");
        updateAutoCloseTimeline( $acWarningTicketIDs, $acTime );

        debug("Changing the status of the close tickets.");
        changeStatuses( $acFinalTicketIDs, $acTargetStatus );

        if ( $_SWIFT["settings"]["t_sendacfinalmail"] )
        {
            debug("Sending notices to the final close tickets.");
            sendNotices( $acFinalTickets, "final");
        }

        if ( $_SWIFT["settings"]["t_sendacwarningmail"] )
        {
            debug("Sending notices to the warning tickets.");
            sendNotices( $acWarningTickets, "warning");
        }
    }

}


function changeStatuses( $ticketIdList, $targetStatus )
{
    global $dbCore, $_SWIFT, $template;

    $index = 0;

    $_ticketobjlist = array();

    // Changing status automatically sets a ticket's autoclosetimeline to 0

    foreach ( $ticketIdList as $key=>$val )
    {
        $_ticketobjlist[$index] =& new TicketMain($val, false, LOG_SYSTEM);

        $_ticketobj = &$_ticketobjlist[$index];

        if ( $_ticketobj->ticket["ticketstatusid"] != $targetStatus["ticketstatusid"] )
        {
            debug("> Changing status of ticket " . $_ticketobj->ticketid);
            $_ticketobj->changeStatus($targetStatus["ticketstatusid"], true);
        }
        else
        {
            debug("> Ticket already set to autoclose target status, doing nothing " . $_ticketobj->ticketid);
        }

        $index++;
    }
}


function updateAutoCloseTimeline( $ticketIdList, $acTime )
{
    global $dbCore, $_SWIFT, $template;

    $dbCore->query("UPDATE `". TABLE_PREFIX ."tickets` SET `autoclosetimeline` = '". intval($acTime) ."' WHERE `ticketid` IN (". buildIN($ticketIdList) .");");
    $debugTemp = print_r($ticketIdList, true);
    debug("Updated auto close time line to ". $acTime . " for tickets" . $debugTemp);
}


function sendNotices( $ticketList, $noticeType )
{
    global $dbCore, $_SWIFT, $template;

    if ( $noticeType != "warning" && $noticeType != "final" ) return false;

    require_once ("./includes/functions_mail.php");

    $_ticketobjlist = array();

    $index = 0;

    foreach ( $ticketList as $key=>$val )
    {
        $mailObj = new SWIFT_Mail();
        $_ticketobjlist[$index] =& new TicketMain($val["ticketid"], false, LOG_SYSTEM);
        $_ticketobj = &$_ticketobjlist[$index];

        $_tgroupid = iif(empty($val["tgroupid"]), 1, $val["tgroupid"]);

        // See if tgroupid is set?
        $template->setGroup($_tgroupid);
        $template->loadLanguageSection("ticketemails", TEMPLATE_DB);
        $_ticketobj->loadTemplateVariables();

        if ( $noticeType == "final" )
        {
            debug("> Sending final notice to ticket" . $_ticketobj->ticketid);
            $template->assign("ishtml", true);
            $_templateresulthtml = $template->displayTemplate("email_autoclose_final", TEMPLATE_DB);
            $template->assign("ishtml", false);
            $_templateresulttext = $template->displayTemplate("email_autoclose_final", TEMPLATE_DB);
        }
        else if ( $noticeType == "warning" )
        {
            debug("> Sending warning notice to ticket" . $_ticketobj->ticketid);
            $template->assign("ishtml", true);
            $_templateresulthtml = $template->displayTemplate("email_autoclose", TEMPLATE_DB);
            $template->assign("ishtml", false);
            $_templateresulttext = $template->displayTemplate("email_autoclose", TEMPLATE_DB);
        }

        $emailqueueid = $_ticketobj->ticket["emailqueueid"];
        $template->assign("queuesignature", $_SWIFT["queuecache"]["list"][$emailqueueid]["contents"]);
        $mailObj->setSubject($_ticketobj->getEmailSubject(SUBJECT_USER));
        $mailObj->setData($_templateresulthtml, $_templateresulttext);
        $returnemail = $_ticketobj->getReturnEmail();
        $returnname = $_ticketobj->getReturnName();

        $mailObj->sendMail(array($_ticketobj->ticket["email"]), $returnemail, $returnname, false);
        $index++;

    }

    return true;

}


$debugLineCounter = 1;
function debug( $message )
{
    global $debugLineCounter;
    if ( isset($_GET["debug"]) )
    {
        echo "<b>". $debugLineCounter .":</b> " . $message;
        echo "<br>";
        $debugLineCounter++;
    }
}

debug("======== end cron_autoclose.php ========");



?>