<?php
//=======================================
//###################################
// Kayako Infotech Ltd. - SWIFT Framework
//
// Source Copyright 2001-2008 Kayako Infotech Ltd.
// Unauthorized reproduction is not allowed
// License Number: $%LICENSE%$
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//                   www.kayako.com
//###################################
//=======================================

if (!defined("INSWIFT")) {
	trigger_error("Unable to process " . htmlentities($_SERVER['PHP_SELF']), E_USER_ERROR);
}

$template->loadLanguageSection("mobile");
$template->loadLanguageSection("staff_tickets");
$template->loadLanguageSection("tickets_auditlogs");
require_once ("./modules/tickets/functions_ticketsui.php");
require_once ("./modules/tickets/functions_ticketmain.php");
require_once ("./modules/tickets/functions_search.php");
require_once ("./modules/tickets/functions_ticketcore.php");
require_once ("./modules/tickets/functions_mobile.php");
require_once ("./includes/functions_xml.php");
require_once ("./modules/tickets/functions_newticket.php");
require_once ("./includes/functions_customfields.php");
require_once ("./includes/functions_users.php");
require_once ("./includes/functions_mail.php");

/*
RESULT OUTPUT

<mobile>
	<success>1</success>
	<errors>2</errors>

	<error>
		<ticketid>0</ticketid>
		<message>Invalid XML Data Received</message>
	<error>
	<error>
		<ticketid>67890</ticketid>
		<message>Failed to update priority, Not enough permissions</message>
	<error>
</mobile>

SAMPLE INCOMING DATA:
<mobile>
<reply>
    <ticketid>123456</ticketid>
    <contents>Hello, this is a reply.</contents>
	<attachment>
		<filename>test.jpg</filename>
		<contents>boo</contents>
	</attachment>
	<attachment>
		<filename>test2.jpg</filename>
		<contents>boo2</contents>
	</attachment>
</reply>
<reply>
    <ticketid>123456</ticketid>
    <contents>Hello, this is a reply.</contents>
</reply>
<note>
    <ticketid>123456</ticketid>
    <type>[user, ticket]</type>
    <contents>Dude: Look into this issue</contents>
</note>
<note>
    <ticketid>123456</ticketid>
    <type>[user, ticket]</type>
    <contents>Dude: Look into this issue</contents>
</note>
<billing>
    <ticketid>123456</ticketid>
    <workerstaffid>1</workerstaffid>
    <timespent>[time spent in seconds]</timespent>
    <timebillable>[time billable in seconds]</timebillable>
    <notes>I did blah, blah, and blah.</notes>
</billing>
<propchange>
    <ticketid>123456</ticketid>
    <type>[owner, department, status, priority]</type>
    <data>[owner=new staff id, department=new dept. id, status=new status id, priority=new priority id]</data>
</propchange>
</mobile>
*/

// We first parse the incoming XML
$xml = new XML;

$_assigns = getAssignedDepartments(MODULE_TICKETS);
$_tree = $xml->xml2tree(decodeUTF8($_POST["xml"]));
  
/*ob_start();
echo $_POST["xml"]."\n";
print_r($_tree);
$contents = ob_get_contents();
ob_end_clean();
$fp = fopen("./cache/km.txt", "w+");
fwrite($fp, $contents);
fclose($fp);*/

if (_is_array($_tree))
{
	$_tree = $_tree["mobile"][0]["children"];
	$_errors = $_success = array();
	$_successcount = 0;
	$_errorcount   = 0;
	$_ticketObjStore = array();

	/**
	* ###############################################
	* INCOMING REPLIES
	* ###############################################
	*/
	if (_is_array($_tree["reply"]))
	{
		foreach ($_tree["reply"] as $key=>$val)
		{
			$_ticketid = $val["children"]["ticketid"][0]["values"][0];
			$_contents = $val["children"]["contents"][0]["values"][0];

			$_ticketObjStore[$_ticketid] = new TicketMain($_ticketid);
			$_ticketObj = &$_ticketObjStore[$_ticketid];

			if (empty($_ticketObj->ticket["ticketid"]))
			{
				$_errors[] = array("ticketid" => $_ticketObj->ticket["fticketid"], "type" => "reply", "message" => sprintf($_SWIFT["language"]["invalidmobileticket"], $_ticketid));
				continue;
			} else if (!in_array($_ticketObj->ticket["departmentid"], $_assigns)) {
				$_errors[] = array("ticketid" => $_ticketObj->ticket["fticketid"], "type" => "reply", "message" => sprintf($_SWIFT["language"]["notassignedmobileticket"], $_ticketObj->ticket["fticketid"]));
				continue;
			}

			$_attachments = array();
			if (_is_array($val["children"]["attachment"]))
			{
				$_attachindex = 0;
				foreach ($val["children"]["attachment"] as $attachkey=>$attachval)
				{
					$_splitdata = explode(";", $attachval["children"]["contents"][0]["values"][0]);
					$_attachcontents = '';
					foreach ($_splitdata as $splitkey=>$splitval)
					{
						if (trim($splitval) != "")
						{
							$_attachcontents .= base64_decode($splitval);
						}
					}
					$_attachments[$_attachindex]["contents"] = $_attachcontents;
					$_attachments[$_attachindex]["filesize"] = strlen($_attachcontents);
					$_attachments[$_attachindex]["filename"] = $attachval["children"]["filename"][0]["values"][0];
					$_attachments[$_attachindex]["contenttype"] = "application/octet-stream";

					$_attachindex++;
				}
			}

			if (empty($_ticketObj->ticket["emailqueueid"]) && is_array($_SWIFT["queuecache"]["list"]))
			{
				foreach ($_SWIFT["queuecache"]["list"] as $key=>$val)
				{
					if ($val["departmentid"] == $_ticketObj->ticket["departmentid"])
					{
						$_emailqueueid = $val["emailqueueid"];
						break;
					}
				}
			} else {
				$_emailqueueid = $_ticketObj->ticket["emailqueueid"];
			}
			
			$_ticketObj->createStaffReply($_SWIFT["staff"]["staffid"], $_SWIFT["staff"]["fullname"], $_SWIFT['staff']['email'], $_ticketObj->ticket["subject"], $_contents, false, $_emailqueueid, $_attachments, "", false, "", false, false, true);
			$_ticketObj->processTicketQueries();
			$_success[] = array("ticketid" => $_ticketObj->ticket["ticketid"], "ticketdisplayid" => $_ticketObj->ticket["fticketid"], "type" => "reply", "data" => "0");
			$_successcount++;
		}
	}

	/**
	* ###############################################
	* INCOMING NEW TICKET REQUESTS
	* ###############################################
	*/
	if (_is_array($_tree["ticket"])) 
	{
		foreach ($_tree["ticket"] as $key=>$val)
		{
			$_ticket = array();
			$_ticket["departmentid"]      = $val["children"]["departmentid"][0]["values"][0];
			$_ticket["ticketstatusid"]    = $val["children"]["ticketstatusid"][0]["values"][0];
			$_ticket["priorityid"]        = $val["children"]["priorityid"][0]["values"][0];
			$_ticket["ownerstaffid"]      = $val["children"]["ownerstaffid"][0]["values"][0];
			$_ticket["type"]              = $val["children"]["type"][0]["values"][0];
			$_ticket["subject"]           = $val["children"]["subject"][0]["values"][0];
			$_ticket["emailqueueid"]      = $val["children"]["emailqueueid"][0]["values"][0];
			$_ticket["fullname"]          = $val["children"]["fullname"][0]["values"][0];
			$_ticket["userphone"]         = $val["children"]["userphone"][0]["values"][0];
			$_ticket["useremail"]         = $val["children"]["useremail"][0]["values"][0];
			$_ticket["duetime"]           = $val["children"]["duetime"][0]["values"][0];
			$_ticket["sendautoresponder"] = $val["children"]["reply"][0]["children"]["sendautoresponder"][0]["values"][0];
			$_ticket["sendcontents"]      = $val["children"]["reply"][0]["children"]["sendcontents"][0]["values"][0];
			$_ticket["ccto"]              = $val["children"]["reply"][0]["children"]["ccto"][0]["values"][0];
			$_ticket["bccto"]             = $val["children"]["reply"][0]["children"]["bccto"][0]["values"][0];
			$_ticket["replycontents"]     = $val["children"]["reply"][0]["children"]["contents"][0]["values"][0];
			$_ticket["flagtype"]          = $val["children"]["flagtype"][0]["values"][0];

			if (empty($_ticket["departmentid"]) || empty($_ticket["ticketstatusid"]) || empty($_ticket["priorityid"]) || empty($_ticket["ownerstaffid"]) || empty($_ticket["subject"]) || empty($_ticket["fullname"]))
			{
				// Some invalid field(s) were encountered, so this ticket is a failure.  Add it to the error output.
				$tmpmsg = sprintf($_SWIFT["language"]["mobnewticketerrmsg"], $_ticket["subject"]) . $_SWIFT["language"]["requiredfieldempty"];
				$_errors[] = array("ticketdisplayid" => "n/a", "type" => "newticket", "message" => $tmpmsg);
				$_errorcount++;
				continue;
			}

			$_assigns = getAssignedDepartments(MODULE_TICKETS);
			if ($_SWIFT["staff"]["tnewticket"] == "0" || ($_SWIFT["settings"]["t_restrictnewticket"] == 1 && !in_array(intval($_ticket["departmentid"]), $_assigns)))
			{
				// The new ticket functionality is not enabled.
				$tmpmsg = sprintf($_SWIFT["language"]["mobnewticketerrmsg"], $_ticket["subject"]) . $_SWIFT["language"]["mobnewticketerrmsg"];
				$_errors[] = array("ticketdisplayid" => "n/a", "type" => "newticket", "message" => $tmpmsg);
				$_errorcount++;
				continue;
			}

			if ($_ticket["type"] == "email" && (empty($_ticket["useremail"]) || !isValidEmail($_ticket["useremail"])))
			{
				// Bad e-mail address!
				$tmpmsg = sprintf($_SWIFT["language"]["mobnewticketerrmsg"], $_ticket["subject"]) . $_SWIFT["language"]["mobemailfieldemptyorinvalid"];
				$_errors[] = array("ticketdisplayid" => "n/a", "type" => "newticket", "message" => $tmpmsg);
				$_errorcount++;
				continue;				
			}

			// Do we have an email queue set?
			if (!empty($_ticket["emailqueueid"]))
			{
				$_emailqueue = $_SWIFT["queuecache"]["list"][$_ticket["emailqueueid"]];
				$_tgroupid = $_emailqueue["tgroupid"];
			}
			else
			{
				$_emailqueue = array();
				$_tgroupid = 1;
			}

			// Lets see if we have an email set for this user?
			if (!empty($_ticket["useremail"]))
			{
				$userid = getUserEmail($_ticket["useremail"]);
				if (!$userid)
				{
					// No such user, insert a new one
					$usergroupid = $_SWIFT["tgroupcache"][$_tgroupid]["regusergroupid"];
					if (empty($usergroupid))
					{
						$usergroupid = 2;
					}
					$userid = insertUser(true, $_ticket["useremail"], substr(buildHash(),0, 8), $usergroupid, LOGINAPI_DEFAULT, 0, $_ticket["fullname"], 0, 0, false, 1, true);
				}
			}

			if (empty($_ticket["fullname"]) && $_ticket["type"] == "phone")
			{
				$fullname = $_SWIFT["staff"]["fullname"]; // Staff creating ticket as client, set full name to that of staff
			} else if (!empty($_ticket["fullname"])) {
				$fullname = $_ticket["fullname"];
			} else {
				$fullname = $_SWIFT["staff"]["fullname"]; // Set full name to staff
			}

			if ($_ticket["type"] == "phone")
			{
				$posttype = POST_CLIENT;
			} else {
				$posttype = POST_STAFF;
			}

			if ($_ticket["sendautoresponder"] == "1" && !empty($_ticket["useremail"]))
			{
				$sendautoresponder = true;
			} else {
				$sendautoresponder = false;
			}

			$_attachments = array();
			
			if (_is_array($val["children"]["reply"][0]["children"]["attachment"]))
			{
				$_attachindex = 0;
				foreach ($val["children"]["reply"][0]["children"]["attachment"] as $attachkey=>$attachval)
				{
					$_splitdata = explode(";", $attachval["children"]["contents"][0]["values"][0]);
					$_attachcontents = '';
					foreach ($_splitdata as $splitkey=>$splitval)
					{
						if (trim($splitval) != "")
						{
							$_attachcontents .= base64_decode($splitval);
						}
					}
					
					$_attachments[$_attachindex]["contents"] = $_attachcontents;
					$_attachments[$_attachindex]["filesize"] = strlen($_attachcontents);
					$_attachments[$_attachindex]["filename"] = $attachval["children"]["filename"][0]["values"][0];
					$_attachments[$_attachindex]["contenttype"] = "application/octet-stream";

					$_attachindex++;
				}
			}		

			$ticketiddata = createTicket($posttype, $_SWIFT["staff"]["staffid"], $userid, $fullname, $_ticket["useremail"], $_ticket["subject"], $_ticket["replycontents"], 0, $_ticket["priorityid"], $_ticket["ticketstatusid"], $_ticket["departmentid"], $_ticket["emailqueueid"], $_SWIFT["language"]["charset"], "", $_tgroupid, $_attachments, false, $sendautoresponder, iif(empty($_ticket["userphone"])&&$_ticket["type"]=="phone", "-1", $_ticket["userphone"]));

			$ticketid = $ticketiddata[0];
			$messageid = $ticketiddata[3];

			$_ticketobj =& new TicketMain($ticketid, false);
			$_ticketobj->messageid = $messageid;

			$mailObj = new SWIFT_Mail();
			$ccemaillist = $bccemaillist = array();

			$cc = $_ticket["ccto"];
			$bcc = $_ticket["bccto"];
			if (!empty($cc))
			{
				if (strstr($cc, ";"))
				{
					$ccemaillist = explode(";", $cc);
				} else if (strstr($cc, ",")) {
					$ccemaillist = explode(",", $cc);
				} else if (isValidEmail($cc)) {
					$ccemaillist = array($cc);
				}

			    $_ticketobj->addRecipients($ccemaillist, RECIPIENT_CCUSER);
			}

			if (!empty($bcc))
			{
				if (strstr($bcc, ";"))
				{
					$bccemaillist = explode(";", $bcc);
				} else if (strstr($bcc, ",")) {
					$bccemaillist = explode(",", $bcc);
				} else if (isValidEmail($bcc)) {
					$bccemaillist = array($bcc);
				}

				$_ticketobj->addRecipients($bccemaillist, RECIPIENT_BCCUSER);
			}

			if ($_ticket["sendcontents"] == "1" && !empty($_ticket["useremail"]))
			{
				sendNewTicketEmail($_ticketobj, $mailObj, $_tgroupid, $ticketiddata[1], $_ticket["useremail"], $_ticket["subject"], $_ticket["replycontents"], $_ticket["emailqueueid"], $ccemaillist, $bccemaillist, $_attachments);
			}

			$_ticketobj->assignTicket($_ticket["ownerstaffid"]);
			$_ticketobj->flagTicket($_ticket["flagtype"]);

            // Process ticket queries before we set the due time - if this is an email ticket, the system could reset
            // the due time after we set it because it thinks it is a staff reply.
            $_ticketobj->processTicketQueries();
			
			if ($_ticket["duetime"] != 0)
			{
			    // Received a valid due time; mark the ticket.
			    $_ticketobj->markAsDue($_ticket["duetime"]);		
			}
			else
			{
			    // Have to call clearDue() instead of markAsDue(0).
			    $_ticketobj->clearDue();
			}
			
			// ======= NOTES =======
			if (_is_array($val["children"]["note"]))
			{		
				$_notes = array();
				$_index = 0;
				foreach ($val["children"]["note"] as $notekey=>$noteval)
				{	
					$_notes[$_index]["staffid"]  = $noteval["children"]["staffid"][0]["values"][0];
					$_notes[$_index]["notetype"] = $noteval["children"]["type"][0]["values"][0];
					$_notes[$_index]["notecontents"] = $noteval["children"]["contents"][0]["values"][0];
					$_index++;
				}
	
				if (count($_notes))
				{
					foreach ($_notes as $notekey=>$noteval)
					{
						if ($noteval["notetype"] == "user")
						{
							$_ticketnotetype = NOTE_USER;
						} else {
							$_ticketnotetype = NOTE_TICKET;
						}
								
						$_ticketobj->addTicketNote($_ticketnotetype, intval($noteval["staffid"]), $noteval["notecontents"]);
						$_ticketobj->processTicketQueries();
					}
				}
			}

			// ======= BILLING =======
			if (_is_array($val["children"]["billing"]))
			{			
				$_billing = array();
				$_index = 0;
				foreach ($val["children"]["billing"] as $billingkey=>$billingval)
				{
					$_billing[$_index]["billingid"] = $billingval["children"]["billingid"][0]["values"][0];
					$_billing[$_index]["workerid"] = $billingval["children"]["workerid"][0]["values"][0];
					$_billing[$_index]["timespent"] = $billingval["children"]["timespent"][0]["values"][0];
					$_billing[$_index]["timebillable"] = $billingval["children"]["timebillable"][0]["values"][0];
					$_billing[$_index]["notes"] = $billingval["children"]["notes"][0]["values"][0];
					$_index++;
				}
	
				if (count($_billing))
				{
					foreach ($_billing as $billingkey=>$billingval)
					{
						$_ticketobj->addBillingEntry(DATENOW, $billingval["timespent"], $billingval["timebillable"], intval($billingval["workerid"]), $billingval["notes"]);
						$_ticketobj->processTicketQueries();
					}
				}
			}

			if ($ticketid)
			{
				// This ticket was successfully created.
				$_success[] = array("ticketid" => intval($ticketid), "ticketdisplayid" => $ticketid, "type" => "newticket", "data" => intval($ticketid));
				$_successcount++;
				continue;
			} 
			else
			{
				// Seems like the XML for this new ticket item might have been trashed.
				$tmpmsg = sprintf($_SWIFT["language"]["mobnewticketerrmsg"], $_ticket["subject"]) . $_SWIFT["language"]["invalidmobilexml"];
				$_errors[] = array("ticketdisplayid" => "n/a", "type" => "newticket", "message" => $tmpmsg);
				$_errorcount++;
				continue;
			}
		}
	}

	/**
	* ###############################################
	* INCOMING NOTES
	* ###############################################
	*/
	if (_is_array($_tree["note"]))
	{
		foreach ($_tree["note"] as $key=>$val)
		{
			$_notestaff = $val["children"]["staffid"][0]["values"][0];
			$_ticketid = $val["children"]["ticketid"][0]["values"][0];
			$_notetype = $val["children"]["type"][0]["values"][0];
			$_contents = $val["children"]["contents"][0]["values"][0];

			if (is_object($_ticketObjStore[$_ticketid]))
			{
				$_ticketObj = &$_ticketObjStore[$_ticketid];
			} else {
				$_ticketObjStore[$_ticketid] = new TicketMain($_ticketid);
				$_ticketObj = &$_ticketObjStore[$_ticketid];
			}

			if (empty($_ticketObj->ticket["ticketid"]))
			{
				$_errors[] = array("ticketid" => $_ticketObj->ticket["fticketid"], "type" => "note", "message" => sprintf($_SWIFT["language"]["invalidmobileticket"], $_ticketid));
				continue;
			} else if (!in_array($_ticketObj->ticket["departmentid"], $_assigns)) {
				$_errors[] = array("ticketid" => $_ticketObj->ticket["fticketid"], "type" => "note", "message" => sprintf($_SWIFT["language"]["notassignedmobileticket"], $_ticketObj->ticket["fticketid"]));
				continue;
			}

			if ($_notetype == "user")
			{
				$_ticketnotetype = NOTE_USER;
			} else {
				$_ticketnotetype = NOTE_TICKET;
			}

			$_ticketObj->addTicketNote($_ticketnotetype, intval($_notestaff), $_contents);
			$_ticketObj->processTicketQueries();
			$_success[] = array("ticketid" => $_ticketObj->ticket["ticketid"], "ticketdisplayid" => $_ticketObj->ticket["fticketid"], "type" => "note", "data" => "0");
			$_successcount++;
		}
	}

	/**
	* ###############################################
	* INCOMING BILLING ENTRIES
	* ###############################################
	*/
	if (_is_array($_tree["billing"]))
	{
		foreach ($_tree["billing"] as $key=>$val)
		{
			$_ticketid = $val["children"]["ticketid"][0]["values"][0];
			$_workerstaffid = $val["children"]["workerid"][0]["values"][0];
			$_timespent = $val["children"]["timespent"][0]["values"][0];
			$_timebillable = $val["children"]["timebillable"][0]["values"][0];
			$_kmbillingid = $val["children"]["billingid"][0]["values"][0];
			$_notes = $val["children"]["notes"][0]["values"][0];

			if (is_object($_ticketObjStore[$_ticketid]))
			{
				$_ticketObj = &$_ticketObjStore[$_ticketid];
			} else {
				$_ticketObjStore[$_ticketid] = new TicketMain($_ticketid);
				$_ticketObj = &$_ticketObjStore[$_ticketid];
			}

			if (empty($_ticketObj->ticket["ticketid"]))
			{
				$_errors[] = array("ticketid" => $_ticketObj->ticket["fticketid"], "type" => "billing", "message" => sprintf($_SWIFT["language"]["invalidmobileticket"], $_ticketid));
				continue;
			} else if (!in_array($_ticketObj->ticket["departmentid"], $_assigns)) {
				$_errors[] = array("ticketid" => $_ticketObj->ticket["fticketid"], "type" => "billing", "message" => sprintf($_SWIFT["language"]["notassignedmobileticket"], $_ticketObj->ticket["fticketid"]));
				continue;
			}

			$timetrackid = $_ticketObj->addBillingEntry(DATENOW, intval($_timespent), intval($_timebillable), intval($_workerstaffid), $_notes);
			$_ticketObj->processTicketQueries();
			$_success[] = array("ticketid" => $_ticketObj->ticket["ticketid"], "ticketdisplayid" => $_ticketObj->ticket["fticketid"], "type" => "billing", "data" => $_kmbillingid);

			$_successcount++;
		}
	}

	/**
	* ###############################################
	* INCOMING PROPERTY CHANGES
	* ###############################################
	*/
	if (_is_array($_tree["propchange"]))
	{
		foreach ($_tree["propchange"] as $key=>$val)
		{
			$_ticketid = $val["children"]["ticketid"][0]["values"][0];
			$_type = $val["children"]["type"][0]["values"][0];
			$_data = $val["children"]["data"][0]["values"][0];

			if (is_object($_ticketObjStore[$_ticketid]))
			{
				$_ticketObj = &$_ticketObjStore[$_ticketid];
			} else {
				$_ticketObjStore[$_ticketid] = new TicketMain($_ticketid);
				$_ticketObj = &$_ticketObjStore[$_ticketid];
			}

			if (empty($_ticketObj->ticket["ticketid"]))
			{
				$_errors[] = array("ticketid" => $_ticketObj->ticket["fticketid"], "type" => "propchange", "message" => sprintf($_SWIFT["language"]["invalidmobileticket"], $_ticketid));
				continue;
			} else if (!in_array($_ticketObj->ticket["departmentid"], $_assigns)) {
				$_errors[] = array("ticketid" => $_ticketObj->ticket["fticketid"], "type" => "propchange", "message" => sprintf($_SWIFT["language"]["notassignedmobileticket"], $_ticketObj->ticket["fticketid"]));
				continue;
			}

			// ======= CHANGE OWNER =======
			if ($_type == "owner" && !empty($_SWIFT["staffcache"][$_data]["staffid"]))
			{
				$_ticketObj->assignTicket(intval($_data));
				$_success[] = array("ticketid" => $_ticketObj->ticket["ticketid"], "ticketdisplayid" => $_ticketObj->ticket["fticketid"], "type" => "propchange", "data" => "owner");
				$_successcount++;

			// ======= CHANGE OWNER - INVALID STAFF =======
			} else if ($_type == "owner" && empty($_SWIFT["staffcache"][$_data]["staffid"])) {
				$_errors[] = array("ticketid" => $_ticketObj->ticket["fticketid"], "type" => "propchange", "message" => sprintf($_SWIFT["language"]["invalidmobilestaff"], $_data));
				continue;
			
			// ======= CHANGE DEPARTMENT =======
			} else if ($_type == "department" && !empty($_SWIFT["departmentcache"][$_data]["departmentid"])) {
				$_ticketObj->moveTicket(intval($_data));
				$_success[] = array("ticketid" => $_ticketObj->ticket["ticketid"], "ticketdisplayid" => $_ticketObj->ticket["fticketid"], "type" => "propchange", "data" => "department");
				$_successcount++;

			// ======= CHANGE DEPARTMENT - INVALID DEPARTMENT =======
			} else if ($_type == "department" && empty($_SWIFT["departmentcache"][$_data]["departmentid"])) {
				$_errors[] = array("ticketid" => $_ticketObj->ticket["fticketid"], "type" => "propchange", "message" => sprintf($_SWIFT["language"]["invalidmobiledep"], $_data));
				continue;

			// ======= CHANGE STATUS =======
			} else if ($_type == "status" && !empty($_SWIFT["statuscache"][$_data]["ticketstatusid"])) {
				$_ticketObj->changeStatus(intval($_data));
				$_success[] = array("ticketid" => $_ticketObj->ticket["ticketid"], "ticketdisplayid" => $_ticketObj->ticket["fticketid"], "type" => "propchange", "data" => "status");
				$_successcount++;

			// ======= CHANGE STATUS - INVALID STATUS =======
			} else if ($_type == "status" && !empty($_SWIFT["statuscache"][$_data]["ticketstatusid"])) {
				$_errors[] = array("ticketid" => $_ticketObj->ticket["fticketid"], "type" => "propchange", "message" => sprintf($_SWIFT["language"]["invalidmobilestatus"], $_data));
				continue;

			// ======= CHANGE PRIORITY =======
			} else if ($_type == "priority" && !empty($_SWIFT["prioritycache"][$_data]["priorityid"])) {
				$_ticketObj->changePriority(intval($_data));
				$_success[] = array("ticketid" => $_ticketObj->ticket["ticketid"], "ticketdisplayid" => $_ticketObj->ticket["fticketid"], "type" => "propchange", "data" => "priority");
				$_successcount++;

			} else if ($_type == "priority" && empty($_SWIFT["prioritycache"][$_data]["priorityid"])) {
				$_errors[] = array("ticketid" => $_ticketObj->ticket["fticketid"], "type" => "propchange", "message" => sprintf($_SWIFT["language"]["invalidmobilepriority"], $_data));
				continue;
				
			// ======= CHANGE FLAG TYPE =======
			} 
			else if ($_type == "flagtype")
			{
				$_ticketObj->flagTicket(intval($_data));
				$_success[] = array("ticketid" => $_ticketObj->ticket["ticketid"], "ticketdisplayid" => $_ticketObj->ticket["fticketid"], "type" => "propchange", "data" => "flagtype");
				$_successcount++;
				
		    // ======= CHANGE DUE DATE =======
			}
			else if ($_type == "duedate")
			{
			    $_ticketObj->markAsDue(intval($_data));
			    $_success[] = array("ticketid" => $_ticketObj->ticket["ticketid"], "ticketdisplayid" => $_ticketObj->ticket["fticketid"], "type" => "propchange", "data" => "duedate");
			    $_successcount++;
			}

			$_ticketObj->processTicketQueries();
		}
	}

	/**
	* ###############################################
	* TICKET DELETES
	* ###############################################
	*/
	if (_is_array($_tree["delete"]))
	{
		$_deletelist = $_deletekeylist = array();

		foreach ($_tree["delete"] as $key=>$val)
		{
			$_ticketid = $val["children"]["ticketid"][0]["values"][0];
			$_deletelist[] = $_ticketid;
			$_deletekeylist[$_ticketid] = 1;
		}

		$_successlist = $_failurelist = $_failurevallist = $_ticketpointer = array();

		$_failurelist = $_deletekeylist;

		if (_is_array($_deletelist) && $_SWIFT["staff"]["tdeleteticket"] != "0")
		{
			$_failurelist = array();
			$dbCore->query("SELECT `ticketid`, `ticketmaskid` FROM `". TABLE_PREFIX ."tickets` WHERE `ticketid` IN (". buildIN($_deletelist) .");");
			while ($dbCore->nextRecord())
			{
				$_ticketpointer[$dbCore->Record["ticketid"]] = $dbCore->Record["ticketmaskid"];
			}

			deleteTickets($_deletelist, true);

			$dbCore->query("SELECT `ticketid` FROM `". TABLE_PREFIX ."tickets` WHERE `ticketid` IN (". buildIN($_deletelist) .");");
			while ($dbCore->nextRecord())
			{
				$_failurelist[$dbCore->Record["ticketid"]] = 1;
			}
		}

		if (_is_array($_deletelist))
		{
			foreach ($_deletelist as $key=>$val)
			{
				if (!isset($_failurelist[$val]))
				{
					$_successlist[] = $val;
				} else {
					$_failurevallist[] = $val;
				}
			}
		}

		if (_is_array($_successlist))
		{
			foreach ($_successlist as $key=>$val)
			{
				$_success[] = array("ticketid" => $val, "ticketdisplayid" => iif($_SWIFT["settings"]["t_eticketid"]=="seq",$val, $_ticketpointer[$val]), "type" => "delete", "data" => "");
				$_successcount++;
			}
		}

		if (_is_array($_failurevallist))
		{
			foreach ($_failurevallist as $key=>$val)
			{
				if (empty($_ticketpointer[$val]))
				{
					$_errors[] = array("ticketid" => $val, "type" => "delete", "message" => sprintf($_SWIFT["language"]["kmnoticketexist"], $val));
				} else {
					$_errors[] = array("ticketid" => iif($_SWIFT["settings"]["t_eticketid"]=="seq",$val, $_ticketpointer[$val]), "type" => "delete", "message" => sprintf($_SWIFT["language"]["nopermdelkm"], iif($_SWIFT["settings"]["t_eticketid"]=="seq",$val, $_ticketpointer[$val])));
				}
			}
		}
	}

	// Dispatch the result
	$xml->addParentTag("mobile");

		$xml->addTag("successes", $_successcount);
		foreach ($_success as $key=>$val)
		{
			$xml->addParentTag("success");
				$xml->addTag("ticketid", intval($val["ticketid"]));
				$xml->addTag("ticketdisplayid", $val["ticketdisplayid"]);
				$xml->addTag("type", $val["type"]);
				$xml->addTag("data", $val["data"]);
			$xml->endTag("success");
		}

		$xml->addTag("errors", count($_errors));
		foreach ($_errors as $key=>$val)
		{
			$xml->addParentTag("error");
				$xml->addTag("ticketdisplayid", $val["ticketid"]);
				$xml->addTag("type", $val["type"]);
				$xml->addTag("message", $val["message"]);
			$xml->endTag("error");
		}

	$xml->endTag("mobile");

	$xml->echoXMLUTFWinapp();
}
else
{
	// Dispatch Invalid XML ERROR
	$xml->addParentTag("mobile");

		$xml->addTag("successes", "0");
		$xml->addTag("errors", "1");

		$xml->addParentTag("error");
			$xml->addTag("ticketdisplayid", "-");
			$xml->addTag("type", "general");
			$xml->addTag("message", $_SWIFT["language"]["invalidmobilexml"]);
		$xml->endTag("error");

	$xml->endTag("mobile");

	$xml->echoXMLUTFWinapp();
}

?>
