<?php
//=======================================
//###################################
// Kayako Infotech Ltd. - SWIFT Framework
//
// Source Copyright 2001-2008 Kayako Infotech Ltd.
// Unauthorized reproduction is not allowed
// License Number: $%LICENSE%$
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//                   www.kayako.com
//###################################
//=======================================

if (!defined("INSWIFT")) {
	trigger_error("Unable to process " . htmlentities($_SERVER['PHP_SELF']), E_USER_ERROR);
}
if (!$staffauth->isAdmin()) {
	trigger_error("You do not have permission to access " . htmlentities($_SERVER['PHP_SELF']), E_USER_ERROR);
}
require_once ("./modules/tickets/functions_tickets.php");
require_once ("./includes/functions_html.php");
require_once ("./includes/functions_template.php");
require_once ("./modules/tickets/functions_ticketsui.php");
require_once ("./modules/tickets/functions_ticketcore.php");
require_once ("./modules/tickets/functions_ticketsearch.php");

?><script language="Javascript" src="<?php echo $_SWIFT["themepath"]; ?>main.js"></script><?php 

$template->loadLanguageSection("tickets");
$template->loadLanguageSection("staff_attach");

function attachmentSearch($searchrules, $rulematch = "all")
	{
		$attachmentidlist = array();
		global $dbCore, $_SWIFT;

		if (!_is_array($searchrules))
		{
			return false;
		}

		if ($rulematch == "all")
		{
			$oper = "AND";
		} else {
			$oper = "OR";
		}
		$_start = fetchmicrotime();

		foreach ($searchrules as $key=>$val)
		{
			switch ($val[0])
			{
				case "filename":
					$_sql[] = buildSearchSQL("filename", $val[1], $val[2]);
				break;
				case "size";
					$_sql[] = buildSearchSQL("filesize", $val[1], ($val[2]*1024));
				break;
				case "dateline":
				$_sql[] = buildSearchSQL("dateline", $val[1], iif(!empty($val[2]), strtotime($val[2]), DATENOW));
				break;
				case "ticketid":
				$_result  = searchTicketID($val[2]);
				$_sql[] = buildSearchSQL("ticketid", $val[1], $_result["ticketid"]);
				break;
			}
		}

		$query = "SELECT `attachmentid`, `ticketid` FROM `". TABLE_PREFIX ."attachments` WHERE (". implode($oper, $_sql).")";
		$dbCore->query($query);
		while ($dbCore->nextRecord())
		{
			$attachmentidlist[] = $dbCore->Record["attachmentid"];
		}
		
		$_end = fetchmicrotime();
		return $attachmentidlist;
}

if ($eventaction == "purgeattachments")
{
	renderTicketTree();

    $template->assign("calendar", true);
	$interface->adminHeader($_SWIFT["language"]["tickets"]. " &gt; ".$_SWIFT["language"]["pattach"] , 1);
	$interface->adminNavBar('<a href="index.php?_m=tickets&_a=purgeattachments" title="'.$_SWIFT["language"]["tickets"].'">'.$_SWIFT["language"]["tickets"].'</a> &raquo; <a href="index.php?_m=tickets&_a=purgeattachments" title="'.$_SWIFT["language"]["pattach"].'">'.$_SWIFT["language"]["pattach"], $_SWIFT["language"]["dis_pattch"] , 5);

	if($_GET["delaconfirm"] == "1")
	{
		printInfoBox($_SWIFT["language"]["delattachconfirm"]);
	}

	if ($_POST["step"] == 1)
	{
				$_searchresults = attachmentSearch($_POST["searchrules"], $_POST["ruleoptions"]);

				if (empty($_searchresults))
				{
					$infomessage = $_SWIFT["language"]["zeroresults"];
					//exit;
				}
				$infomessage  = sprintf($_SWIFT["language"]["attachresult"], count($_searchresults));

				printInfoBox($infomessage);
				printErrorBox($errormessage);
				
				printMainTableHeader(htmlspecialchars("Attachments Table") , "100%", "0", "0", "float: left; position: relative;");
				$name = "attachlist";

				printFormStart($name, "index.php", "POST", false, "", "");
				
						echo '<tr>'.SWIFT_CRLF;

						echo '<td class="tabletitlerow" align="center" valign="middle" width=20 nowrap><input type="checkbox" name="allselect" class="swiftcheckbox" onClick="javascript:toggleAll(document.'.$name.');"></td>'.SWIFT_CRLF;
						
						echo '<td class="tabletitlerow">Attachment ID</td><td class="tabletitlerow">Ticket ID</td><td class="tabletitlerow">File Size</td><td class="tabletitlerow">File name</td>'.SWIFT_CRLF;
						
						echo '</tr>'.SWIFT_CRLF;

						$dbCore->query("SELECT attachments.*, tickets.ticketmaskid AS ticketmaskid FROM `". TABLE_PREFIX ."attachments` AS attachments LEFT JOIN `". TABLE_PREFIX ."tickets` AS tickets ON (attachments.ticketid = tickets.ticketid) WHERE attachments.attachmentid IN (". buildIN($_searchresults) .");");

						while ($dbCore->nextRecord())
						{
							$id = $dbCore->Record["attachmentid"];
						echo '<tr class="'. getRowBG() .'">' . SWIFT_CRLF;
						
						echo '<td align="center" valign="middle">'. "<input type='checkbox' name='itemid[]' value='$id' class=\"swiftcheckbox\" ><input type='hidden' name='itemhighlight{$id}' value='0'>" .'</td>'.SWIFT_CRLF;
						
						echo "<td>" . $dbCore->Record["attachmentid"] . "</td><td>" . iif($_SWIFT["settings"]["t_eticketid"]=="seq",$dbCore->Record["ticketid"], $dbCore->Record["ticketmaskid"]) . "</td><td>" . formattedSize($dbCore->Record["filesize"])."</td><td>" . 
						$dbCore->Record["filename"]. "</td></tr>";
						}
					printSubmitRow($_SWIFT["language"]["delete"], "5");
					printMainTableFooter();

					addHiddenField("_m", "tickets");
					addHiddenField("_a", "purgeattachments");
					addHiddenField("type", "delete");
					printFormEnd();
	} else {
							
		if ($_POST["type"] == 'delete')
		{
			//------delete attachments physicaly-------
			$_attachlist = $_POST["itemid"];
			$_ticketids = array();

			$dbCore->query("SELECT `storefilename`, `ticketid` FROM `". TABLE_PREFIX ."attachments` WHERE (`attachmenttype`='" . ATTACHMENT_FILE . "' AND `attachmentid` IN (". buildIN($_attachlist) ."));");

			while ($dbCore->nextRecord())
			{
				$attach = $dbCore->Record["storefilename"];
				$_ticketids[] = $dbCore->Record["ticketid"];

				@unlink('./files/' . $attach);
			}

			$dbCore->query("DELETE FROM `". TABLE_PREFIX ."attachmentchunks` WHERE `attachmentid` IN (". buildIN($_attachlist) .");");
			$dbCore->query("DELETE FROM `". TABLE_PREFIX ."attachments` WHERE `attachmentid` IN (". buildIN($_attachlist) .");");

			$_uticketid = array();
			foreach($_ticketids as $key=>$val)
			{
				$count=$dbCore->queryFetch("SELECT COUNT(*) AS count FROM `". TABLE_PREFIX ."attachments` WHERE `ticketid`= '". intval($val) ."';");
	    	
				if(empty($count["count"]))
				{
					$_uticketid[] = intval($val);
				}
			}

			$dbCore->shutDownQuery("UPDATE `". TABLE_PREFIX ."tickets` SET `hasattachments` = '0' WHERE `ticketid` IN (". buildIN($_uticketid) .");");
			
			printInfoBox($_SWIFT["language"]["delattachconfirm"]);			
		}

		?>

		<script type="text/javascript">
			var cruleindex = 1;
			function newSearchAttach()
			{
				var rowElement = document.createElement("div");
				rowElement.id = "rulerow"+cruleindex;
				var rowMod = cruleindex%2;
				rowElement.className = "searchrule"+rowMod;
				var tparent = browserObject("ruleparent");
				if (!tparent)
				{
					return false;
				}

				tparent.appendChild(rowElement);
				updateRuleHTML(cruleindex, "filename");
				cruleindex++;
			}

			function removeRuleRow(ruleindex)
			{
				var tparent = browserObject("ruleparent");
				if (!tparent)
				{
					return false;
				}

				var rowElement = browserObject("rulerow"+ruleindex);
				if (!rowElement)
				{
					return false;
				}

				tparent.removeChild(rowElement);
			}

			function updateRuleHTML(ruleindex, fieldtype)
			{
				var returnResult;

				returnResult = '<table border="0" cellpadding="3" cellspacing="1" width="100%"><tr><td align="left" width="1"><a href="javascript:void(0);" onClick="javascript:removeRuleRow(\''+ruleindex+'\');"><img src="<?php echo $_SWIFT["themepath"]; ?>icon_deletesmall.gif" title="<?php echo $_SWIFT["language"]["deletecriteria"]; ?>" border="0" /></a></td><td align="left" width="1"><select name="searchrules['+ ruleindex +'][0]" class="swiftselect" onChange="javascript:updateRuleHTML(\''+ ruleindex +'\', this.options[this.selectedIndex].value);">';
				returnResult += '<optgroup label="<?php echo $_SWIFT["language"]["attach"]; ?>">';
				returnResult += '<option value="filename"'+selectedStatus(fieldtype, "filename")+'><?php echo addslashes($_SWIFT["language"]["filename"]); ?></option>';
				returnResult += '<option value="size"'+selectedStatus(fieldtype, "size")+'><?php echo addslashes($_SWIFT["language"]["size"]); ?></option>';
				returnResult += '<option value="ticketid"'+selectedStatus(fieldtype, "ticketid")+'><?php echo addslashes($_SWIFT["language"]["byticketid"]); ?></option>';
				returnResult += '<option value="dateline"'+selectedStatus(fieldtype, "dateline")+'><?php echo addslashes($_SWIFT["language"]["bydate"]); ?></option>';
				returnResult += '</optgroup>';
				
				returnResult += '</select>';

				returnResult += "</td>";

				if (fieldtype == "filename")
				{
					returnResult += getOperatorHTML(ruleindex, "string")+getQueryHTML(ruleindex, "textentire");
				} else if (fieldtype == "size") {
					returnResult += getOperatorHTML(ruleindex, "int")+getQueryHTML(ruleindex, "textentire");
				} else if (fieldtype == "dateline") {
					returnResult += getOperatorHTML(ruleindex, "cal")+getQueryHTML(ruleindex, "cal");
				} else if (fieldtype == "ticketid")
				{ 
					returnResult += getOperatorHTML(ruleindex, "bool")+getQueryHTML(ruleindex, "textentire");
				}

				var cfield = fieldtype.substring(0,7);
				if (cfield == "cfield_")
				{
					returnResult += getOperatorHTML(ruleindex, "resstring")+getQueryHTML(ruleindex, "text");
				}

				var dRow = browserObject("rulerow"+ruleindex);
				if (!dRow)
				{
					return;
				}

				dRow.innerHTML = returnResult+'</tr></table>';
			}

			function selectedStatus(fieldtype, fieldvalue)
			{
				if (fieldtype == fieldvalue)
				{
					return " selected";
				}
			}

			function getOperatorHTML(ruleindex, optype)
			{
				if (!ruleindex)
				{
					return;
				}

				if (optype == "string")
				{
					return '<td align="left" width="1"><select name="searchrules['+ ruleindex +'][1]" class="swiftselect"><option value="<?php echo OP_CONTAINS; ?>" selected><?php echo $_SWIFT["language"]["opcontains"]; ?></option><option value="<?php echo OP_NOTCONTAINS; ?>"><?php echo addslashes($_SWIFT["language"]["opnotcontains"]); ?></option><option value="<?php echo OP_EQUAL; ?>"><?php echo $_SWIFT["language"]["opequal"]; ?></option><option value="<?php echo OP_NOTEQUAL; ?>"><?php echo $_SWIFT["language"]["opnotequal"]; ?></option></select></td>';
				} else if (optype == "int") {
					return '<td align="left" width="1"><select name="searchrules['+ ruleindex +'][1]" class="swiftselect"><option value="<?php echo OP_GREATER; ?>"><?php echo $_SWIFT["language"]["opgreater"]; ?></option><option value="<?php echo OP_LESS; ?>"><?php echo $_SWIFT["language"]["opless"]; ?></option><option value="<?php echo OP_EQUAL; ?>" selected><?php echo $_SWIFT["language"]["opequal"]; ?></option><option value="<?php echo OP_NOTEQUAL; ?>"><?php echo $_SWIFT["language"]["opnotequal"]; ?></option></select></td>';
				} else if (optype == "cal") {
					return '<td align="left" width="1"><select name="searchrules['+ ruleindex +'][1]" class="swiftselect"><option value="<?php echo OP_GREATER; ?>" selected><?php echo $_SWIFT["language"]["opgreater"]; ?></option><option value="<?php echo OP_LESS; ?>"><?php echo $_SWIFT["language"]["opless"]; ?></option></select></td>';
				}else if (optype == "bool") {
					return '<td align="left" width="1"><select name="searchrules['+ ruleindex +'][1]" class="swiftselect"><option value="<?php echo OP_EQUAL; ?>" selected><?php echo $_SWIFT["language"]["opequal"]; ?></option><option value="<?php echo OP_NOTEQUAL; ?>"><?php echo $_SWIFT["language"]["opnotequal"]; ?></option></select></td>';
				}
			}

			function getQueryHTML(ruleindex, querytype)
			{
				if (!ruleindex)
				{
					return;
				}

				var returnResult = '<td align="left">';
				
				if (querytype == "textentire") {
					returnResult += '<input type="text" size="20" class="swifttext" name="searchrules['+ ruleindex +'][2]" style="width:50%;" /><span class="smalltext">&nbsp;&nbsp;<?php echo addslashes($_SWIFT["language"]["squerydesc"]); ?></span>';
				} else if (querytype == "cal") {
				    <?php 
				        require_once("./includes/functions_date.php");
				        $dateFormat = getCalendarDateFormats(false); // Don't want hour-granularity
				    ?>
					returnResult += '<input type="text" name="searchrules['+ruleindex+'][2]" id="rulecal'+ ruleindex +'" onclick="return showCalendar(\'rulecal'+ ruleindex +'\', \'<?php echo $dateFormat["cal"]; ?>\');" size="17" readonly="1" value="" class="swifttext"/>&nbsp;<img src="<?php echo $_SWIFT["themepath"]; ?>calendar.gif" onclick="return showCalendar(\'rulecal'+ ruleindex +'\', \'<?php echo $dateFormat["cal"]; ?>\');" style="cursor: pointer;" align="absmiddle"/>';
				}
				
				return returnResult+'</td>';
			}
		</script>
		<?php 

		printFormStart();
		printMainTableHeader($_SWIFT["language"]["searchrules"]);

		echo '<tr class="'. getRowBG() .'">
		<td align="left" colspan="2"><span class="smalltext"><div id="ruleparent"></div></span></td></tr>';

		echo '<tr class="'. getRowBG() .'">
		<td align="left" colspan="2"><span class="smalltext"><a href="javascript:newSearchAttach();"><img src="'. $_SWIFT["themepath"] .'icon_add.gif" border="0" align="absmiddle" />&nbsp;'. $_SWIFT["language"]["newrule"] .'</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<label for="ruleall"><input type="radio" name="ruleoptions" value="all" id="ruleall" checked>'. $_SWIFT["language"]["smatchall"] .'</label>&nbsp;<label for="ruleany"><input type="radio" name="ruleoptions" value="any" id="ruleany">'. $_SWIFT["language"]["smatchany"] .'</label></span></td></tr>';

		printSubmitRow($_SWIFT["language"]["search"]);

		printMainTableFooter();

		addHiddenField("_m", "tickets");
		addHiddenField("_a", "purgeattachments");
		addHiddenField("step", "1");
		printFormEnd();
		?>
		<script type="text/javascript">
			newSearchAttach();
		</script>
		<?php   }
		
	$interface->adminFooter();
}

?>