<?php
//=======================================
//###################################
// Kayako Infotech Ltd. - SWIFT Framework
//
// Source Copyright 2001-2008 Kayako Infotech Ltd.
// Unauthorized reproduction is not allowed
// License Number: $%LICENSE%$
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//                   www.kayako.com
//###################################
//=======================================

if (!defined("INSWIFT")) {
	trigger_error("Unable to process " . htmlentities($_SERVER['PHP_SELF']), E_USER_ERROR);
}

require_once ("./includes/Graph/functions_charts.php");
require_once ("./includes/functions_date.php");

$template->assign("calendar", true);

unset($_staffsql);
unset($_statussql);

if (!empty($_REQUEST["filterticketstatusid"]))
{
	$_statussql = " AND `ticketstatusid` = '". intval($_REQUEST["filterticketstatusid"]) ."'";
}

$dateFormat = getCalendarDateFormats(false); // Don't want hour-granularity

if (empty($_REQUEST["datefrom"]) && empty($_REQUEST["dateto"]))
{
	$_gdatefrom = stringFirstOfTheMonth($dateFormat["html"]);
	$_gdateto   = date($dateFormat["html"], DATENOW);
} else {
	$_gdatefrom = $_REQUEST["datefrom"];
	$_gdateto = $_REQUEST["dateto"];
}

$_datefrom = floorDate(strtotime($_gdatefrom));
$_dateto   = ceilDate(strtotime($_gdateto));

$_datestart = $_datefrom;
$_daylist   = array();

while ($_datestart <= $_dateto)
{
	$_daylist[] = date("d-n-Y", $_datestart);
	$_datestart += 86400;
}

$_filterticketidlist = $_filterticketpostidlist = array();
if (!empty($_REQUEST["filterstaffid"]))
{
	$dbCore->query("SELECT `ticketpostid` FROM `". TABLE_PREFIX ."ticketposts` WHERE `creator` = '". POST_STAFF ."' AND `staffid` = '". intval($_REQUEST["filterstaffid"]) ."' AND DATE_FORMAT(FROM_UNIXTIME(dateline), '%d-%c-%Y') IN (". buildIN($_daylist) .");");
	while ($dbCore->nextRecord())
	{
		$_filterticketpostidlist[] = $dbCore->Record["ticketpostid"];
	}

	$_staffsql = " AND `ownerstaffid` = '". intval($_REQUEST["filterstaffid"]) ."'";
	$_staffsql = " AND `ticketid` IN (". buildIN($_filterticketidlist) .")";
}

$_stat = $_statstatus = $_statdep = array();
$_max = 0;

if (count($_filterticketpostidlist))
{
	$dbCore->query("SELECT COUNT(*) AS totalitems, DATE_FORMAT(FROM_UNIXTIME(ticketposts.dateline), '%d') AS outdate, tickets.departmentid, tickets.ticketstatusid FROM `". TABLE_PREFIX ."ticketposts` AS ticketposts LEFT JOIN `". TABLE_PREFIX ."tickets` AS tickets ON (ticketposts.ticketid = tickets.ticketid) WHERE ticketposts.ticketpostid IN (". buildIN($_filterticketpostidlist) .")". $_statussql ." GROUP BY DATE_FORMAT(FROM_UNIXTIME(ticketposts.dateline), '%d-%c-%Y'), tickets.departmentid, tickets.ticketstatusid;");
} else {
	if ($_GET["custom"] == 1)
	{
		$dbCore->query("SELECT COUNT(*) AS totalitems, DATE_FORMAT(FROM_UNIXTIME(dateline), '%d') AS outdate, departmentid, ticketstatusid FROM `". TABLE_PREFIX ."tickets` WHERE DATE_FORMAT(FROM_UNIXTIME(dateline), '%d-%c-%Y') IN (". buildIN($_daylist) .")". $_staffsql . $_statussql ." GROUP BY DATE_FORMAT(FROM_UNIXTIME(dateline), '%d-%c-%Y'), departmentid, ticketstatusid;");
	} else {
		$dbCore->query("SELECT COUNT(*) AS totalitems, DATE_FORMAT(FROM_UNIXTIME(lastactivity), '%d') AS outdate, departmentid, ticketstatusid FROM `". TABLE_PREFIX ."tickets` WHERE DATE_FORMAT(FROM_UNIXTIME(lastactivity), '%d-%c-%Y') IN (". buildIN($_daylist) .")". $_staffsql . $_statussql ." GROUP BY DATE_FORMAT(FROM_UNIXTIME(lastactivity), '%d-%c-%Y'), departmentid, ticketstatusid;");
	}
}

while ($dbCore->nextRecord())
{
	if ($dbCore->Record["totalitems"] > $_max && $dbCore->Record["departmentid"] == $_REQUEST["departmentid"])
	{
		$_max = $dbCore->Record["totalitems"];
	}

	$_stat[$dbCore->Record["departmentid"]][$dbCore->Record["outdate"]] += $dbCore->Record["totalitems"];
	$_statstatus[$dbCore->Record["departmentid"]][$dbCore->Record["ticketstatusid"]] += $dbCore->Record["totalitems"];
	$_statdep[$dbCore->Record["departmentid"]] += $dbCore->Record["totalitems"];
}

if ($_REQUEST["do"] == "chart")
{
		$chart[ 'axis_category' ] = array ( 'size'=>10, 'color'=>"000000", 'alpha'=>50, 'font'=>"verdana", 'bold'=>true, 'skip'=>0 ,'orientation'=>"horizontal" ); 
		$chart[ 'axis_ticks' ] = array ( 'value_ticks'=>true, 'category_ticks'=>true, 'major_thickness'=>2, 'minor_thickness'=>1, 'minor_count'=>1, 'major_color'=>"000000", 'minor_color'=>"222222" ,'position'=>"outside" );
		$chart[ 'axis_value' ] = array (  'min'=> 0, 'max'=> round($_max), 'font'=>"verdana", 'bold'=>true, 'size'=>10, 'color'=>"000000", 'alpha'=>50, 'steps'=>6, 'prefix'=>"", 'suffix'=>"", 'decimals'=>0, 'separator'=>"", 'show_min'=>true );
		$chart[ 'chart_border' ] = array ( 'color'=>"000000", 'top_thickness'=>2, 'bottom_thickness'=>2, 'left_thickness'=>2, 'right_thickness'=>2 );

		$index = 1;
		$_chartindex = array("");
		$_chartvalue = array("Values");

		if (_is_array($_stat[$_REQUEST["departmentid"]]))
		{
			foreach ($_stat[$_REQUEST["departmentid"]] as $key=>$val)
			{
				$_chartindex[] = $key;
				$_chartvalue[] = $val;
				$index++;
			}
		}
		
		$chart[ 'chart_data' ] = array ( $_chartindex, $_chartvalue);
		$chart[ 'chart_grid_h' ] = array ( 'alpha'=>10, 'color'=>"000000", 'thickness'=>1, 'type'=>"solid" );
		$chart[ 'chart_grid_v' ] = array ( 'alpha'=>0, 'color'=>"000000", 'thickness'=>1, 'type'=>"solid" );
		$chart[ 'chart_pref' ] = array ( 'line_thickness'=>2, 'point_shape'=>"circle", 'fill_shape'=>false );
		$chart[ 'chart_rect' ] = array ( 'x'=>70, 'y'=>25, 'width'=>635, 'height'=>200, 'positive_color'=>"000000", 'positive_alpha'=>30, 'negative_color'=>"ff0000",  'negative_alpha'=>10 );
		$chart[ 'chart_type' ] = "Line";
		$chart[ 'chart_value' ] = array ( 'prefix'=>"", 'suffix'=>"", 'decimals'=>0, 'separator'=>"", 'position'=>"cursor", 'hide_zero'=>true, 'as_percentage'=>false, 'font'=>"verdana", 'bold'=>true, 'size'=>12, 'color'=>"000000", 'alpha'=>75 );
		$chart[ 'legend_rect' ] = array ( 'x'=>-100, 'y'=>-100, 'width'=>10, 'height'=>10, 'margin'=>10 ); 
		$chart[ 'series_color' ] = array ( "ff4444" ); 

		SendChartData ( $chart );


	exit;
}

$interface->staffHeader($_SWIFT["language"]["tickets"]." &gt; ".$_SWIFT["language"]["reports"], 2);

renderTicketTree();
$interface->staffNavBar('<a href="index.php?_m=tickets&_a=manage" title="'.$_SWIFT["language"]["tickets"].'">'.$_SWIFT["language"]["tickets"].'</a> &raquo; '.'<a href="index.php?_m=tickets&_a=reports&type=department" title="'.$_SWIFT["language"]["reports"].'">'.$_SWIFT["language"]["reports"].'</a> &raquo; '.'<a href="index.php?_m=tickets&_a=reports&type=department" title="'.$_SWIFT["language"]["departmentrep"].'">'.$_SWIFT["language"]["departmentrep"].'</a>', "", 2);

printInfoBox($infomessage);
printErrorBox($errormessage);

?>

<form name="swiftform" action="index.php" method="POST"><fieldset class="swiftfieldset">
<legend><?php echo $_SWIFT["language"]["filter"]; ?></legend>
<table width="100%"  border="0" cellspacing="1" cellpadding="2" class="tborder">
<tr>
<td width="100" class="row1" nowrap><?php echo $_SWIFT["language"]["fildate"]; ?></td>
<td class="row2"><?php echo $_SWIFT["language"]["filfrom"]; ?>&nbsp;<input type="text" name="datefrom" id="datefrom" size="12" readonly="1" value="<?php echo iif(!empty($_gdatefrom), $_gdatefrom); ?>" class="swifttext" onclick="return showCalendar('datefrom', '<?php echo $dateFormat["cal"]; ?>');" />&nbsp;<img src="<?php echo $_SWIFT["themepath"]; ?>calendar.gif" id="datefromtrigger" style="cursor: pointer;" align="absmiddle" onclick="return showCalendar('datefrom', '<?php echo $dateFormat["cal"]; ?>');" />&nbsp;<?php echo $_SWIFT["language"]["filto"]; ?>&nbsp;<input type="text" name="dateto" id="dateto" size="12" readonly="1" value="<?php echo iif(!empty($_gdateto), $_gdateto); ?>" class="swifttext" onclick="return showCalendar('dateto', '<?php echo $dateFormat["cal"]; ?>');" />&nbsp;<img src="<?php echo $_SWIFT["themepath"]; ?>calendar.gif" id="datetotrigger" style="cursor: pointer;" align="absmiddle" onclick="return showCalendar('dateto', '<?php echo $dateFormat["cal"]; ?>');" /></td>

<td width="100" class="row1" nowrap><?php echo $_SWIFT["language"]["filstaff"]; ?></td>
<td class="row2">
<select name="filterstaffid" class="swiftselect">
<option value="0"<?php echo iif(empty($_POST["filterstaffid"]), " selected"); ?>><?php echo $_SWIFT["language"]["filnotselected"]; ?></option>
<?php 
foreach ($_SWIFT["staffcache"] as $key=>$val)
{
	?><option value="<?php echo $val["staffid"]; ?>"<?php echo iif($_POST["filterstaffid"]==$val["staffid"], " selected"); ?>><?php echo htmlspecialchars($val["fullname"]); ?></option><?php 
}
?></select>
</td>

<td width="100" class="row1" nowrap><?php echo $_SWIFT["language"]["filstatus"]; ?></td>
<td class="row2">
<select name="filterticketstatusid" class="swiftselect">
<option value="0"<?php echo iif(empty($_POST["filterticketstatusid"]), " selected"); ?>><?php echo $_SWIFT["language"]["filnotselected"]; ?></option>
<?php 
foreach ($_SWIFT["statuscache"] as $key=>$val)
{
	?><option value="<?php echo $val["ticketstatusid"]; ?>" style="color:<?php echo $val["statuscolor"]; ?>"<?php echo iif($_POST["filterticketstatusid"]==$val["ticketstatusid"], " selected"); ?>><?php echo htmlspecialchars($val["title"]); ?></option><?php 
}
?></select>
</td>

<td width="100" class="row2" align="right" nowrap><input type="submit" class="yellowbutton" name="filter" value="<?php echo $_SWIFT["language"]["filter"]; ?>"></td>
</tr>
</table>
</fieldset><BR />
<input type="hidden" name="_m" value="tickets"><input type="hidden" name="_a" value="reports"><input type="hidden" name="type" value="department">
</form>
<?php 

$_colspan  = count($_SWIFT["statuscache"]);

foreach ($_SWIFT["departmentcache"] as $key=>$val)
{
	if ($val["departmentmodule"] != MODULE_TICKETS)
	{
		continue;
	}

	printMainTableHeader(htmlspecialchars($val["title"])." (". intval($_statdep[$val["departmentid"]]) .")");

	$data = array();
	$index = 0;
	foreach ($_SWIFT["statuscache"] as $statkey=>$statval)
	{
		$data[$index]["value"] = '<span class="smalltext"><font color="'. $statval["statuscolor"] .'">'. htmlspecialchars($statval["title"])."</font>: ".intval($_statstatus[$val["departmentid"]][$statval["ticketstatusid"]]) .'</span>'.SWIFT_CRLF;
		$data[$index]["align"] = "left";
		$index++;
	}
	printDataRow($data);

	$data = array();
	$data[0]["value"] = InsertChart($_SWIFT["swiftpath"]."includes/Graph/charts.swf", "index.php?_m=tickets&_a=reports&type=department&do=chart&datefrom=". $_gdatefrom ."&dateto=".$_gdateto."&filterstaffid=".intval($_POST["filterstaffid"])."&filterticketstatusid=".intval($_POST["filterticketstatusid"])."&departmentid=".intval($val["departmentid"])."&custom=".intval($_GET["custom"]), 750, 250, "666666", true);
	$data[0]["align"] = "left";
	$data[0]["colspan"] = $_colspan;
	printDataRow($data);

	printMainTableFooter();
	echo "<BR />";
}

$template->assign("backurl", "index.php?_m=tickets&_a=manage");
$interface->staffFooter();

?>