<?php
//=======================================
//###################################
// Kayako Infotech Ltd. - SWIFT Framework
//
// Source Copyright 2001-2008 Kayako Infotech Ltd.
// Unauthorized reproduction is not allowed
// License Number: $%LICENSE%$
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//                   www.kayako.com
//###################################
//=======================================

if (!defined("INSWIFT")) {
	trigger_error("Unable to process " . htmlentities($_SERVER['PHP_SELF']), E_USER_ERROR);
}

require_once ("./includes/functions_html.php");
$template->loadLanguageSection("staff_tickets");
$template->loadLanguageSection("tickets_auditlogs");
$template->loadLanguageSection("staff_ticketfilters");
$template->loadLanguageSection("staff_tsearch");
require_once ("./modules/tickets/functions_ticketsearch.php");
require_once ("./modules/tickets/functions_ticketsui.php");
require_once ("./modules/tickets/functions_ticketcore.php");
require_once ("./modules/tickets/functions_filters.php");

/**
* ###############################################
* FUNCTION DECLARATIONS
* ###############################################
*/

/**
* Callback for parsing Filters data
*/
function _ticketFilterFields($arg)
{
	global $_SWIFT;
	$record = &$arg[0];
	$fields = &$arg[1];

	if ($record["filtertype"] == SWIFTPUBLIC)
	{
		$record["filtertype"] =$_SWIFT["language"]["public"];
	} else {
		$record["filtertype"] =$_SWIFT["language"]["private"];
	}

	$record["title"] = '<table width="100%" border="0" cellspacing="0" cellpadding="1"><tr><td width="1"><img src="'. $_SWIFT["themepath"] .'icon_filteritem.gif" border="0" /></td><td><span class="smalltext">&nbsp;<a href="index.php?_m=tickets&_a=editfilter&ticketfilterid='. $record["ticketfilterid"] .'">'. $record["title"] .'</a></span></td></tr></table>';

	$record["options"] = '<a href="index.php?_m=tickets&_a=editfilter&ticketfilterid='. $record["ticketfilterid"] .'" title="'. $_SWIFT["language"]["edit"] .'"><img src="'. $_SWIFT["themepath"] .'icon_edit.gif" border="0">&nbsp;'. $_SWIFT["language"]["edit"] .'</a>&nbsp;&nbsp;&nbsp;&nbsp;<a onClick="javascript:doConfirm(\''. $_SWIFT["language"]["filterdelconfirmmsg"] .'\', \'index.php?_m=tickets&_a=managefilters&do=delete&ticketfilterid='. $record["ticketfilterid"] .'\');" href="#" title="'. $_SWIFT["language"]["delete"] .'"><img src="'. $_SWIFT["themepath"] .'icon_delete.gif" border="0">&nbsp;'. $_SWIFT["language"]["delete"] .'</a>&nbsp;';

	return $record;
}

/**
* Mass Action: Delete Ticket Filters
*/
function _maDeleteTicketFilters()
{
	global $dbCore, $_SWIFT;

	if (_is_array($_POST["itemid"]))
	{
		deleteTicketFilters($_POST["itemid"]);
	}
}




ob_start();
?>
<script type="text/javascript">
			var cruleindex = 1;
			function newFilterCriteria()
			{
				var rowElement = document.createElement("div");
				rowElement.id = "rulerow"+cruleindex;
				var rowMod = cruleindex%2;
				rowElement.className = "searchrule"+rowMod;
				var tparent = browserObject("ruleparent");
				if (!tparent)
				{
					return false;
				}

				tparent.appendChild(rowElement);
				updateRuleHTML(cruleindex, "subject", '', '');
				cruleindex++;
			}

			function newRuleCriteria(crulename, selectedop, dfieldvalue)
			{
				var rowElement = document.createElement("div");
				rowElement.id = "rulerow"+cruleindex;
				var rowMod = cruleindex%2;
				rowElement.className = "searchrule"+rowMod;
				var tparent = browserObject("ruleparent");
				if (!tparent)
				{
					return false;
				}

				tparent.appendChild(rowElement);
				updateRuleHTML(cruleindex, crulename, selectedop, dfieldvalue);
				cruleindex++;
			}

			function removeRuleRow(ruleindex)
			{
				var tparent = browserObject("ruleparent");
				if (!tparent)
				{
					return false;
				}

				var rowElement = browserObject("rulerow"+ruleindex);
				if (!rowElement)
				{
					return false;
				}

				tparent.removeChild(rowElement);
			}

			function updateRuleHTML(ruleindex, fieldtype, selectedop, dfieldvalue)
			{
				var returnResult;

				if (!selectedop)
				{
					var selectedop = '';
				}
				if (!dfieldvalue)
				{
					var dfieldvalue = '';
				}

				returnResult = '<table border="0" cellpadding="3" cellspacing="1" width="100%"><tr><td align="left" width="1"><a href="javascript:void(0);" onClick="javascript:removeRuleRow(\''+ruleindex+'\');"><img src="<?php echo $_SWIFT["themepath"]; ?>icon_deletesmall.gif" title="<?php echo $_SWIFT["language"]["deletecriteria"]; ?>" border="0" /></a></td><td align="left" width="1"><select name="searchrules['+ ruleindex +'][0]" class="swiftselect" onChange="javascript:updateRuleHTML(\''+ ruleindex +'\', this.options[this.selectedIndex].value);">';
				returnResult += '<optgroup label="<?php echo $_SWIFT["language"]["sticket"]; ?>">';
				returnResult += '<option value="subject"'+selectedStatus(fieldtype, "subject")+'><?php echo addslashes($_SWIFT["language"]["ssubject"]); ?></option>';
				returnResult += '<option value="fullname"'+selectedStatus(fieldtype, "fullname")+'><?php echo addslashes($_SWIFT["language"]["sfullname"]); ?></option>';
				returnResult += '<option value="email"'+selectedStatus(fieldtype, "email")+'><?php echo addslashes($_SWIFT["language"]["semail"]); ?></option>';
				returnResult += '<option value="groupname"'+selectedStatus(fieldtype, "groupname")+'><?php echo addslashes($_SWIFT["language"]["sgroupname"]); ?></option>';
				returnResult += '<option value="tgroupid"'+selectedStatus(fieldtype, "tgroupid")+'><?php echo addslashes($_SWIFT["language"]["stgroup"]); ?></option>';
				returnResult += '<option value="notes"'+selectedStatus(fieldtype, "notes")+'><?php echo addslashes($_SWIFT["language"]["snotes"]); ?></option>';
				returnResult += '<option value="usernotes"'+selectedStatus(fieldtype, "usernotes")+'><?php echo addslashes($_SWIFT["language"]["susernotes"]); ?></option>';
				returnResult += '<option value="departmentid"'+selectedStatus(fieldtype, "departmentid")+'><?php echo addslashes($_SWIFT["language"]["sdepartment"]); ?></option>';
				returnResult += '<option value="ticketstatusid"'+selectedStatus(fieldtype, "ticketstatusid")+'><?php echo addslashes($_SWIFT["language"]["sticketstatus"]); ?></option>';
				returnResult += '<option value="priorityid"'+selectedStatus(fieldtype, "priorityid")+'><?php echo addslashes($_SWIFT["language"]["spriority"]); ?></option>';
				returnResult += '<option value="ownerstaffid"'+selectedStatus(fieldtype, "ownerstaffid")+'><?php echo addslashes($_SWIFT["language"]["sowner"]); ?></option>';
				returnResult += '<option value="flagtype"'+selectedStatus(fieldtype, "flagtype")+'><?php echo addslashes($_SWIFT["language"]["sflagtype"]); ?></option>';
				returnResult += '<option value="slaplanid"'+selectedStatus(fieldtype, "slaplanid")+'><?php echo addslashes($_SWIFT["language"]["sslaplan"]); ?></option>';
				returnResult += '<option value="dateline"'+selectedStatus(fieldtype, "dateline")+'><?php echo addslashes($_SWIFT["language"]["screationdate"]); ?></option>';
				returnResult += '<option value="datelinerange"'+selectedStatus(fieldtype, "datelinerange")+'><?php echo addslashes($_SWIFT["language"]["fcreationdaterange"]); ?></option>';
				returnResult += '<option value="duetime"'+selectedStatus(fieldtype, "duetime")+'><?php echo addslashes($_SWIFT["language"]["sduetime"]); ?></option>';
				returnResult += '<option value="duetimerange"'+selectedStatus(fieldtype, "duetimerange")+'><?php echo addslashes($_SWIFT["language"]["fduetimerange"]); ?></option>';
				returnResult += '<option value="lastactivity"'+selectedStatus(fieldtype, "lastactivity")+'><?php echo addslashes($_SWIFT["language"]["slastactivity"]); ?></option>';
				returnResult += '<option value="lastactivityrange"'+selectedStatus(fieldtype, "lastactivityrange")+'><?php echo addslashes($_SWIFT["language"]["flastactivityrange"]); ?></option>';
				returnResult += '<option value="lastuserreplytime"'+selectedStatus(fieldtype, "lastuserreplytime")+'><?php echo addslashes($_SWIFT["language"]["slastuserreplytime"]); ?></option>';
				returnResult += '<option value="lastuserreplytimerange"'+selectedStatus(fieldtype, "lastuserreplytimerange")+'><?php echo addslashes($_SWIFT["language"]["slastuserreplytimerange"]); ?></option>';
				returnResult += '<option value="laststaffreplytime"'+selectedStatus(fieldtype, "laststaffreplytime")+'><?php echo addslashes($_SWIFT["language"]["slaststaffreplytime"]); ?></option>';
				returnResult += '<option value="laststaffreplytimerange"'+selectedStatus(fieldtype, "laststaffreplytimerange")+'><?php echo addslashes($_SWIFT["language"]["slaststaffreplytimerange"]); ?></option>';
				returnResult += '<option value="isphonecall"'+selectedStatus(fieldtype, "isphonecall")+'><?php echo addslashes($_SWIFT["language"]["sphoneticket"]); ?></option>';
				returnResult += '<option value="isescalated"'+selectedStatus(fieldtype, "isescalated")+'><?php echo addslashes($_SWIFT["language"]["sisescalated"]); ?></option>';
				returnResult += '<option value="escalatedon"'+selectedStatus(fieldtype, "escalatedon")+'><?php echo addslashes($_SWIFT["language"]["fescalatedon"]); ?></option>';
				returnResult += '<option value="escalatedonrange"'+selectedStatus(fieldtype, "escalatedonrange")+'><?php echo addslashes($_SWIFT["language"]["fescalatedonrange"]); ?></option>';
				returnResult += '<option value="hasattachments"'+selectedStatus(fieldtype, "hasattachments")+'><?php echo addslashes($_SWIFT["language"]["shasattachments"]); ?></option>';
				returnResult += '<option value="hasnotes"'+selectedStatus(fieldtype, "hasnotes")+'><?php echo addslashes($_SWIFT["language"]["shasnotes"]); ?></option>';
				returnResult += '<option value="isemailed"'+selectedStatus(fieldtype, "isemailed")+'><?php echo addslashes($_SWIFT["language"]["sisemailed"]); ?></option>';
				returnResult += '<option value="hasbilling"'+selectedStatus(fieldtype, "hasbilling")+'><?php echo addslashes($_SWIFT["language"]["shasbilling"]); ?></option>';
				returnResult += '</optgroup>';
				<?php 
				// First get the custom field groups
				//Mahesh Slaria: Staff & user ticket creation
				$_customfieldgroups = $customfieldgroupidlist = $_customfields = $customfieldidlist = array();
				$dbCore->query("SELECT * FROM `". TABLE_PREFIX ."customfieldgroups` WHERE `grouptype` IN ('". CUSTOMFIELD_USERTICKET ."', '". CUSTOMFIELD_STAFFTICKET ."', '". CUSTOMFIELD_STAFFUSERTICKET ."') ORDER BY `displayorder` ASC;");
				while ($dbCore->nextRecord())
				{
					$customfieldgroupidlist[]= $dbCore->Record["customfieldgroupid"];
					$_customfieldgroups[$dbCore->Record["customfieldgroupid"]] = $dbCore->Record;
					$_customfieldgroups[$dbCore->Record["customfieldgroupid"]]["fields"] = array();
				}

				if (count($customfieldgroupidlist))
				{
					$dbCore->query("SELECT * FROM `". TABLE_PREFIX ."customfields` WHERE `customfieldgroupid` IN (". buildIN($customfieldgroupidlist) .");");
					while ($dbCore->nextRecord())
					{
						$customfieldidlist[] = $dbCore->Record["customfieldid"];
						$_customfields[$dbCore->Record["customfieldid"]] = $dbCore->Record;
						$_customfieldgroups[$dbCore->Record["customfieldgroupid"]]["fields"][$dbCore->Record["customfieldid"]] = &$_customfields[$dbCore->Record["customfieldid"]];
					}
				}

				foreach ($_customfieldgroups as $key=>$val)
				{
					?>
					returnResult += '<optgroup label="<?php echo addslashes($val["title"]); ?>">';
					<?php 
					foreach ($val["fields"] as $fieldkey=>$fieldval)
					{
						?>
						returnResult += '<option value="cfield_<?php echo $fieldval["customfieldid"]; ?>"'+selectedStatus(fieldtype, "cfield_<?php echo $fieldval["customfieldid"]; ?>")+'><?php echo addslashes($fieldval["title"]); ?></option>';
						<?php 
					}
					?>
					returnResult += '</optgroup>';
					<?php 
				}
				?>
				returnResult += '</select>';

				returnResult += "</td>";

				if (fieldtype == "subject") {
					returnResult += getOperatorHTML(ruleindex, "string", selectedop)+getQueryHTML(ruleindex, "text", dfieldvalue);
				} else if (fieldtype == "contents") {
					returnResult += getOperatorHTML(ruleindex, "string", selectedop)+getQueryHTML(ruleindex, "text", dfieldvalue);
				} else if (fieldtype == "departmentid") {
					returnResult += getOperatorHTML(ruleindex, "bool", selectedop)+getQueryHTML(ruleindex, "departmentid", dfieldvalue);
				} else if (fieldtype == "ticketstatusid") {
					returnResult += getOperatorHTML(ruleindex, "bool", selectedop)+getQueryHTML(ruleindex, "ticketstatusid", dfieldvalue);
				} else if (fieldtype == "priorityid") {
					returnResult += getOperatorHTML(ruleindex, "bool", selectedop)+getQueryHTML(ruleindex, "priorityid", dfieldvalue);
				} else if (fieldtype == "tgroupid") {
					returnResult += getOperatorHTML(ruleindex, "bool", selectedop)+getQueryHTML(ruleindex, "tgroupid", dfieldvalue);
				} else if (fieldtype == "ownerstaffid") {
					returnResult += getOperatorHTML(ruleindex, "bool", selectedop)+getQueryHTML(ruleindex, "ownerstaffid", dfieldvalue);
				} else if (fieldtype == "flagtype") {
					returnResult += getOperatorHTML(ruleindex, "bool", selectedop)+getQueryHTML(ruleindex, "flagtype", dfieldvalue);
				} else if (fieldtype == "isphonecall") {
					returnResult += getOperatorHTML(ruleindex, "bool", selectedop)+getQueryHTML(ruleindex, "bool", dfieldvalue);
				} else if (fieldtype == "isescalated") {
					returnResult += getOperatorHTML(ruleindex, "bool", selectedop)+getQueryHTML(ruleindex, "bool", dfieldvalue);
				} else if (fieldtype == "hasattachments") {
					returnResult += getOperatorHTML(ruleindex, "bool", selectedop)+getQueryHTML(ruleindex, "bool", dfieldvalue);
				} else if (fieldtype == "hasnotes") {
					returnResult += getOperatorHTML(ruleindex, "bool", selectedop)+getQueryHTML(ruleindex, "bool", dfieldvalue);
				} else if (fieldtype == "notes" || fieldtype == "email" || fieldtype == "fullname" || fieldtype == "groupname") {
					returnResult += getOperatorHTML(ruleindex, "resstring", selectedop)+getQueryHTML(ruleindex, "text", dfieldvalue);
				} else if (fieldtype == "usernotes") {
					returnResult += getOperatorHTML(ruleindex, "resstring", selectedop)+getQueryHTML(ruleindex, "text", dfieldvalue);
				} else if (fieldtype == "duetime") {
					returnResult += getOperatorHTML(ruleindex, "cal", selectedop)+getQueryHTML(ruleindex, "cal", dfieldvalue);
				} else if (fieldtype == "lastactivity" || fieldtype == "lastuserreplytime" || fieldtype == "laststaffreplytime") {
					returnResult += getOperatorHTML(ruleindex, "cal", selectedop)+getQueryHTML(ruleindex, "cal", dfieldvalue);
				} else if (fieldtype == "dateline" || fieldtype == "escalatedon") {
					returnResult += getOperatorHTML(ruleindex, "cal", selectedop)+getQueryHTML(ruleindex, "cal", dfieldvalue);
				} else if (fieldtype == "slaplanid") {
					returnResult += getOperatorHTML(ruleindex, "bool", selectedop)+getQueryHTML(ruleindex, "slaplanid", dfieldvalue);
				} else if (fieldtype == "isemailed") {
					returnResult += getOperatorHTML(ruleindex, "bool", selectedop)+getQueryHTML(ruleindex, "bool", dfieldvalue);
				} else if (fieldtype == "hasbilling") {
					returnResult += getOperatorHTML(ruleindex, "bool", selectedop)+getQueryHTML(ruleindex, "bool", dfieldvalue);
				} else if (fieldtype == "datelinerange" || fieldtype == "lastactivityrange" || fieldtype == "duetimerange" || fieldtype == "escalatedonrange" || fieldtype == "lastuserreplytimerange" || fieldtype == "laststaffreplytimerange") {
					returnResult += getOperatorHTML(ruleindex, "calrange", selectedop)+getQueryHTML(ruleindex, "calrange", dfieldvalue);
				}

				var cfield = fieldtype.substring(0,7);
				if (cfield == "cfield_")
				{
					returnResult += getOperatorHTML(ruleindex, "resstring", selectedop)+getQueryHTML(ruleindex, "text", dfieldvalue);
				}

				var dRow = browserObject("rulerow"+ruleindex);
				if (!dRow)
				{
					return;
				}

				dRow.innerHTML = returnResult+'</tr></table>';
			}

			function selectedStatus(fieldtype, fieldvalue)
			{
				if (fieldtype == fieldvalue)
				{
					return " selected";
				}
			}

			function getOperatorHTML(ruleindex, optype, selectedop)
			{
				if (!ruleindex)
				{
					return;
				}

				if (optype == "string")
				{
					if (!selectedop)
					{
						var selectedop = '<?php echo OP_CONTAINS; ?>';
					}
					return '<td align="left" width="1"><select name="searchrules['+ ruleindex +'][1]" class="swiftselect"><option value="<?php echo OP_CONTAINS; ?>"'+selectedStatus(selectedop, "<?php echo OP_CONTAINS; ?>")+'><?php echo $_SWIFT["language"]["opcontains"]; ?></option><option value="<?php echo OP_NOTCONTAINS; ?>"'+selectedStatus(selectedop, "<?php echo OP_NOTCONTAINS; ?>")+'><?php echo addslashes($_SWIFT["language"]["opnotcontains"]); ?></option><option value="<?php echo OP_EQUAL; ?>"'+selectedStatus(selectedop, "<?php echo OP_EQUAL; ?>")+'><?php echo $_SWIFT["language"]["opequal"]; ?></option><option value="<?php echo OP_NOTEQUAL; ?>"'+selectedStatus(selectedop, "<?php echo OP_NOTEQUAL; ?>")+'><?php echo $_SWIFT["language"]["opnotequal"]; ?></option></select></td>';
				} else if (optype == "resstring") {
					return '<td align="left" width="1"><select name="searchrules['+ ruleindex +'][1]" class="swiftselect"><option value="<?php echo OP_CONTAINS; ?>" selected><?php echo $_SWIFT["language"]["opcontains"]; ?></option></select></td>';
				} else if (optype == "bool") {
					if (!selectedop)
					{
						var selectedop = '<?php echo OP_EQUAL; ?>';
					}
					return '<td align="left" width="1"><select name="searchrules['+ ruleindex +'][1]" class="swiftselect"><option value="<?php echo OP_EQUAL; ?>"'+selectedStatus(selectedop, "<?php echo OP_EQUAL; ?>")+'><?php echo $_SWIFT["language"]["opequal"]; ?></option><option value="<?php echo OP_NOTEQUAL; ?>"'+selectedStatus(selectedop, "<?php echo OP_NOTEQUAL; ?>")+'><?php echo $_SWIFT["language"]["opnotequal"]; ?></option></select></td>';
				} else if (optype == "int") {
					if (!selectedop)
					{
						var selectedop = '<?php echo OP_EQUAL; ?>';
					}
					return '<td align="left" width="1"><select name="searchrules['+ ruleindex +'][1]" class="swiftselect"><option value="<?php echo OP_GREATER; ?>"'+selectedStatus(selectedop, "<?php echo OP_GREATER; ?>")+'><?php echo $_SWIFT["language"]["opgreater"]; ?></option><option value="<?php echo OP_LESS; ?>"'+selectedStatus(selectedop, "<?php echo OP_LESS; ?>")+'><?php echo $_SWIFT["language"]["opless"]; ?></option><option value="<?php echo OP_EQUAL; ?>"'+selectedStatus(selectedop, "<?php echo OP_EQUAL; ?>")+'><?php echo $_SWIFT["language"]["opequal"]; ?></option><option value="<?php echo OP_NOTEQUAL; ?>"'+selectedStatus(selectedop, "<?php echo OP_NOTEQUAL; ?>")+'><?php echo $_SWIFT["language"]["opnotequal"]; ?></option></select></td>';
				} else if (optype == "cal") {
					if (!selectedop)
					{
						var selectedop = '<?php echo OP_GREATER; ?>';
					}
					return '<td align="left" width="1"><select name="searchrules['+ ruleindex +'][1]" class="swiftselect"><option value="<?php echo OP_GREATER; ?>"'+selectedStatus(selectedop, "<?php echo OP_GREATER; ?>")+'><?php echo $_SWIFT["language"]["opgreater"]; ?></option><option value="<?php echo OP_LESS; ?>"'+selectedStatus(selectedop, "<?php echo OP_LESS; ?>")+'><?php echo $_SWIFT["language"]["opless"]; ?></option></select></td>';
				} else if (optype == "calrange") {
					return '<td align="left" width="1"><select name="searchrules['+ ruleindex +'][1]" class="swiftselect"><option value="<?php echo OP_EQUAL; ?>" selected><?php echo $_SWIFT["language"]["opequal"]; ?></option></select></td>';
				}
			}

			function getQueryHTML(ruleindex, querytype, dfieldvalue)
			{
				if (!ruleindex)
				{
					return;
				}

				var returnResult = '<td align="left">';
				if (querytype == "text")
				{
					returnResult += '<input type="text" size="20" class="swifttext" name="searchrules['+ ruleindex +'][2]" style="width:98%;" value="'+ dfieldvalue +'" />';
				} else if (querytype == "textentire") {
					returnResult += '<input type="text" size="20" class="swifttext" name="searchrules['+ ruleindex +'][2]" style="width:50%;" value="'+ dfieldvalue +'" /><span class="smalltext">&nbsp;&nbsp;<?php echo addslashes($_SWIFT["language"]["squerydesc"]); ?></span>';
				} else if (querytype == "ticketstatusid") {
					returnResult += '<select name="searchrules['+ ruleindex +'][2]" class="swiftselect">';
					<?php 
					foreach ($_SWIFT["statuscache"] as $key=>$val)
					{
						?>returnResult += '<option value="<?php echo $val["ticketstatusid"]; ?>" style="color:<?php echo $val["statuscolor"]; ?>;"'+ selectedStatus(dfieldvalue, '<?php echo $val["ticketstatusid"]; ?>') +'><?php echo addslashes($val["title"]); ?></option>';<?php 
					}
					?>
					returnResult += '</select>';
				} else if (querytype == "tgroupid") {
					returnResult += '<select name="searchrules['+ ruleindex +'][2]" class="swiftselect">';
					<?php 
					foreach ($_SWIFT["tgroupcache"] as $key=>$val)
					{
						?>returnResult += '<option value="<?php echo $val["tgroupid"]; ?>"'+ selectedStatus(dfieldvalue, '<?php echo $val["tgroupid"]; ?>') +'><?php echo addslashes($val["title"]); ?></option>';<?php 
					}
					?>
					returnResult += '</select>';
				} else if (querytype == "priorityid") {
					returnResult += '<select name="searchrules['+ ruleindex +'][2]" class="swiftselect">';
					<?php 
					foreach ($_SWIFT["prioritycache"] as $key=>$val)
					{
						?>returnResult += '<option value="<?php echo $val["priorityid"]; ?>" style="color:<?php echo $val["frcolorcode"]; ?>;background:<?php echo $val["bgcolorcode"]; ?>;"'+ selectedStatus(dfieldvalue, '<?php echo $val["priorityid"]; ?>') +'><?php echo addslashes($val["title"]); ?></option>';<?php 
					}
					?>
					returnResult += '</select>';
				} else if (querytype == "ownerstaffid") {
					returnResult += '<select name="searchrules['+ ruleindex +'][2]" class="swiftselect">';
					<?php 
					foreach ($_SWIFT["staffcache"] as $key=>$val)
					{
						?>returnResult += '<option value="<?php echo $val["staffid"]; ?>"'+ selectedStatus(dfieldvalue, '<?php echo $val["staffid"]; ?>') +'><?php echo addslashes($val["fullname"]); ?></option>';<?php 
					}
					?>
					returnResult += '</select>';
				} else if (querytype == "departmentid") {
					returnResult += '<select name="searchrules['+ ruleindex +'][2]" class="swiftselect">';
					<?php 
					$_assigns = getAssignedDepartments(MODULE_TICKETS);
					foreach ($_assigns as $key=>$val)
					{
						$_department = $_SWIFT["departmentcache"][$val];
						?>returnResult += '<option value="<?php echo $_department["departmentid"]; ?>"'+ selectedStatus(dfieldvalue, '<?php echo $_department["departmentid"]; ?>') +'><?php echo addslashes($_department["title"]); ?></option>';<?php 
					}
					?>
					returnResult += '</select>';
				} else if (querytype == "slaplanid") {
					returnResult += '<select name="searchrules['+ ruleindex +'][2]" class="swiftselect">';
					<?php 
					if (_is_array($_SWIFT["slaplancache"]))
					{
						foreach ($_SWIFT["slaplancache"] as $key=>$val)
						{
							?>returnResult += '<option value="<?php echo $val["slaplanid"]; ?>"'+ selectedStatus(dfieldvalue, '<?php echo $val["slaplanid"]; ?>') +'><?php echo addslashes($val["title"]); ?></option>';<?php 
						}
					}
					?>
					returnResult += '</select>';
				} else if (querytype == "cal") {
				    <?php 
				        require_once ("./includes/functions_date.php");
				        $dateFormat = getCalendarDateFormats();
				    ?>
					returnResult += '<input type="text" name="searchrules['+ruleindex+'][2]" id="rulecal'+ ruleindex +'" onclick="return showCalendar(\'rulecal'+ ruleindex +'\', \'<?php echo $dateFormat["cal"]; ?>\');" size="12" readonly="1" value="'+ dfieldvalue +'" class="swifttext"/>&nbsp;<img src="<?php echo $_SWIFT["themepath"]; ?>calendar.gif" onclick="return showCalendar(\'rulecal'+ ruleindex +'\', \'<?php echo $dateFormat["cal"]; ?>\');" style="cursor: pointer;" align="absmiddle"/>';
				} else if (querytype == "calrange") {
					returnResult += '<select name="searchrules['+ ruleindex +'][2]" class="swiftselect">';
					returnResult += '<option value="yesterday"'+ selectedStatus(dfieldvalue, 'yesterday') +'><?php echo addslashes($_SWIFT["language"]["fyesterday"]); ?></option>';					
					returnResult += '<option value="today"'+ selectedStatus(dfieldvalue, 'today') +'><?php echo addslashes($_SWIFT["language"]["ftoday"]); ?></option>';
					returnResult += '<option value="thisweek"'+ selectedStatus(dfieldvalue, 'thisweek') +'><?php echo addslashes($_SWIFT["language"]["fthisweek"]); ?></option>';
					returnResult += '<option value="thismonth"'+ selectedStatus(dfieldvalue, 'thismonth') +'><?php echo addslashes($_SWIFT["language"]["fthismonth"]); ?></option>';				
					returnResult += '<option value="thisyear"'+ selectedStatus(dfieldvalue, 'thisyear') +'><?php echo addslashes($_SWIFT["language"]["fthisyear"]); ?></option>';						
					returnResult += '<option value="lastweek"'+ selectedStatus(dfieldvalue, 'lastweek') +'><?php echo addslashes($_SWIFT["language"]["flastweek"]); ?></option>';					
					returnResult += '<option value="lastmonth"'+ selectedStatus(dfieldvalue, 'lastmonth') +'><?php echo addslashes($_SWIFT["language"]["flastmonth"]); ?></option>';					
					returnResult += '<option value="lastthreemonths"'+ selectedStatus(dfieldvalue, 'lastthreemonths') +'><?php echo addslashes($_SWIFT["language"]["flastthreemonths"]); ?></option>';
					returnResult += '<option value="lastsixmonths"'+ selectedStatus(dfieldvalue, 'lastsixmonths') +'><?php echo addslashes($_SWIFT["language"]["flastsixmonths"]); ?></option>';
					returnResult += '<option value="lastyear"'+ selectedStatus(dfieldvalue, 'lastyear') +'><?php echo addslashes($_SWIFT["language"]["flastyear"]); ?></option>';					
					returnResult += '</select>';
				} else if (querytype == "bool") {
					returnResult += '<select name="searchrules['+ ruleindex +'][2]" class="swiftselect"><option value="1"'+ selectedStatus(dfieldvalue, '1') +'><?php echo $_SWIFT["language"]["strue"]; ?></option><option value="0"'+ selectedStatus(dfieldvalue, '0') +'><?php echo $_SWIFT["language"]["sfalse"]; ?></option></select>';
				} else if (querytype == "flagtype") {
					<?php 
					$flagbgcolors = array(FLAG_PURPLE => "#A5587C", FLAG_ORANGE => "#FF8C5A", FLAG_GREEN => "#8BB467", FLAG_YELLOW => "#FFC160", FLAG_RED => "#CF5D60", FLAG_BLUE => "#5C83B4");
					?>
					returnResult += '<select name="searchrules['+ ruleindex +'][2]" class="swiftselect">';
					returnResult += '<option value="<?php echo FLAG_PURPLE; ?>" style="background: <?php echo $flagbgcolors[FLAG_PURPLE]; ?>; color: #FFFFFF;"'+ selectedStatus(dfieldvalue, '<?php echo FLAG_PURPLE; ?>') +'><?php echo addslashes($_SWIFT["language"]["purpleflag"]); ?></option>';
					returnResult += '<option value="<?php echo FLAG_RED; ?>" style="background: <?php echo $flagbgcolors[FLAG_RED]; ?>; color: #FFFFFF;"'+ selectedStatus(dfieldvalue, '<?php echo FLAG_RED; ?>') +'><?php echo addslashes($_SWIFT["language"]["redflag"]); ?></option>';
					returnResult += '<option value="<?php echo FLAG_ORANGE; ?>" style="background: <?php echo $flagbgcolors[FLAG_ORANGE]; ?>; color: #FFFFFF;"'+ selectedStatus(dfieldvalue, '<?php echo FLAG_ORANGE; ?>') +'><?php echo addslashes($_SWIFT["language"]["orangeflag"]); ?></option>';
					returnResult += '<option value="<?php echo FLAG_YELLOW; ?>" style="background: <?php echo $flagbgcolors[FLAG_YELLOW]; ?>; color: #FFFFFF;"'+ selectedStatus(dfieldvalue, '<?php echo FLAG_YELLOW; ?>') +'><?php echo addslashes($_SWIFT["language"]["yellowflag"]); ?></option>';
					returnResult += '<option value="<?php echo FLAG_BLUE; ?>" style="background: <?php echo $flagbgcolors[FLAG_BLUE]; ?>; color: #FFFFFF;"'+ selectedStatus(dfieldvalue, '<?php echo FLAG_BLUE; ?>') +'><?php echo addslashes($_SWIFT["language"]["blueflag"]); ?></option>';
					returnResult += '<option value="<?php echo FLAG_GREEN; ?>" style="background: <?php echo $flagbgcolors[FLAG_GREEN]; ?>; color: #FFFFFF;"'+ selectedStatus(dfieldvalue, '<?php echo FLAG_GREEN; ?>') +'><?php echo addslashes($_SWIFT["language"]["greenflag"]); ?></option>';
					returnResult += '<option value="0" style="background: #CCCCCC; color: #FFFFFF;"'+ selectedStatus(dfieldvalue, '0') +'><?php echo addslashes($_SWIFT["language"]["noflag"]); ?></option>';
					returnResult += '</select>';
				}

				return returnResult+'</td>';
			}
</script>
<?php 
$jscode = ob_get_contents();
ob_end_clean();

/**
* ###############################################
* RUN EXISTING FILTER
* ###############################################
*/
if ($eventaction == "runfilter")
{
	$_ticketfilter = $dbCore->queryFetch("SELECT * FROM `". TABLE_PREFIX ."ticketfilters` WHERE `ticketfilterid` = '". intval($_REQUEST["ticketfilterid"]) ."';");
	if (empty($_ticketfilter["ticketfilterid"]) || ($_ticketfilter["filtertype"] == SWIFTPRIVATE && $_ticketfilter["staffid"] != $_SWIFT["staff"]["staffid"]))
	{
		trigger_error($_SWIFT["language"]["invalidfilteraccess"], E_USER_ERROR);
		exit;
	}

	$_filterrules = array();
	$index = 0;
	$dbCore->query("SELECT * FROM `". TABLE_PREFIX ."ticketfilterfields` WHERE `ticketfilterid` = '". intval($_ticketfilter["ticketfilterid"]) ."';");
	while ($dbCore->nextRecord())
	{
		$_filterrules[$index][0] = $dbCore->Record["fieldtitle"];
		$_filterrules[$index][1] = $dbCore->Record["fieldoper"];
		$_filterrules[$index][2] = $dbCore->Record["fieldvalue"];
		$index++;
	}

	$_ticketsearchid = processSearchRules($_filterrules, $_ticketfilter["filteroptions"], $_ticketfilter["ticketfilterid"]);
	if ($_ticketsearchid)
	{
		header("location: index.php?_m=tickets&_a=manage&ticketsearchid=".intval($_ticketsearchid));
		exit;
	} else {
		// Search Failed
		header("location: index.php?_m=tickets&_a=manage&fnomatch=1");
		exit;
	}



/**
* ###############################################
* INSERT NEW FILTER
* ###############################################
*/
} else if ($eventaction == "insertfilter") {
	if ($_POST["step"] == "1")
	{
		if (trim($_POST["title"]) == "" || trim($_POST["filtertype"]) == "" || !count($_POST["searchrules"]))
		{
			$errormessage = $_SWIFT["language"]["requiredfieldempty"];
		} else {
			$_ticketfilterid = insertTicketFilter($_POST["title"], $_POST["filtertype"], $_POST["searchrules"], $_POST["ruleoptions"]);

			printRedirect(sprintf($_SWIFT["language"]["filterinsertconfirm"], htmlspecialchars($_POST["title"])), "index.php?_m=tickets&_a=managefilters&insertfilter=".urlencode($_POST["title"]));
			exit;
		}
	}

	renderTicketTree();

	$template->assign("calendar", true);

	$interface->staffHeader($_SWIFT["language"]["ticket"] ." &gt; ".$_SWIFT["language"]["insertfilter"], 2);

	$interface->staffNavBar('<a href="index.php?_m=tickets&_a=manage" title="'.$_SWIFT["language"]["tickets"].'">'.$_SWIFT["language"]["tickets"].'</a> &raquo; <a href="index.php?_m=tickets&_a=insertfilter" title="'.$_SWIFT["language"]["insertfilter"].'">'.$_SWIFT["language"]["insertfilter"]."</a>", $_SWIFT["language"]["insertfilterdesc"], 2);

	echo $jscode;

	printInfoBox($infomessage);
	printErrorBox($errormessage);

	printFormStart();
	printMainTableHeader($_SWIFT["language"]["insertfilter"]);

	printTextRow("title", $_SWIFT["language"]["filtertitle"], $_SWIFT["language"]["desc_filtertitle"], "text", $_POST["title"]);

	printPublicPrivateRow("filtertype", $_SWIFT["language"]["filtertype"], $_SWIFT["language"]["desc_filtertype"], SWIFTPUBLIC);

	printDescRow($_SWIFT["language"]["filtercriteria"]);
	echo '<tr class="'. getRowBG() .'">
	<td align="left" colspan="2"><span class="smalltext"><div id="ruleparent"></div></span></td></tr>';

	echo '<tr class="'. getRowBG() .'">
	<td align="left" colspan="2"><span class="smalltext"><a href="javascript:newFilterCriteria();"><img src="'. $_SWIFT["themepath"] .'icon_add.gif" border="0" align="absmiddle" />&nbsp;'. $_SWIFT["language"]["newcriteria"] .'</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<label for="ruleall"><input type="radio" name="ruleoptions" value="all" id="ruleall" checked>'. $_SWIFT["language"]["fmatchall"] .'</label>&nbsp;<label for="ruleany"><input type="radio" name="ruleoptions" value="any" id="ruleany">'. $_SWIFT["language"]["fmatchany"] .'</label></span></td></tr>';

	printSubmitRow($_SWIFT["language"]["insert"]);

	printMainTableFooter();

	addHiddenField("_m", "tickets");
	addHiddenField("_a", "insertfilter");
	addHiddenField("step", "1");
	printFormEnd();


	?>
	<script type="text/javascript">
		newFilterCriteria();
	</script>
	<?php 
	$template->assign("backurl", "index.php?_m=tickets&_a=manage");
	$interface->staffFooter();





/**
* ###############################################
* EDIT EXISTING FILTER
* ###############################################
*/
} else if ($eventaction == "editfilter") {
	$_ticketfilter = $dbCore->queryFetch("SELECT * FROM `". TABLE_PREFIX ."ticketfilters` WHERE `ticketfilterid` = '". intval($_REQUEST["ticketfilterid"]) ."';");
	if (empty($_ticketfilter["ticketfilterid"]) || ($_ticketfilter["filtertype"] == SWIFTPRIVATE && $_ticketfilter["staffid"] != $_SWIFT["staff"]["staffid"]))
	{
		trigger_error($_SWIFT["language"]["invalidfilteraccess"], E_USER_ERROR);
		exit;
	}

	$_ticketfilterfields = array();
	$dbCore->query("SELECT * FROM `". TABLE_PREFIX ."ticketfilterfields` WHERE `ticketfilterid` = '". intval($_ticketfilter["ticketfilterid"]) ."';");
	while ($dbCore->nextRecord())
	{
		$_ticketfilterfields[$dbCore->Record["ticketfilterfieldid"]] = $dbCore->Record;
	}

	if ($_POST["step"] == "1")
	{
		if (trim($_POST["title"]) == "" || trim($_POST["filtertype"]) == "" || !count($_POST["searchrules"]))
		{
			$errormessage = $_SWIFT["language"]["requiredfieldempty"];
		} else {
			updateTicketFilter($_ticketfilter["ticketfilterid"], $_POST["title"], $_POST["filtertype"], $_POST["searchrules"], $_POST["ruleoptions"]);

			printRedirect(sprintf($_SWIFT["language"]["filtereditconfirm"], htmlspecialchars($_POST["title"])), "index.php?_m=tickets&_a=managefilters&editfilter=".urlencode($_POST["title"]));
			exit;
		}
	}

	renderTicketTree();

	$template->assign("calendar", true);

	$interface->staffHeader($_SWIFT["language"]["ticket"] ." &gt; ".$_SWIFT["language"]["editfilter"], 2);

	$interface->staffNavBar('<a href="index.php?_m=tickets&_a=manage" title="'.$_SWIFT["language"]["tickets"].'">'.$_SWIFT["language"]["tickets"].'</a> &raquo; <a href="index.php?_m=tickets&_a=editfilter&ticketfilterid='. intval($_ticketfilter["ticketfilterid"]) .'" title="'.$_SWIFT["language"]["editfilter"].'">'.$_SWIFT["language"]["editfilter"]."</a>", $_SWIFT["language"]["editfilterdesc"], 2);

	echo $jscode;

	printInfoBox($infomessage);
	printErrorBox($errormessage);

	printFormStart();
	printMainTableHeader($_SWIFT["language"]["editfilter"]);

	printTextRow("title", $_SWIFT["language"]["filtertitle"], $_SWIFT["language"]["desc_filtertitle"], "text", $_ticketfilter["title"]);

	printPublicPrivateRow("filtertype", $_SWIFT["language"]["filtertype"], $_SWIFT["language"]["desc_filtertype"], iif($_ticketfilter["filtertype"]==SWIFTPUBLIC, true, false));

	printDescRow($_SWIFT["language"]["filtercriteria"]);
	echo '<tr class="'. getRowBG() .'">
	<td align="left" colspan="2"><span class="smalltext"><div id="ruleparent"></div></span></td></tr>';

	echo '<tr class="'. getRowBG() .'">
	<td align="left" colspan="2"><span class="smalltext"><a href="javascript:newFilterCriteria();"><img src="'. $_SWIFT["themepath"] .'icon_add.gif" border="0" align="absmiddle" />&nbsp;'. $_SWIFT["language"]["newcriteria"] .'</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<label for="ruleall"><input type="radio" name="ruleoptions" value="all" id="ruleall"'. iif($_ticketfilter["filteroptions"]=="all", " checked") .'>'. $_SWIFT["language"]["fmatchall"] .'</label>&nbsp;<label for="ruleany"><input type="radio" name="ruleoptions" value="any" id="ruleany"'. iif($_ticketfilter["filteroptions"]=="any", " checked") .'>'. $_SWIFT["language"]["fmatchany"] .'</label></span></td></tr>';

	printSubmitRow($_SWIFT["language"]["insert"]);

	printMainTableFooter();

	addHiddenField("_m", "tickets");
	addHiddenField("_a", "editfilter");
	addHiddenField("ticketfilterid", $_ticketfilter["ticketfilterid"]);
	addHiddenField("step", "1");
	printFormEnd();


	?>
	<script type="text/javascript">
		<?php echo criteriaArrayToForm($_ticketfilterfields); ?>
	</script>
	<?php 
	$template->assign("backurl", "index.php?_m=tickets&_a=manage");
	$interface->staffFooter();





/**
* ###############################################
* MANAGE EXISTING FILTERS
* ###############################################
*/
} else if ($eventaction == "managefilters") {
	if ($_GET["do"] == "delete" && !empty($_GET["ticketfilterid"]))
	{
		deleteTicketFilters(array($_GET["ticketfilterid"]));

		printRedirect($_SWIFT["language"]["filterdelconfirm"], "index.php?_m=tickets&_a=managefilters&filterdel=1");
		exit;
	}

	if (!empty($_GET["insertfilter"]))
	{
		$infomessage = sprintf($_SWIFT["language"]["filterinsertconfirm"], htmlspecialchars($_GET["insertfilter"]));
	} else if (!empty($_GET["editfilter"])) {
		$infomessage = sprintf($_SWIFT["language"]["filtereditconfirm"], htmlspecialchars($_GET["editfilter"]));
	} else if (!empty($_GET["filterdel"])) {
		$infomessage = $_SWIFT["language"]["filterdelconfirm"];
	}
	

	$options["recordsperpage"] = "10";
	$options["sortby"] = "title";
	$options["sortorder"] = "asc";
	$options["massaction"][0]["title"] = $_SWIFT["language"]["delete"];
	$options["massaction"][0]["callback"] = "_maDeleteTicketFilters";

	$options["idname"] = "ticketfilterid";
	$options["quicksearch"] = true;

	$options["advancedsearch"][0]["title"] = $_SWIFT["language"]["title"];
	$options["advancedsearch"][0]["query"] = 'SELECT * FROM `'. TABLE_PREFIX .'ticketfilters` WHERE `title` LIKE \'%$_searchstr%\' AND ((`filtertype` = \''. ALERT_PUBLIC .'\') OR (`filtertype` = \''. ALERT_PRIVATE .'\' AND `staffid` = \''. intval($_SWIFT["staff"]["staffid"]) .'\')) $_sortjoin;';

	$options["callback"] = "_ticketFilterFields";

	$fields[0]["name"] = "title";
	$fields[0]["title"] = $_SWIFT["language"]["filtertitle"];
	$fields[0]["width"] = "";

	$fields[1]["name"] = "filtertype";
	$fields[1]["title"] = $_SWIFT["language"]["filtertype"];
	$fields[1]["width"] = "150";
	$fields[1]["align"] = "center";

	$fields[2]["type"] = "custom";
	$fields[2]["name"] = "options";
	$fields[2]["title"] = $_SWIFT["language"]["options"];
	$fields[2]["width"] = "150";
	$fields[2]["align"] = "center";

	$grid = new Grid();

	renderTicketTree();
	$interface->staffHeader($_SWIFT["language"]["tickets"]." &gt; ".$_SWIFT["language"]["managefilters"], 2);

	$interface->staffNavBar('<a href="index.php?_m=tickets&_a=manage" title="'.$_SWIFT["language"]["tickets"].'">'.$_SWIFT["language"]["tickets"].'</a> &raquo; <a href="index.php?_m=tickets&_a=managefilters" title="'.$_SWIFT["language"]["managefilters"].'">'.$_SWIFT["language"]["managefilters"].'</a>', "", 2);

	$grid->start("ticketfilters", $_SWIFT["language"]["filterlist"], 'SELECT * FROM `'. TABLE_PREFIX .'ticketfilters` WHERE (`filtertype` = \''. SWIFTPUBLIC .'\') OR (`filtertype` = \''. SWIFTPRIVATE .'\' AND `staffid` = \''. intval($_SWIFT["staff"]["staffid"]) .'\') $_sortjoin;', 'SELECT COUNT(*) AS totalitems FROM `'. TABLE_PREFIX .'ticketfilters` AS ticketfilters WHERE (`filtertype` = \''. SWIFTPUBLIC .'\') OR (`filtertype` = \''. SWIFTPRIVATE .'\' AND `staffid` = \''. intval($_SWIFT["staff"]["staffid"]) .'\');', 'SELECT * FROM `'. TABLE_PREFIX .'ticketfilters` WHERE `title` LIKE \'%$_searchstr%\' AND ((`filtertype` = \''. SWIFTPUBLIC .'\') OR (`filtertype` = \''. SWIFTPRIVATE .'\' AND `staffid` = \''. intval($_SWIFT["staff"]["staffid"]) .'\')) $_sortjoin;', $fields, $options);

	printInfoBox($infomessage);
	printErrorBox($errormessage);

	$grid->display("ticketfilters");

	$interface->staffFooter();
}

?>