<?php
//=======================================
//###################################
// Kayako Infotech Ltd. - SWIFT Framework
//
// Source Copyright 2001-2008 Kayako Infotech Ltd.
// Unauthorized reproduction is not allowed
// License Number: $%LICENSE%$
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//                   www.kayako.com
//###################################
//=======================================

define("SWIFT_AREA", 20);

if (defined("SWIFTCUSTOMPATH"))
{
	chdir(SWIFTCUSTOMPATH);
} else {
	chdir('./../');
}
require_once ("./swift.php");

/**
* ###############################################
* BEGIN IP RESTRICTION CHECK
* ###############################################
*/
if (_is_array($_SWIFT['iprestrict']))
{
	// Seems like we have IPs specified.. by default deny all requests
	$_continue = false;
	foreach ($_SWIFT['iprestrict'] as $key=>$val)
	{
		if (netMatch($val, $_SERVER['REMOTE_ADDR']))
		{
			$_continue = true;
		}
	}

	if (!$_continue)
	{
		trigger_error(sprintf($_SWIFT['language']['iprestrictdenial'], 'staff', $_SERVER['REMOTE_ADDR']), E_USER_ERROR);
		exit;
	}
}
/**
* ###############################################
* END IP RESTRICTION CHECK
* ###############################################
*/

if ($_REQUEST["_ca"] == "css")
{
	header("Content-Type: text/css");
	headerCache();

	echo $template->displayTemplate("css.tpl");
	exit;

// ======= ADDED IN V3.00.80 =======
} else if ($_REQUEST["_ca"] == "rebuildcache") {

	if (isset($_REQUEST["verbose"]))
		echo "Clearing cache directory...<BR>";
	
	// Empty Cache Directory
	if ($handle = opendir('./cache/'))
	{
		while (false !== ($file = readdir($handle)))
		{ 
			if ($file != "." && $file != ".." && $file != "index.html")
			{
				if (isset($_REQUEST["verbose"]))
					echo "Deleting file './cache/" . $file . "'...<BR>";
				
				if (!unlink("./cache/".$file))
				{
					if (isset($_REQUEST["verbose"]))
						echo "ERROR: Failed to delete file './cache/" . $file . "'!<BR>";
				}
			}
		}

		closedir($handle); 
	}
	else
	{
		if (isset($_REQUEST["verbose"]))
			echo "ERROR: Failed to open the ./cache/ directory!<BR>";
	}
	
	if (isset($_REQUEST["verbose"]))	
		echo "Done.<BR>Building all core caches...<BR>";
	
	require_once ("./includes/functions_settings.php");
	require_once ("./includes/functions_template.php");
	require_once ("./includes/functions_language.php");
	require_once ("./includes/functions_users.php");
	require_once ("./includes/functions_staff.php");

	rebuildSettingsCache();
	rebuildPhraseCache(1);
	rebuildLanguageCache();
	rebuildTemplateGroupCache();
	rebuildUserGroupPermissions();
	rebuildStaffGroupPermissions();
	rebuildGroupSettingsCache();
	rebuildUserGroupSettingsCache();
	rebuildTemplateGroupAssignCache();	

	if (isset($_REQUEST["verbose"]))	
		echo "Done.<BR>Building javascript caches...<BR>";

    require_once("./includes/functions_jscache.php");
    require_once("./modules/downloads/functions_downloads.php");
    rebuildDownloadJSCache();

    require_once("./modules/knowledgebase/functions_knowledgebase.php");
    rebuildKnowledgebaseJSCache();
    
	global $module;
	
	if ($module->IsRegistered(MODULE_TICKETS))
	{
		require_once("./modules/tickets/functions_predefined.php");
		rebuildPredefinedJSCache();
	}
	
	if (isset($_REQUEST["verbose"]))
		echo "Done.<BR>Cache rebuild is complete!<BR>";

} else if ($_REQUEST["_ca"] == "login") {
	/*
	* #########################################################
	* Authenticate User, Insert session and redirect else just display login form
	* #########################################################
	*/
	// Remember Password available?
	if (!empty($_POST["cookiepassword"]) && $_POST["password"] == "******")
	{
		// Try to use cookie password
		$staffid = $staffauth->authenticate($_POST["username"], $_POST["cookiepassword"], false, false);
	} else {
		$staffid = $staffauth->authenticate($_POST["username"], $_POST["password"], false);
	}

	if (!empty($staffid))
	{
		require_once ("./includes/functions_html.php");

		// Authentication successfull, Generate a sessionid for this user
		$session->insertSession(SESSION_STAFF, $staffid);

		// We always empty the remember cookie if username differs
		$_cookieusername = $cookie->getSCookie("remusername");
		if ($_POST["username"] != $_cookieusername && !empty($_cookieusername))
		{
			$cookie->emptySCookie("remusername");
			$cookie->emptySCookie("rempassword");
		}

		if ($_POST["remember"] == 1 && $_POST["password"] != "******")
		{
			$cookie->setSCookie("remusername", $_POST["username"], true);
			$cookie->setSCookie("rempassword", md5($_POST["password"]), true);
		} else if ($_POST["remember"] == 1 && $_POST["password"] == "******") {
			// Do Nothing
		} else {
			$cookie->emptySCookie("remusername");
			$cookie->emptySCookie("rempassword");
		}

		if (!empty($_POST["querystring"]))
		{
			printRedirect($_SWIFT["language"]["redirect_login"], "index.php?".htmlspecialchars($_POST["querystring"]), true);
		} else {
			printRedirect($_SWIFT["language"]["redirect_login"], "index.php?_m=core&_a=dashboard", true);
		}

	} else {
		$cookie->emptySCookie("remusername");
		$cookie->emptySCookie("rempassword");

		$staffauth->displayLoginForm($_SWIFT["errorstr"]);
	}
} else if ($_REQUEST["_ca"] == "logout") {
	$session->logoutSession(SESSION_STAFF);
	$cookie->emptyCookie("staffsettings");

	$staffauth->displayLoginForm($_SWIFT["language"]["loggedout"]);
} else {
	if (!$session->start(SESSION_STAFF)) {
		/*
		* #########################################################
		* No other action, we always try to start a session
		* #########################################################
		*/
		// Failed to load session
		$staffauth->displayLoginForm($_SWIFT["errorstr"]);
		exit;
	}

	$cookie->parseCookie("staffsettings");

	if ($_SWIFT["staff"]["pmunread"] > 0 && $_GET["popupshow"] != 1 && $cookie->getKey("staffsettings", "prvpopup") != 1 && $_SWIFT["staff"]["enablepmjsalerts"] == 1)
	{
		$cookie->addCookie("staffsettings", "prvpopup", "1");
		$cookie->buildCookie("staffsettings", true);

		$template->assign("prvmsgshow", true);
	}

	// User logged in, trigger events
	if (!$events->triggerEvent(EVENT_STAFF))
	{
		require_once ("./includes/functions_html.php");
		printRedirect($_SWIFT["language"]["redirect_dashboard"], "index.php?_m=core&_a=dashboard", true);
	}
}

$_SWIFT["endtime"] = fetchmicrotime();

//$dbCore->debugOutput();
//echo "Total Time Taken: ".($_SWIFT["endtime"]-$_SWIFT["starttime"]) ." seconds";
?>