<?php
//=======================================
//###################################
// Kayako Infotech Ltd. - SWIFT Framework
//
// Source Copyright 2001-2008 Kayako Infotech Ltd.
// Unauthorized reproduction is not allowed
// License Number: $%LICENSE%$
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//                   www.kayako.com
//###################################
//=======================================

define("SWIFT_AREA", 50);

if (defined("SWIFTCUSTOMPATH"))
{
	chdir(SWIFTCUSTOMPATH);
} else {
	chdir('./../');
}
require_once ("./swift.php");
/**
* ###############################################
* BEGIN IP RESTRICTION CHECK
* ###############################################
*/
if (_is_array($_SWIFT['iprestrict']))
{
	// Seems like we have IPs specified.. by default deny all requests
	$_continue = false;
	foreach ($_SWIFT['iprestrict'] as $key=>$val)
	{
		if (netMatch($val, $_SERVER['REMOTE_ADDR']))
		{
			$_continue = true;
		}
	}

	if (!$_continue)
	{
		trigger_error(sprintf($_SWIFT['language']['iprestrictdenial'], 'winapp', $_SERVER['REMOTE_ADDR']), E_USER_ERROR);
		exit;
	}
}
/**
* ###############################################
* END IP RESTRICTION CHECK
* ###############################################
*/

if ($_REQUEST["_ca"] == "login") {
	$staffid = $staffauth->authenticate(urldecode($_REQUEST["username"]), strtolower($_REQUEST["password"]), false, false);
	if (!empty($staffid))
	{
		require_once ("./includes/functions_xml.php");
		$xml = new XML;

		$session->insertSession(SESSION_WINAPP, $staffid);

		$xml->addParentTag("swiftwinapp");
		$xml->addTag("sessionid", $_SWIFT["session"]["sessionid"]);
		
		// Hardcoded module event callback, will just return false if module isnt there or isnt registered
		$events->triggerCallback("livesupport", "winappLogin");
	
		$xml->addTag("producturl", $_SWIFT["settings"]["general_producturl"]);
		$xml->addTag("uniqueid", $_SWIFT["uniqueid"]);
		$xml->endTag("swiftwinapp");
		$xml->echoXMLUTFWinapp();

		require_once ("./includes/functions_cron.php");
		$cron = new Cron;

		$cron->runPendingTasks();

} else {
		// Authentication Failed
		echoWinappData("-2");
	}
} else if ($_REQUEST["_ca"] == "logout") {
	if (!$session->start(SESSION_WINAPP)) {
		// Session expired
		echoWinappData("-1");
		exit;
	}		

	$events->triggerCallback("livesupport", "winappLogout");

	$session->logoutSession(SESSION_WINAPP);
	echoWinappData("1");
} else {
	if (!$session->start(SESSION_WINAPP)) {
		// Session expired
		echoWinappData("-1");
		exit;
	}		

	$events->triggerEvent(EVENT_WINAPP);
}
?>